2007-10-14  Eric Seidel  <eric@webkit.org>

        Reviewed by aroben.

        Remove senseless malloc from paintOutline
        No tests needed, no functional change.

        * rendering/RenderFlow.cpp:
        (WebCore::RenderFlow::paintOutline): remove unneeded malloc

2007-10-13  Eric Seidel  <eric@webkit.org>

        Reviewed by Mark Rowe.

        Fix SVGSVGElement::currentView() to not leak by using an OwnPtr.
        This fix is incompatible with changes eventually needed for supporting
        SVGSVGElement.currentView in the bindings (that needs a ref'd object)
        There are also several parser crashers in SVGViewSpec, but those will be fixed
        in my next patch.
        
        Leak fix only, no additional tests needed.

        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::currentView): call .get() and .set()
        * ksvg2/svg/SVGSVGElement.h: use OwnPtr

2007-10-13  Oliver Hunt  <oliver@apple.com>

        Reviewed by Maciej.

        Fixing a few testcases by enabling SVG_EXPERIMENTAL on windows, and making the
        required fixes and corrections.

        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.vcproj/build-generated-files.sh:
        * bindings/scripts/CodeGeneratorJS.pm:
        * ksvg2/scripts/make_names.pl:
        * ksvg2/svg/SVGColor.cpp:
        (WebCore::SVGColor::colorFromRGBColorString):
        * page/DOMWindow.idl:
        * platform/graphics/svg/cg/SVGResourceFilterCg.cpp:
        * platform/win/WebCoreTextRenderer.cpp:

2007-10-12  Darin Adler  <darin@apple.com>

        Reviewed by Sam.

        - more float/int conversion (to try to get the old builbot up)

        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::layout): Cast to int.
        (WebCore::RenderSVGRoot::applyContentTransforms): Ditto.
        (WebCore::RenderSVGRoot::nodeAtPoint): Ditto.

2007-10-12  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Harrison.
        
        <rdar://problem/5483370> GoogleDocs: Deleting cell text in a table row also removes any empty rows beneath the row being edited
        <rdar://problem/5482524> GoogleDocs: A hang occurs when applying list to selected table
        
        * editing/DeleteSelectionCommand.cpp:
        (WebCore::DeleteSelectionCommand::removePreviouslySelectedEmptyTableRows):
        * editing/InsertListCommand.cpp:
        (WebCore::InsertListCommand::modifyRange):
        (WebCore::InsertListCommand::doApply):

2007-10-12  Darin Adler  <darin@apple.com>

        - fix another float/int conversion

        * platform/graphics/svg/cg/SVGResourceMaskerCg.mm:
        (WebCore::SVGResourceMasker::applyMask): Explicitly cast to int.

2007-10-12  Darin Adler  <darin@apple.com>

        Reviewed by Oliver Hunt.

        - fix float/int conversions that cause warnings on older versions
          of gcc (like the version currently being used on the PowerPC
          buildbot slave)

        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::paint): Explicitly cast to int.
        (WebCore::RenderPath::addFocusRingRects): Use enclosingIntRect
        to convert a FloatRect to an IntRect.
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBoxPaintWalker::chunkPortionCallback):
        Use 0 for the initial value of an int, rather than 0.0f.
        (WebCore::svgTextStyleForInlineTextBox): Explicitly cast to int.
        (WebCore::applyTextAnchorToTextChunk): Ditto.

2007-10-12  Oliver Hunt  <oliver@apple.com>

        Reviewed by Mark.

        Cast zoom factor to int as the original patch did.  This is necessary to appease some versions of gcc.

        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::setCurrentScale):

2007-10-12  Eric Seidel  <eric@webkit.org>

        Reviewed by Mark Rowe.

        Fix leaks in SVG code from feature-branch.

        * ksvg2/svg/SVGFEDiffuseLightingElement.cpp:
        (WebCore::SVGFEDiffuseLightingElement::filterEffect):
        * ksvg2/svg/SVGFEFloodElement.cpp:
        (WebCore::SVGFEFloodElement::filterEffect):
        * ksvg2/svg/SVGFESpecularLightingElement.cpp:
        (WebCore::SVGFESpecularLightingElement::filterEffect):
        * ksvg2/svg/SVGGradientElement.cpp:
        (WebCore::SVGGradientElement::buildStops):
        * ksvg2/svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::resolveStyle): always refs style
        * platform/graphics/cg/ImageBufferCG.cpp:
        (WebCore::ImageBuffer::create): fastFree buffer if CG Context creation fails

2007-10-12  Mark Rowe  <mrowe@apple.com>

        Windows, Gtk and Qt build fixes.  Add new files to projects.

        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:

=== Start merge of feature-branch 2007-10-12 ===

2007-10-11  Oliver Hunt  <oliver@apple.com>

        Reviewed by Sam.

        Bug 15469: feature branch has 100's of implicit double -> float conversions

        Re-enable -Wshorten-64-to-32, and make required code changes to make us build sanely again.
        
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSSVGMatrixCustom.cpp:
        (WebCore::JSSVGMatrix::translate):
        (WebCore::JSSVGMatrix::scale):
        (WebCore::JSSVGMatrix::scaleNonUniform):
        (WebCore::JSSVGMatrix::rotate):
        (WebCore::JSSVGMatrix::skewX):
        (WebCore::JSSVGMatrix::skewY):
        * bindings/scripts/CodeGeneratorJS.pm:
        * bindings/scripts/CodeGeneratorObjC.pm:
        * ksvg2/css/SVGRenderStyle.cpp:
        (WebCore::SVGRenderStyle::cssPrimitiveToLength):
        * ksvg2/css/SVGRenderStyle.h:
        * ksvg2/svg/SVGAnimateMotionElement.cpp:
        (WebCore::SVGAnimateMotionElement::parseMappedAttribute):
        (WebCore::SVGAnimateMotionElement::updateAnimatedValue):
        (WebCore::parsePoint):
        (WebCore::SVGAnimateMotionElement::calculateFromAndToValues):
        * ksvg2/svg/SVGAnimationElement.cpp:
        (WebCore::SVGAnimationElement::parseKeyNumbers):
        (WebCore::parseKeySplines):
        * ksvg2/svg/SVGComponentTransferFunctionElement.cpp:
        (WebCore::SVGComponentTransferFunctionElement::SVGComponentTransferFunctionElement):
        (WebCore::SVGComponentTransferFunctionElement::parseMappedAttribute):
        * ksvg2/svg/SVGFECompositeElement.cpp:
        (WebCore::SVGFECompositeElement::SVGFECompositeElement):
        (WebCore::SVGFECompositeElement::parseMappedAttribute):
        * ksvg2/svg/SVGFEDiffuseLightingElement.cpp:
        (WebCore::SVGFEDiffuseLightingElement::SVGFEDiffuseLightingElement):
        (WebCore::SVGFEDiffuseLightingElement::parseMappedAttribute):
        * ksvg2/svg/SVGFEDisplacementMapElement.cpp:
        (WebCore::SVGFEDisplacementMapElement::SVGFEDisplacementMapElement):
        (WebCore::SVGFEDisplacementMapElement::parseMappedAttribute):
        * ksvg2/svg/SVGFEGaussianBlurElement.cpp:
        (WebCore::SVGFEGaussianBlurElement::SVGFEGaussianBlurElement):
        (WebCore::SVGFEGaussianBlurElement::parseMappedAttribute):
        * ksvg2/svg/SVGFELightElement.cpp:
        (WebCore::SVGFELightElement::SVGFELightElement):
        (WebCore::SVGFELightElement::parseMappedAttribute):
        * ksvg2/svg/SVGFEOffsetElement.cpp:
        (WebCore::SVGFEOffsetElement::SVGFEOffsetElement):
        (WebCore::SVGFEOffsetElement::parseMappedAttribute):
        * ksvg2/svg/SVGFESpecularLightingElement.cpp:
        (WebCore::SVGFESpecularLightingElement::SVGFESpecularLightingElement):
        (WebCore::SVGFESpecularLightingElement::parseMappedAttribute):
        * ksvg2/svg/SVGFETurbulenceElement.cpp:
        (WebCore::SVGFETurbulenceElement::SVGFETurbulenceElement):
        (WebCore::SVGFETurbulenceElement::parseMappedAttribute):
        * ksvg2/svg/SVGFitToViewBox.cpp:
        (WebCore::SVGFitToViewBox::parseMappedAttribute):
        * ksvg2/svg/SVGFitToViewBox.h:
        * ksvg2/svg/SVGLength.cpp:
        (WebCore::SVGLength::setValueAsString):
        (WebCore::SVGLength::PercentageOfViewport):
        * ksvg2/svg/SVGNumber.idl:
        * ksvg2/svg/SVGNumberList.cpp:
        (WebCore::SVGNumberList::parse):
        * ksvg2/svg/SVGNumberList.h:
        * ksvg2/svg/SVGParserUtilities.cpp:
        (WebCore::_parseNumber):
        (WebCore::parseNumber):
        (WebCore::pointsListFromSVGData):
        (WebCore::PathBuilder::svgMoveTo):
        (WebCore::PathBuilder::svgLineTo):
        (WebCore::PathBuilder::svgCurveToCubic):
        (WebCore::SVGPathSegListBuilder::svgMoveTo):
        (WebCore::SVGPathSegListBuilder::svgLineTo):
        (WebCore::SVGPathSegListBuilder::svgLineToHorizontal):
        (WebCore::SVGPathSegListBuilder::svgLineToVertical):
        (WebCore::SVGPathSegListBuilder::svgCurveToCubic):
        (WebCore::SVGPathSegListBuilder::svgCurveToCubicSmooth):
        (WebCore::SVGPathSegListBuilder::svgCurveToQuadratic):
        (WebCore::SVGPathSegListBuilder::svgCurveToQuadraticSmooth):
        (WebCore::SVGPathSegListBuilder::svgArcTo):
        * ksvg2/svg/SVGParserUtilities.h:
        * ksvg2/svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::SVGPathElement):
        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::pixelUnitToMillimeterX):
        (WebCore::SVGSVGElement::pixelUnitToMillimeterY):
        * ksvg2/svg/SVGSVGElement.h:
        * ksvg2/svg/SVGTransformDistance.cpp:
        (WebCore::SVGTransformDistance::addToSVGTransform):
        (WebCore::SVGTransformDistance::distance):
        * ksvg2/svg/SVGTransformDistance.h:
        * ksvg2/svg/SVGTransformable.cpp:
        (WebCore::SVGTransformable::parseTransformValue):
        * ksvg2/svg/SVGViewSpec.cpp:
        (WebCore::SVGViewSpec::parseViewSpec):
        * platform/graphics/svg/SVGResourceFilter.cpp:
        (WebCore::SVGResourceFilter::filterBBoxForItemBBox):
        * platform/graphics/svg/cg/CgSupport.cpp:
        (WebCore::applyStrokeStyleToContext):
        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        (WebCore::SVGPaintServerPattern::setup):
        * platform/graphics/svg/cg/SVGResourceFilterCg.mm:
        (WebCore::SVGResourceFilter::applyFilter):
        * platform/graphics/svg/filters/SVGFEComponentTransfer.h:
        (WebCore::SVGComponentTransferFunction::SVGComponentTransferFunction):
        * platform/graphics/svg/filters/SVGFEComposite.cpp:
        (WebCore::SVGFEComposite::SVGFEComposite):
        * platform/graphics/svg/filters/SVGFEConvolveMatrix.cpp:
        (WebCore::SVGFEConvolveMatrix::SVGFEConvolveMatrix):
        * platform/graphics/svg/filters/SVGFEDiffuseLighting.cpp:
        (WebCore::SVGFEDiffuseLighting::SVGFEDiffuseLighting):
        * platform/graphics/svg/filters/SVGFEFlood.cpp:
        (WebCore::SVGFEFlood::SVGFEFlood):
        * platform/graphics/svg/filters/SVGFEGaussianBlur.cpp:
        (WebCore::SVGFEGaussianBlur::SVGFEGaussianBlur):
        * platform/graphics/svg/filters/SVGFEMorphology.cpp:
        (WebCore::SVGFEMorphology::SVGFEMorphology):
        * platform/graphics/svg/filters/SVGFEOffset.cpp:
        (WebCore::SVGFEOffset::SVGFEOffset):
        * platform/graphics/svg/filters/SVGFESpecularLighting.cpp:
        (WebCore::SVGFESpecularLighting::SVGFESpecularLighting):
        * platform/graphics/svg/filters/SVGFETurbulence.cpp:
        (WebCore::SVGFETurbulence::SVGFETurbulence):
        * platform/graphics/svg/filters/cg/SVGFEColorMatrixCg.mm:
        (WebCore::SVGFEColorMatrix::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEHelpersCg.mm:
        (WebCore::getVectorForChannel):
        (WebCore::getLightVectors):
        * platform/graphics/svg/filters/cg/SVGFEImageCg.mm:
        (WebCore::SVGFEImage::getCIFilter):
        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::drawMarkersIfNeeded):
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::paint):
        * rendering/RenderSVGInlineText.cpp:
        (WebCore::RenderSVGInlineText::computeAbsoluteRectForRange):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::applyContentTransforms):
        (WebCore::RenderSVGRoot::calcViewport):
        (WebCore::RenderSVGRoot::nodeAtPoint):
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::absoluteRects):
        (WebCore::RenderSVGText::relativeBBox):
        * rendering/RenderSVGTextPath.cpp:
        * rendering/SVGCharacterLayoutInfo.cpp:
        (WebCore::calculateBaselineShift):
        (WebCore::SVGCharacterLayoutInfo::SVGCharacterLayoutInfo):
        (WebCore::SVGCharacterLayoutInfo::processedChunk):
        (WebCore::SVGCharacterLayoutInfo::nextPathLayoutPointAndAngle):
        (WebCore::SVGCharacterLayoutInfo::addLayoutInformation):
        * rendering/SVGCharacterLayoutInfo.h:
        * rendering/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::calculateGlyphBoundaries):
        (WebCore::SVGInlineTextBoxClosestCharacterToPositionWalker::chunkPortionCallback):
        (WebCore::pathForDecoration):
        * rendering/SVGRenderTreeAsText.cpp:
        (WebCore::writeStyle):
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBoxPaintWalker::chunkPortionCallback):
        (WebCore::applyTextAnchorToTextChunk):
        (WebCore::SVGRootInlineBox::buildLayoutInformation):
        (WebCore::SVGRootInlineBox::buildLayoutInformationForTextBox):

2007-10-11  Andrew Wellington  <proton@wiretapped.net>

        Reviewed by Eric Seidel.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=15076
        "deg2rad has multiple definitions"
        
        Use deg2rad, rad2deg, deg2grad, grad2deg, rad2grad, grad2rad
        from wtf where appropriate.
        
        No test cases as this doesn't change behaviour.
        
        Change based on original patch by Rob Buis.

        * ksvg2/svg/SVGAngle.cpp:
        (WebCore::SVGAngle::calculate):
        (WebCore::SVGAngle::convertToSpecifiedUnits):
        (WebCore::SVGAngle::todeg):
        (WebCore::SVGAngle::torad):
        * platform/graphics/AffineTransform.cpp:
        (WebCore::AffineTransform::rotateFromVector):
        (WebCore::AffineTransform::skewX):
        (WebCore::AffineTransform::skewY):
        * platform/graphics/cg/AffineTransformCG.cpp:
        (WebCore::AffineTransform::rotate):
        * platform/graphics/svg/filters/cg/SVGFEColorMatrixCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEHelpersCg.h:
        * platform/graphics/svg/filters/cg/SVGFEHelpersCg.mm:
        * rendering/RenderPath.cpp:
        (WebCore::drawMarkerWithData):

2007-10-11  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=6421 (<text> textLength attribute is not respected)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=6422 (<text> lengthAdjust attribute is not respected)

        Implement textLength and full lengthAdjust (both 'spacing' & 'spacingAndGlyphs' mode)
        for <text> & <tspan> & friends. <textPath> is still todo, as it's special.

        Also fix usage of cummulatedGlyphWidth/Height in SVGInlineTextBox, calculateGlyphBoundaries was
        supposed to be used in the distance calculations, to take per character transformations into account (ie. rotation).

        Fixes: svg/W3C-SVG-1.1/text-text-01-b.svg (complelty fixed the single W3C textLength testcase)
        Partly fixed: svg/batik/text/textOnPathSpaces.svg (kerning support missing)
        Partly fixed: svg/batik/text/textLayout.svg (word-letter spacing & textLength is todo)

        * ksvg2/svg/SVGTextContentElement.cpp:
        (WebCore::SVGTextContentElement::SVGTextContentElement):
        (WebCore::SVGTextContentElement::parseMappedAttribute):
        * rendering/SVGCharacterLayoutInfo.cpp:
        (WebCore::SVGCharacterLayoutInfo::nextPathLayoutPointAndAngle):
        * rendering/SVGCharacterLayoutInfo.h:
        (WebCore::SVGTextChunk::SVGTextChunk):
        (WebCore::SVGTextChunkWalker::operator()):
        * rendering/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBoxClosestCharacterToPositionWalker::chunkPortionCallback):
        (WebCore::SVGInlineTextBoxSelectionRectWalker::chunkPortionCallback):
        (WebCore::SVGInlineTextBox::svgCharacterHitsPosition):
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBoxPaintWalker::chunkPortionCallback):
        (WebCore::cummulatedWidthOrHeightOfTextChunk):
        (WebCore::cummulatedWidthOfTextChunk):
        (WebCore::cummulatedHeightOfTextChunk):
        (WebCore::applyTextAnchorToTextChunk):
        (WebCore::applyTextLengthCorrectionToTextChunk):
        (WebCore::SVGRootInlineBox::buildLayoutInformationForTextBox):
        (WebCore::SVGRootInlineBox::buildTextChunks):
        (WebCore::SVGRootInlineBox::layoutTextChunks):
        (WebCore::SVGRootInlineBox::walkTextChunks):

2007-10-11  Oliver Hunt  <oliver@apple.com>

        Reviewed by Niko.

        Fix for Bug 15468: Parsing of numbers and lists is too lenient in SVG

        Correct parsing of numbers, number lists, and length lists in SVG.

        * ksvg2/svg/SVGLength.cpp:
        (WebCore::SVGLength::setValueAsString):
        * ksvg2/svg/SVGLength.h:
        * ksvg2/svg/SVGLengthList.cpp:
        (WebCore::SVGLengthList::parse):
        * ksvg2/svg/SVGParserUtilities.cpp:
        (WebCore::parseNumber):

2007-10-11  Allan Sandfeld Jensen  <sandfeld@kde.org>
 
         Reviewed by Maciej and Eric.
 
         Implement CSS selector combinators nondeterministic matching. 
         Fixes http://bugs.webkit.org/show_bug.cgi?id=3428
 
         * css/CSSStyleSelector.cpp:
         (WebCore::CSSStyleSelector::matchRulesForList):
         (WebCore::CSSStyleSelector::checkSelector): Split the function and make the second part recursive
         (WebCore::CSSStyleSelector::checkOneSelector): Handle pseodo-elements rules and hoveractive quirks 
         here instead of in checkSelector.
         * css/CSSStyleSelector.h:
 
2007-10-10  Eric Seidel  <eric@webkit.org>

        Reviewed by Nikolas Zimmermann.
        
        Fix the SVG dom so that rect.x.baseVal = rect.x.baseVal like it should.
        http://bugs.webkit.org/show_bug.cgi?id=14150

        Test: svg/dom/animated-tearoff-equlity.xhtml

        * ksvg2/svg/SVGAnimatedTemplate.h:
        (WebCore::SVGAnimatedTypeWrapperKey::SVGAnimatedTypeWrapperKey):
        (WebCore::SVGAnimatedTypeWrapperKey::operator==):
        (WebCore::SVGAnimatedTypeWrapperKeyHash::hash):
        (WebCore::SVGAnimatedTypeWrapperKeyHash::equal):
        (WebCore::SVGAnimatedTypeWrapperKeyHashTraits::deletedValue):
        (WebCore::SVGAnimatedTypeWrapperKeyHashTraits::emptyValue):
        (WebCore::SVGAnimatedTemplate::~SVGAnimatedTemplate):
        (WebCore::SVGAnimatedTemplate::wrapperCache):
        (WebCore::SVGAnimatedTemplate::forgetWrapper):
        (WebCore::lookupOrCreateWrapper):
        * ksvg2/svg/SVGElement.h:

2007-10-10  Oliver Hunt  <oliver@apple.com>

        Reviewed by Maciej.

        Leopard build fix -- SVGDocument should not trty to make read/write properties read-only

        Remove those API definitions SVGDocument now inherits from Document

        * ksvg2/svg/SVGDocument.idl:

2007-10-10  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver.

        Make renderers pull localTransform instead of depending on DOM elements to push
        This allows for cleaner invalidation code, and makes writing animation easier.
        Also fixed a tiny bug in SVGRenderImage focus ring calculations while there
        
        Updated test results for svg/custom/focus-ring.svg

        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/svg/SVGAElement.cpp:
        (WebCore::SVGAElement::createRenderer):
        * ksvg2/svg/SVGAnimateMotionElement.cpp:
        (WebCore::SVGAnimateMotionElement::applyAnimatedValueToElement):
        * ksvg2/svg/SVGAnimateTransformElement.cpp:
        (WebCore::SVGAnimateTransformElement::applyAnimatedValueToElement):
        * ksvg2/svg/SVGClipPathElement.cpp:
        (WebCore::SVGClipPathElement::canvasResource):
        * ksvg2/svg/SVGElement.h:
        * ksvg2/svg/SVGGElement.cpp:
        (WebCore::SVGGElement::createRenderer):
        * ksvg2/svg/SVGImageElement.cpp:
        * ksvg2/svg/SVGLocatable.cpp:
        (WebCore::SVGLocatable::getCTM):
        (WebCore::SVGLocatable::getScreenCTM):
        * ksvg2/svg/SVGMarkerElement.cpp:
        (WebCore::SVGMarkerElement::canvasResource):
        (WebCore::SVGMarkerElement::notifyAttributeChange):
        * ksvg2/svg/SVGSVGElement.h:
        * ksvg2/svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::rendererIsNeeded):
        (WebCore::SVGStyledElement::notifyResourceParentIfExistant):
        * ksvg2/svg/SVGStyledElement.h:
        (WebCore::SVGStyledElement::style):
        * ksvg2/svg/SVGStyledTransformableElement.cpp:
        (WebCore::SVGStyledTransformableElement::animatedLocalTransform):
        (WebCore::SVGStyledTransformableElement::parseMappedAttribute):
        (WebCore::SVGStyledTransformableElement::notifyAttributeChange):
        (WebCore::SVGStyledTransformableElement::createRenderer):
        * ksvg2/svg/SVGStyledTransformableElement.h:
        (WebCore::SVGStyledTransformableElement::toPathData):
        * ksvg2/svg/SVGSwitchElement.cpp:
        (WebCore::SVGSwitchElement::createRenderer):
        * ksvg2/svg/SVGTRefElement.cpp:
        (WebCore::SVGTRefElement::updateReferencedText):
        * ksvg2/svg/SVGTextElement.cpp:
        (WebCore::SVGTextElement::parseMappedAttribute):
        (WebCore::SVGTextElement::animatedLocalTransform):
        * ksvg2/svg/SVGTextElement.h:
        * ksvg2/svg/SVGTextPathElement.cpp:
        * ksvg2/svg/SVGTextPathElement.h:
        * ksvg2/svg/SVGTransformable.cpp:
        (WebCore::SVGTransformable::getCTM):
        (WebCore::SVGTransformable::getScreenCTM):
        * ksvg2/svg/SVGTransformable.h:
        * ksvg2/svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::createRenderer):
        (WebCore::SVGUseElement::attachShadowTree):
        * platform/graphics/AffineTransform.h:
        (WebCore::AffineTransform::operator!=):
        * platform/graphics/svg/SVGResourceMarker.cpp:
        (WebCore::SVGResourceMarker::setMarker):
        * platform/graphics/svg/SVGResourceMarker.h:
        * rendering/RenderForeignObject.cpp:
        (WebCore::RenderForeignObject::calculateLocalTransform):
        (WebCore::RenderForeignObject::layout):
        * rendering/RenderForeignObject.h:
        (WebCore::RenderForeignObject::localTransform):
        * rendering/RenderObject.cpp:
        * rendering/RenderObject.h:
        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::RenderPath):
        (WebCore::RenderPath::localTransform):
        (WebCore::RenderPath::calculateLocalTransform):
        (WebCore::RenderPath::layout):
        * rendering/RenderPath.h:
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::localTransform):
        (WebCore::RenderSVGContainer::calculateLocalTransform):
        (WebCore::RenderSVGContainer::layout):
        * rendering/RenderSVGContainer.h:
        * rendering/RenderSVGImage.h:
        (WebCore::RenderSVGImage::localTransform):
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::calculateLocalTransform):
        (WebCore::RenderSVGText::layout):
        * rendering/RenderSVGText.h:
        (WebCore::RenderSVGText::isSVGText):
        (WebCore::RenderSVGText::localTransform):
        * rendering/RenderSVGTextPath.cpp:
        (WebCore::RenderSVGTextPath::layoutPath):
        (WebCore::RenderSVGTextPath::startOffset):
        (WebCore::RenderSVGTextPath::exactAlignment):
        (WebCore::RenderSVGTextPath::stretchMethod):
        * rendering/RenderSVGTextPath.h:
        * rendering/RenderSVGTransformableContainer.cpp: Added.
        (WebCore::RenderSVGTransformableContainer::RenderSVGTransformableContainer):
        (WebCore::RenderSVGTransformableContainer::calculateLocalTransform):
        * rendering/RenderSVGTransformableContainer.h: Added.
        * rendering/RenderSVGViewportContainer.h:

2007-10-10  Oliver Hunt  <oliver@apple.com>

        Reviewed by Eric.

        Bug 15451: SVGStyledElement must unregister itself from Resources on detach
        
        Use a global hashtable to maintain the relationship between the
        various SVG resources and their clients, across dom updates, etc.

        * ksvg2/svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::detach):
        * ksvg2/svg/SVGStyledElement.h:
        * platform/graphics/svg/SVGPaintServer.h:
        * platform/graphics/svg/SVGResource.cpp:
        (WebCore::ResourceSet::ResourceSet):
        (WebCore::clientMap):
        (WebCore::SVGResource::~SVGResource):
        (WebCore::SVGResource::invalidate):
        (WebCore::SVGResource::removeClient):
        (WebCore::SVGResource::addClient):
        * platform/graphics/svg/SVGResource.h:
        (WebCore::):
        (WebCore::SVGResource::isPaintServer):
        (WebCore::SVGResource::isFilter):
        (WebCore::SVGResource::isClipper):
        (WebCore::SVGResource::isMarker):
        (WebCore::SVGResource::isMasker):
        * platform/graphics/svg/SVGResourceClipper.h:
        (WebCore::SVGResourceClipper::resourceType):
        * platform/graphics/svg/SVGResourceFilter.h:
        * platform/graphics/svg/SVGResourceMarker.h:
        * platform/graphics/svg/SVGResourceMasker.h:

2007-10-10  Mark Rowe  <mrowe@apple.com>

        Windows build fix after r26109.

        * WebCore.vcproj/WebCore.vcproj:

2007-10-10  Oliver Hunt  <oliver@apple.com>

        Reviewed by Eric.

        Fix Bug 15433: Filters do not repaint when base resources change/update

        SVGFEImage now actually responds to image updates, and triggers a repaint.

        * platform/graphics/svg/SVGResource.h:
        * platform/graphics/svg/filters/SVGFEImage.cpp:
        (WebCore::SVGFEImage::setCachedImage):
          Don't re-set the image lest we want to trigger infinite recursion.
        (WebCore::SVGFEImage::imageChanged):
          Image change means we need to tell our clients to repaint
        * platform/graphics/svg/filters/SVGFEImage.h:
        * rendering/SVGRenderSupport.cpp:
        (WebCore::prepareToRenderSVGContent):
          make sure that users of filters are registered.

2007-10-09  Eric Seidel  <eric@webkit.org>

        Reviewed by Alp.

        Track changes in r26109 to fix the Gtk+ build.

        * WebCore.pro:

2007-10-09  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Anders.

        http://bugs.webkit.org/show_bug.cgi?id=15436
        Wrong node order for XPath reverse axes

        Test: fast/xpath/reverse-axes.html

        * xml/XPathStep.cpp:
        (WebCore::XPath::Step::nodesInAxis): Do not prematurely sort reverse
        axes. Generate preceding axis nodes in reversed document order.

2007-10-09  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Mitz.

        http://bugs.webkit.org/show_bug.cgi?id=15437
        XPath substring-after function is broken

        Test: fast/xpath/substring-after.html

        * xml/XPathFunctions.cpp:
        (WebCore::XPath::FunSubstringAfter::evaluate): Fix it for real this time, hopefully.

2007-10-09  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=15080
        <use> element not refresh after adding objects by script in referrer

        Update shadow tree when elements are added/removed from a tree
        that is referenced by a <use>.

        * ksvg2/svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::childrenChanged):
        * ksvg2/svg/SVGStyledElement.h:

2007-10-09  Rob Buis  <buis@kde.org>

        Reviewed by Maciej.

        http://bugs.webkit.org/show_bug.cgi?id=15088
        HTMLOptionElement.selected returns false when parent HTMLSelectElement is "display: none" until parent's .selectedIndex is accessed

        Make sure the list items are up to date when there is no renderer.

        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::recalcStyle):

2007-10-08  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver.

        Build fix.  Fix circular build rule for CSS*.in files evident on clean build.

        * DerivedSources.make:
        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/css/CSSPropertyNames.in: Removed.
        * ksvg2/css/CSSValueKeywords.in: Removed.
        * ksvg2/css/SVGCSSPropertyNames.in: Copied from ksvg2/css/CSSPropertyNames.in.
        * ksvg2/css/SVGCSSValueKeywords.in: Copied from ksvg2/css/CSSValueKeywords.in.

2007-10-08  Eric Seidel  <eric@webkit.org>

        Reviewed by hyatt.

        Implement getComputedStyle support for SVG CSS values
        http://bugs.webkit.org/show_bug.cgi?id=15422
        
        This also unifies SVG and non-SVG CSS hash lookups. A unified hash
        solves correctness problems as well as offers improved speed.
        
        Test: svg/css/getComputedStyle-basic.xhtml

        * DerivedSources.make: unify SVG and non-SVG CSS hash files
        * WebCore.xcodeproj/project.pbxproj: remove old SVG CSS hash files
        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::):
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue): call getPropertyCSSValue
        * css/CSSComputedStyleDeclaration.h: add getPropertyCSSValue
        * css/CSSGrammar.y:
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        * css/CSSStyleDeclaration.cpp:
        (WebCore::propertyID):
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applyProperty):
        * ksvg2/css/CSSPropertyNames.in: remove font-size-adjust
        * ksvg2/css/SVGCSSComputedStyleDeclaration.cpp: Added.
        (WebCore::CSSComputedStyleDeclaration::getSVGPropertyCSSValue): added.
        * ksvg2/css/SVGCSSParser.cpp:
        (WebCore::CSSParser::parseSVGValue):
        * ksvg2/css/SVGCSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applySVGProperty):
        * ksvg2/scripts/cssmakeprops: Removed.
        * ksvg2/scripts/cssmakevalues: Removed.
        * ksvg2/svg/SVGAnimationElement.cpp:
        * ksvg2/svg/SVGStyledElement.cpp:
        (WebCore::mapAttributeToCSSProperty):
        (WebCore::SVGStyledElement::cssPropertyIdForSVGAttributeName): remove font-size-adjust

2007-10-08  Sam Weinig  <sam@webkit.org>

        Reviewed by Steve Falkenburg;

        Fix for <rdar://problem/5519698> CrashTracer: [USER] 47 crashes in Safari at com.apple.WebCore: WebCore::XMLTokenizer::lineNumber const + 9

        Test: fast/innerHTML/innerHTML-script-tag-crash.xhtml

        * dom/XMLTokenizer.cpp:
        (WebCore::XMLTokenizer::lineNumber): Return 1 when there is no context.
        (WebCore::XMLTokenizer::columnNumber): ditto.

2007-10-08  Alexey Proskuryakov  <ap@webkit.org>

        * platform/mac/FontPlatformDataMac.mm:
        (WebCore::FontPlatformData::setFont): Restored one of the -1 checks removed in
        the previous change - we do need to check m_font!

2007-10-08  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=15397
        Layout tests freeze in HashTable::lookup

        Fixes a DRT freeze on PowerPC.

        * platform/mac/FontPlatformDataMac.mm:
        (WebCore::FontPlatformData::FontPlatformData): Don't ask for a size of a nil font,
        the result is undefined.
        (WebCore::FontPlatformData::setFont): Ditto. Also removed some checks for -1 that
        were not sufficient, and thus likely unnecessary,

2007-10-07  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Eric.

        Fix some issues with rotation & baseline-shift, when spanning
        across <tspan> elements. Highlighted by the existing batik tests.

        * rendering/SVGCharacterLayoutInfo.cpp:
        (WebCore::SVGCharacterLayoutInfo::SVGCharacterLayoutInfo):
        (WebCore::SVGCharacterLayoutInfo::processedChunk):
        (WebCore::SVGChar::characterTransform):
        * rendering/SVGCharacterLayoutInfo.h:
        * rendering/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::calculateGlyphBoundaries):
        (WebCore::SVGInlineTextBox::paintCharacters):
        (WebCore::SVGInlineTextBox::paintDecoration):
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBox::buildLayoutInformationForTextBox):

2007-10-07  Mark Rowe  <mrowe@apple.com>

        Reviewed by Maciej.

        Bug 5122: Need an equivalent of Mozilla's DOMContentLoaded event
        http://bugs.webkit.org/show_bug.cgi?id=5122

        This is based on a patch by Daniel Peebles (pumpkingod@gmail.com).

        Test: http/tests/loading/DOMContentLoaded-event.html

        * dom/Document.cpp:
        (WebCore::Document::finishedParsing): Dispatch the DOMContentLoaded event when parsing completes.
        * dom/EventNames.h:  Add DOMContentLoaded to the list of events.

2007-10-07  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Eric Seidel.

        http://bugs.webkit.org/show_bug.cgi?id=15368
        xsl:import fails when preceded by comment

        Test: fast/xsl/import-after-comment.xml

        * xml/XSLStyleSheet.cpp:
        (WebCore::XSLStyleSheet::loadChildSheets): It's OK for xsl:import to be preceded by
        non-element nodes.

2007-10-07  Vincent Ricard  <magic@magicninja.org>

        Reviewed by Maciej.  Landed by eseidel.

        http://bugs.webkit.org/show_bug.cgi?id=15062
        Implement document.compatMode

        Tests: fast/dom/compatMode-AlmostStrict.html
               fast/dom/compatMode-Compat.html
               fast/dom/compatMode-Strict.html

        * html/HTMLDocument.cpp:
        (WebCore::HTMLDocument::compatMode):
        * html/HTMLDocument.h:
        * html/HTMLDocument.idl:

2007-10-07  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin & Nikolas.  Landed by eseidel.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=14455
        Autogenerate the JS bindings for the StyleSheetList

        * DerivedSources.make:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSStyleSheetListCustom.cpp: Added.
        (WebCore::JSStyleSheetList::canGetItemsForName):
        (WebCore::JSStyleSheetList::nameGetter):
        * bindings/js/kjs_css.cpp:
        * bindings/js/kjs_css.h:
        * bindings/objc/DOMUtility.mm:
        * bindings/scripts/CodeGeneratorJS.pm:
        * css/StyleSheetList.cpp:
        (WebCore::StyleSheetList::StyleSheetList):
        (WebCore::StyleSheetList::documentDestroyed):
        (WebCore::StyleSheetList::getNamedItem):
        * css/StyleSheetList.h: Add Document member variable and
        getNamedItem function to accommodate the odd javascript 
        name getter functionality.
        * css/StyleSheetList.idl:
        * dom/Document.cpp:
        (WebCore::Document::Document):
        (WebCore::Document::~Document):
        * page/DOMWindow.idl: Add StyleSheetListConstructor

2007-10-07  Lars Naesbye Christensen  <lars@naesbye.dk>

        Reviewed by Eric Seidel.

        make CSS cell cursor more mac-like
        http://bugs.webkit.org/show_bug.cgi?id=15325

        * Resources/cellCursor.png:

2007-10-06  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver.
        
        SVG does not correctly handle onfocusin, onfocusout or onactivate
        http://bugs.webkit.org/show_bug.cgi?id=12573

        Test: svg/W3C-SVG-1.1/script-handle-02-b.svg

        * ksvg2/svg/SVGElement.cpp:
        (WebCore::SVGElement::parseMappedAttribute):
        * ksvg2/svg/svgattrs.in: add onfocusin, onfocusout and onactivate

2007-10-06  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Never pass null input images to CICrop filter.

        * platform/graphics/svg/filters/cg/SVGFEComponentTransferCg.mm:
        (WebCore::SVGFEComponentTransfer::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEHelpersCg.h:

2007-10-06  Mark Rowe  <mrowe@apple.com>

        Reviewed by Alp Toker.

        Gtk+ build fix and minor code cleanup.

        * WebCore.pro:
        * platform/gtk/FontCacheGtk.cpp:
        (WebCore::FontCache::getLastResortFallbackFont):
        (WebCore::FontCache::fontExists):

2007-10-06  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Mitz.

        http://bugs.webkit.org/show_bug.cgi?id=15380
        XPath: id('foo') doesn't resolve correctly

        Test: fast/xpath/id-simple.html

        * xml/XPathFunctions.cpp:
        (WebCore::XPath::FunId::evaluate): Fixed a logic error in id() parameter parsing.

2007-10-06  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin.

        Patch for http://bugs.webkit.org/show_bug.cgi?id=13707
        REGRESSION: JavaScript exceptions on quotes.burntelectrons.org

        http://bugs.webkit.org/show_bug.cgi?id=12628
        document.body is not supported in XHTML documents

        http://bugs.webkit.org/show_bug.cgi?id=14213
        On page with MIME type application/xhtml+xml, cookie don't work

        Moved a bunch of methods and properties from HTMLDocument down into Document to make
        them available for all documents (xml, svg).
        What was kept in HTMLDocument:
        - some methods and properties that are not in HTML5 (yet?);
        - open/write/writeln/close, as they will need to be modified to work on XML documents, and aren't
        of much use for those anyway;
        - designMode, because its definition in HTML5 is incompatible with our implementation.

        Covered by existing tests.

        * bindings/js/JSDocumentCustom.cpp:
        (WebCore::JSDocument::location):
        (WebCore::JSDocument::setLocation):
        * bindings/js/JSHTMLDocumentCustom.cpp:
        * bindings/objc/PublicDOMInterfaces.h:
        * dom/Document.cpp:
        (WebCore::Document::setBody):
        (WebCore::Document::cookie):
        (WebCore::Document::setCookie):
        (WebCore::Document::lastModified):
        * dom/Document.h:
        (WebCore::Document::title):
        * dom/Document.idl:
        * html/HTMLDocument.cpp:
        * html/HTMLDocument.h:
        * html/HTMLDocument.idl:

2007-10-06  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver Hunt.

        RenderSVGContainer (<g>) should not repaint when its bounds change (unless it has a filter)
        http://bugs.webkit.org/show_bug.cgi?id=15388
        This makes the Sun Lively Kernel invalidate only what it should!
        
        No tests possible in DRT.

        * ksvg2/svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::notifyAttributeChange): replace call to rebuildRenderer
        * ksvg2/svg/SVGEllipseElement.cpp:
        (WebCore::SVGEllipseElement::notifyAttributeChange): replace call to rebuildRenderer
        * ksvg2/svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::notifyAttributeChange): replace call to rebuildRenderer
        (WebCore::SVGImageElement::hasRelativeValues): implemented
        * ksvg2/svg/SVGImageElement.h:
        * ksvg2/svg/SVGLineElement.cpp:
        (WebCore::SVGLineElement::notifyAttributeChange): replace call to rebuildRenderer
        * ksvg2/svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::notifyAttributeChange): replace call to rebuildRenderer
        * ksvg2/svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::notifyAttributeChange): replace call to rebuildRenderer
        * ksvg2/svg/SVGRectElement.cpp:
        (WebCore::SVGRectElement::notifyAttributeChange): replace call to rebuildRenderer
        * ksvg2/svg/SVGStyledElement.cpp:
        * ksvg2/svg/SVGStyledElement.h:
        (WebCore::SVGStyledElement::hasRelativeValues): default to true instead
        * ksvg2/svg/SVGStyledTransformableElement.cpp:
        (WebCore::SVGStyledTransformableElement::updateLocalTransform): don't layout if no change
        * ksvg2/svg/SVGStyledTransformableElement.h:
        * ksvg2/svg/SVGTransform.h:
        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::layout):
        * rendering/RenderPath.h:
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::layout):
        (WebCore::RenderSVGContainer::selfWillPaint): return true if have a filter
        (WebCore::RenderSVGContainer::paint):
        * rendering/RenderSVGContainer.h:
        * rendering/RenderSVGHiddenContainer.cpp:
        (WebCore::RenderSVGHiddenContainer::layout):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::layout):
        * rendering/RenderSVGViewportContainer.cpp:
        (WebCore::RenderSVGViewportContainer::layout):
        (WebCore::RenderSVGViewportContainer::calcViewport): use floats

2007-10-06  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        Use document() instead of ownerDocument() and a few other cleanups.

        * ksvg2/misc/SVGDocumentExtensions.cpp:
        (WebCore::SVGDocumentExtensions::mapInstanceToElement):
        * ksvg2/svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::notifyAttributeChange):
        * ksvg2/svg/SVGClipPathElement.cpp:
        (WebCore::SVGClipPathElement::notifyAttributeChange):
        * ksvg2/svg/SVGElementInstance.cpp:
        (WebCore::containsUseChildNode):
        * ksvg2/svg/SVGEllipseElement.cpp:
        (WebCore::SVGEllipseElement::notifyAttributeChange):
        * ksvg2/svg/SVGGradientElement.cpp:
        (WebCore::SVGGradientElement::notifyAttributeChange):
        * ksvg2/svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::notifyAttributeChange):
        * ksvg2/svg/SVGLineElement.cpp:
        (WebCore::SVGLineElement::notifyAttributeChange):
        * ksvg2/svg/SVGMarkerElement.cpp:
        (WebCore::SVGMarkerElement::notifyAttributeChange):
        * ksvg2/svg/SVGMaskElement.cpp:
        (WebCore::SVGMaskElement::notifyAttributeChange):
        * ksvg2/svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::notifyAttributeChange):
        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::notifyAttributeChange):
        * ksvg2/svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::notifyAttributeChange):
        * ksvg2/svg/SVGRectElement.cpp:
        (WebCore::SVGRectElement::notifyAttributeChange):
        * ksvg2/svg/SVGStopElement.cpp:
        (WebCore::SVGStopElement::notifyAttributeChange):

2007-10-05  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver Hunt.

        SVG invalidates way too much during layout()
        http://bugs.webkit.org/show_bug.cgi?id=14003

        * ksvg2/svg/SVGElement.cpp:
        (WebCore::SVGElement::ownerSVGElement): simplify if
        (WebCore::SVGElement::viewportElement): simplify if
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::layout): only layout children if parent changed
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::layout): only layout children when size changes
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::layout): hack to avoid bad RenderBlock::layout code
        * rendering/RenderSVGViewportContainer.cpp:
        (WebCore::RenderSVGViewportContainer::layout): don't use RenderSVGContainer::layout()

2007-10-05  Oliver Hunt  <oliver@apple.com>

        Reviewed by Eric.

        30%+ performance improvement for svg embedded in xhtml

        Relayout internal to SVG was incorrectly being propagated to
        the containing xhtml element, which subsequently resulted in
        a full paint of the SVG, rather than just the dirty regions.

        * rendering/RenderObject.cpp:
        (WebCore::objectIsRelayoutBoundary):
        (WebCore::RenderObject::markContainingBlocksForLayout):

2007-10-03  Eric Seidel  <eric@webkit.org>

        Reviewed by Maciej.
        
        http://bugs.webkit.org/show_bug.cgi?id=12310
        Remove static variables from removeAllChildren causing crash.
        removeAllChildren now iterates over the entire tree instead of recursing.
        Also (according to Maciej) a possible 1-2% speedboost on HTML iBench.

        Test: fast/images/svg-background-crash-on-refresh.html

        * WebCore.xcodeproj/project.pbxproj:
        * dom/ContainerNode.cpp:
        (WebCore::addChildNodesToDeletionQueue):
        (WebCore::ContainerNode::removeAllChildren): use new addChildNodesToDeletionQueue

2007-10-03  David Hyatt  <hyatt@apple.com>

        Land support for the CSS @font-face rule.  This patch allows custom fonts
        to be downloaded from the Web and rendered in Web pages.  Right now only
        TrueType fonts are supported.  Proprietary formats like .eot are not
        supported.

        Reviewed by Eric Seidel

        Many tests will be coming in a future landing.

        * WebCore.base.exp:
        Expose some more stuff for WebKit, caused by font restructuring.

        * WebCore.xcodeproj/project.pbxproj:
        Add all the new font face files.

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        Make sure to ignore the 'src' property of @font-face rules.

        * css/CSSFontFace.cpp: Added.
        (WebCore::CSSFontFace::CSSFontFace):
        (WebCore::CSSFontFace::~CSSFontFace):
        (WebCore::CSSFontFace::isLoaded):
        (WebCore::CSSFontFace::isValid):
        (WebCore::CSSFontFace::addSource):
        (WebCore::CSSFontFace::fontLoaded):
        (WebCore::CSSFontFace::getFontData):
        * css/CSSFontFace.h: Added.
        A CSSFontFace is a composite object.  It consists of multiple font-face sources, where each source represents either a remote or local
        file in a @font-face rule's src list.

        * css/CSSFontFaceRule.cpp:
        (WebCore::CSSFontFaceRule::setDeclaration):
        (WebCore::CSSFontFaceRule::cssText):
        * css/CSSFontFaceRule.h:
        The implementation of the @font-face rule itself in the CSS sheet back end.
        
        * css/CSSFontFaceSource.cpp: Added.
        (WebCore::CSSFontFaceSource::CSSFontFaceSource):
        (WebCore::CSSFontFaceSource::~CSSFontFaceSource):
        (WebCore::CSSFontFaceSource::pruneTable):
        (WebCore::CSSFontFaceSource::isLoaded):
        (WebCore::CSSFontFaceSource::isValid):
        (WebCore::CSSFontFaceSource::fontLoaded):
        (WebCore::CSSFontFaceSource::getFontData):
        * css/CSSFontFaceSource.h: Added.
        (WebCore::CSSFontFaceSource::string):
        (WebCore::CSSFontFaceSource::setFontFace):
        A font face source represents a single remote or local font.  If it represents a remote font than it wraps a CachedFont.
        
        * css/CSSFontFaceSrcValue.cpp: Added.
        (WebCore::CSSFontFaceSrcValue::isSupportedFormat):
        (WebCore::CSSFontFaceSrcValue::cssText):
        * css/CSSFontFaceSrcValue.h: Added.
        (WebCore::CSSFontFaceSrcValue::m_isLocal):
        (WebCore::CSSFontFaceSrcValue::~CSSFontFaceSrcValue):
        (WebCore::CSSFontFaceSrcValue::resource):
        (WebCore::CSSFontFaceSrcValue::format):
        (WebCore::CSSFontFaceSrcValue::isLocal):
        (WebCore::CSSFontFaceSrcValue::setFormat):
        Used in parsing.  Represents the parsed form of the src value that can then be used to build up a CSSFontFace.

        * css/CSSFontSelector.cpp: Added.
        (WebCore::CSSFontSelector::CSSFontSelector):
        (WebCore::CSSFontSelector::~CSSFontSelector):
        (WebCore::CSSFontSelector::isEmpty):
        (WebCore::CSSFontSelector::docLoader):
        (WebCore::hashForFont):
        (WebCore::CSSFontSelector::addFontFaceRule):
        (WebCore::CSSFontSelector::fontLoaded):
        (WebCore::CSSFontSelector::getFontData):
        * css/CSSFontSelector.h: Added.
        The CSS font selector is the object that selects the correct font given a specified font family.  It builds up a database of CSSFontFaces that can then be handed
        back.

        * css/CSSGrammar.y:
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        (WebCore::CSSParser::parseFontFaceSrc):
        (WebCore::CSSParser::createFontFaceRule):
        * css/CSSParser.h:
        Modify the CSS grammar to now understand @font-face rules.

        * css/CSSPropertyNames.in:
        Add the src property.

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::CSSStyleSelector):
        (WebCore::CSSStyleSelector::styleForElement):
        (WebCore::CSSStyleSelector::updateFont):
        (WebCore::CSSRuleSet::addRulesFromSheet):
        (WebCore::CSSStyleSelector::applyProperty):
        (WebCore::CSSStyleSelector::ensureFontSelector):
        * css/CSSStyleSelector.h:
        (WebCore::CSSStyleSelector::fontSelector):
        The style selector now creates a font selector object and feeds it the appropriate information when @font-face rules are encountered.
    
        * dom/Document.cpp:
        (WebCore::Document::recalcStyle):
        Patch the update method now that it takes a font selector argument.
    
        * loader/Cache.cpp:
        (WebCore::createResource):
        (WebCore::Cache::getStatistics):
        * loader/Cache.h:
        Teach the Cache about CachedFonts.

        * loader/CachedFont.cpp: Added.
        (WebCore::CachedFont::CachedFont):
        (WebCore::CachedFont::~CachedFont):
        (WebCore::CachedFont::ref):
        (WebCore::CachedFont::data):
        (WebCore::CachedFont::beginLoadIfNeeded):
        (WebCore::CachedFont::ensureCustomFontData):
        (WebCore::CachedFont::platformDataFromCustomData):
        (WebCore::CachedFont::allReferencesRemoved):
        (WebCore::CachedFont::checkNotify):
        (WebCore::CachedFont::error):
        * loader/CachedFont.h: Added.
        (WebCore::CachedFont::schedule):
        The implementation of CachedFont.  This represents the downloaded resource and has all the raw font data.

        * loader/CachedResource.h:
        (WebCore::CachedResource::):
        * loader/CachedResourceClient.h:
        (WebCore::CachedResourceClient::fontLoaded):
        Add a new fontLoaded method for clients of cached resources to track when fonts finish downloading.
    
        * loader/DocLoader.cpp:
        (WebCore::DocLoader::requestFont):
        * loader/DocLoader.h:
         Add the ability to request a font.

        * platform/Font.cpp:
        (WebCore::Font::operator==):
        (WebCore::Font::update):
        (WebCore::Font::drawText):
        * platform/Font.h:
        * platform/FontCache.cpp:
        (WebCore::FontCache::getFontData):
        * platform/FontCache.h:
        * platform/FontData.cpp:
        (WebCore::FontData::FontData):
        * platform/FontData.h:
        (WebCore::FontData::isCustomFont):
        (WebCore::FontData::isLoading):
        * platform/FontFallbackList.cpp:
        (WebCore::FontFallbackList::FontFallbackList):
        (WebCore::FontFallbackList::invalidate):
        (WebCore::FontFallbackList::fontDataAt):
        * platform/FontFallbackList.h:
        (WebCore::FontFallbackList::loadingCustomFonts):
        (WebCore::FontFallbackList::fontSelector):
        * platform/FontSelector.h: Added.
        (WebCore::FontSelector::~FontSelector):
        * platform/GlyphPageTreeNode.cpp:
        (WebCore::GlyphPageTreeNode::getRoot):
        (WebCore::GlyphPageTreeNode::pruneTreeCustomFontData):
        (WebCore::GlyphPageTreeNode::~GlyphPageTreeNode):
        (WebCore::GlyphPageTreeNode::initializePage):
        (WebCore::GlyphPageTreeNode::getChild):
        (WebCore::GlyphPageTreeNode::pruneCustomFontData):
        * platform/GlyphPageTreeNode.h:
        (WebCore::GlyphPageTreeNode::GlyphPageTreeNode):
        (WebCore::GlyphPageTreeNode::page):
        * platform/PopupMenuClient.h:
        * platform/mac/FontCacheMac.mm:
        (WebCore::FontCache::getFontDataForCharacters):
        (WebCore::FontCache::getLastResortFallbackFont):
        (WebCore::FontCache::fontExists):
        (WebCore::FontCache::createFontPlatformData):
        * platform/mac/FontCustomPlatformData.cpp: Added.
        (WebCore::FontCustomPlatformData::~FontCustomPlatformData):
        (WebCore::FontCustomPlatformData::fontPlatformData):
        (WebCore::createFontCustomPlatformData):
        * platform/mac/FontCustomPlatformData.h: Added.
        (WebCore::FontCustomPlatformData::FontCustomPlatformData):
        * platform/mac/FontDataMac.mm:
        (WebCore::initFontData):
        (WebCore::FontData::platformInit):
        (WebCore::FontData::smallCapsFontData):
        (WebCore::FontData::platformWidthForGlyph):
        (WebCore::FontData::checkShapesArabic):
        * platform/mac/FontMac.mm:
        (WebCore::initializeATSUStyle):
        (WebCore::Font::drawGlyphs):
        * platform/mac/FontPlatformData.h:
        (WebCore::FontPlatformData::FontPlatformData):
        (WebCore::FontPlatformData::hash):
        (WebCore::FontPlatformData::operator==):
        * platform/mac/FontPlatformDataMac.mm: Added.
        (WebCore::FontPlatformData::FontPlatformData):
        (WebCore::~FontPlatformData):
        (WebCore::FontPlatformData::setFont):
        * platform/mac/WebCoreSystemInterface.h:
        * platform/mac/WebCoreSystemInterface.mm:
        * platform/win/FontCacheWin.cpp:
        (WebCore::FontCache::getLastResortFallbackFont):
        (WebCore::FontCache::fontExists):
        * platform/win/FontCustomPlatformData.cpp: Added.
        (WebCore::FontCustomPlatformData::~FontCustomPlatformData):
        (WebCore::FontCustomPlatformData::fontPlatformData):
        (WebCore::getData):
        (WebCore::releaseData):
        (WebCore::getBytesWithOffset):
        (WebCore::createFontCustomPlatformData):
        * platform/win/FontCustomPlatformData.h: Added.
        (WebCore::FontCustomPlatformData::FontCustomPlatformData):
        * platform/win/FontDataWin.cpp:
        (WebCore::FontData::platformInit):
        (WebCore::FontData::platformDestroy):
        (WebCore::FontData::smallCapsFontData):
        (WebCore::FontData::containsCharacters):
        (WebCore::FontData::determinePitch):
        * platform/win/FontPlatformData.h:
        (WebCore::FontPlatformData::FontPlatformData):
        (WebCore::FontPlatformData::hash):
        (WebCore::FontPlatformData::operator==):
        * platform/win/FontPlatformDataWin.cpp:
        (WebCore::FontPlatformData::FontPlatformData):
        * platform/win/PopupMenuWin.cpp:
        (WebCore::PopupMenu::paint):
        Changes to platform to support rendering of custom fonts.  Too large to go into, but for ports, the relevant object to implement is
        FontCustomPlatformData (to get the data loaded into your native font format), and then you have to patch your other font objects to know
        how to use the font.

        * rendering/RenderListBox.cpp:
        (WebCore::RenderListBox::updateFromElement):
        (WebCore::RenderListBox::paintItemForeground):
        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::fontSelector):
        * rendering/RenderMenuList.h:
        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::fontSelector):
        * rendering/RenderTextControl.h:
        * rendering/RenderThemeMac.mm:
        (WebCore::RenderThemeMac::setFontFromControlSize):
        * rendering/RenderThemeSafari.cpp:
        (WebCore::RenderThemeSafari::setFontFromControlSize):
        Patches for update now taking a font selector argument.
    
2007-10-03  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        Remove unneeded code and other cleanups.

        * ksvg2/svg/SVGScriptElement.cpp:
        (WebCore::SVGScriptElement::parseMappedAttribute):
        * ksvg2/svg/SVGScriptElement.h:

2007-10-03  Rob Buis  <buis@kde.org>

        Reviewed by Maciej.

        http://bugs.webkit.org/show_bug.cgi?id=15260
        Any styles defined after <element> {<property>:%} style are ignored by Safari
    
        Add dummy rule to skip constructions like width: %.

        * css/CSSGrammar.y:

2007-10-03  Mark Rowe  <mrowe@apple.com>

        Reviewed by Lars.

        Get Gtk+ port building on the feature branch.

        * WebCore.pro:
        * ksvg2/svg/SVGSVGElement.cpp:
        * platform/graphics/svg/cairo/RenderPathCairo.cpp:
        (WebCore::RenderPath::strokeContains):
        * platform/graphics/svg/cairo/SVGPaintServerCairo.cpp:
        (WebCore::SVGPaintServer::draw):
        (WebCore::SVGPaintServer::renderPath):
        * platform/graphics/svg/cairo/SVGPaintServerSolidCairo.cpp:
        (WebCore::SVGPaintServerSolid::setup):
        * platform/graphics/svg/cairo/SVGResourceMaskerCairo.cpp:
        (WebCore::SVGResourceMasker::applyMask):
        * rendering/SVGCharacterLayoutInfo.cpp:
        * rendering/SVGInlineTextBox.cpp:
        * rendering/SVGRootInlineBox.cpp:

2007-10-02  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Maciej.

        http://bugs.webkit.org/show_bug.cgi?id=15102
        XMLHttpRequests should dispatch a readystatechange event.

        Test: http/tests/xmlhttprequest/readystatechange.html

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::callReadyStateChangeListener): Added readystatechange
        event support. Fixed the function to dispatch the same event to all listeners
        instead of creating a new copy for each one. Changed bubbling/cancelability of
        load and readystatechange events to match Firefox.

2007-10-02  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver Hunt.

        http://bugs.webkit.org/show_bug.cgi?id=13828
        Fixes svg/custom/rootmost-svg-xy-attrs.xhtml

        * WebCore.xcodeproj/project.pbxproj: fix warning about SVGDOM.h
        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::viewport): use new isOutermostSVG()
        (WebCore::SVGSVGElement::getCTM): use isOutermostSVG()
        (WebCore::SVGSVGElement::getScreenCTM): use isOutermostSVG()
        (WebCore::SVGSVGElement::createRenderer): use isOutermostSVG()
        (WebCore::SVGSVGElement::isOutermostSVG):
        * ksvg2/svg/SVGSVGElement.h: add isOutermostSVG
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::calcViewport): ignore x/y

2007-10-02  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Mitz.
        
        - Avoid uselessly serializing CSS property values on replacement for 10% CK DOM speedup
        http://bugs.webkit.org/show_bug.cgi?id=15340

        * css/CSSMutableStyleDeclaration.cpp:
        (WebCore::CSSMutableStyleDeclaration::removeProperty): Don't generate return value unless needed.
        (WebCore::CSSMutableStyleDeclaration::setProperty): Use the no-return version appropriately.
        * css/CSSMutableStyleDeclaration.h:
        (WebCore::CSSMutableStyleDeclaration::removeProperty): New version with no return value.

2007-10-02  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Oliver.

        - Use Vector<UChar> instead of DeprecatedString for innerHTML, for 35% speedup on CK DOM test
        http://bugs.webkit.org/show_bug.cgi?id=15339

        Rewrote both versions of createMarkup to build based on
        Vector<UChar> instead of String. Also other miscellaneous
        speedups (mainly content strings are now encoded in a way that
        doesn't take a function call per character, and switch is avoided).
        
        This also causes a functional change - we no longer escape '>' since this was unnecessary and it's faster
        to avoid testing for it. See updated test results.
        
        * editing/markup.cpp:
        (WebCore::appendString):
        (WebCore::appendAttributeValue):
        (WebCore::escapeContentText):
        (WebCore::appendEscapedContent):
        (WebCore::appendDeprecatedString):
        (WebCore::appendQuotedURLAttributeValue):
        (WebCore::stringValueForRange):
        (WebCore::ucharRange):
        (WebCore::appendUCharRange):
        (WebCore::appendNamespace):
        (WebCore::appendStartMarkup):
        (WebCore::getStartMarkup):
        (WebCore::appendEndMarkup):
        (WebCore::getEndMarkup):
        (WebCore::appendMarkup):
        (WebCore::joinMarkups):
        (WebCore::createMarkup):
        * editing/markup.h:
        * page/mac/WebCoreFrameBridge.mm:
        (-[WebCoreFrameBridge markupStringFromNode:nodes:]):
        (-[WebCoreFrameBridge markupStringFromRange:nodes:]):

2007-10-02  Maciej Stachowiak  <mjs@apple.com>

        Reviewed by Eric.
        
        - fixed "innerHTML updates layout every time (very bad if adding to it in a loop)"
        http://bugs.webkit.org/show_bug.cgi?id=15326
        (65% speedup on Celtic Kane JS 2007 DOM test)

        * editing/markup.cpp:
        (WebCore::createMarkup): The Node version of this function currently never uses
        the render tree, so don't bother to update layout. This is the version used for
        innerHTML.

2007-10-02  Nicholas Shanks  <webkit@nickshanks.com>

        Reviewed by eseidel & hyatt.

        Add support for CSS3 values 'start' and 'end' to text-align property.

        * css/cssparser.cpp:
        (WebCore::CSSParser::parseValue): allow start and end values
        * css/cssstyleselector.cpp:
        (WebCore::CSSStyleSelector::applyProperty): handle start and end values

2007-10-01  Oliver Hunt  <oliver@apple.com>

        Reviewed by Mark.

        Enable Experimental SVG features by default when building from Xcode

        * Configurations/WebCore.xcconfig:

2007-10-01  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver Hunt.

        This only affects Debug builds, and the ability to save SVGs as WebArchives
        neither are testable via DumpRenderTree.

        * Configurations/WebCore.xcconfig: change where Xcode looks for WebCore.exp
        * DerivedSources.make: adds SVG symbols to WebCore.exp when necessary
        * WebCore.SVG.exp: Added.
        * WebCore.exp: moved to WebCore.base.exp
        * WebCore.xcodeproj/project.pbxproj: updated to reflect moved files
        * bindings/objc/DOMSVGExecption.h: moved to DOMSVGException.h

2007-10-01  Eric Seidel  <eric@webkit.org>

        Reviewed by olliej.

        Make feature-branch build again with ENABLE_SVG_EXPERIMENTAL_FEATURES
        Needed a double -> float change to make the new filter types build.

        Build fix, no test cases.

        * ksvg2/svg/SVGComponentTransferFunctionElement.cpp:
        * ksvg2/svg/SVGComponentTransferFunctionElement.h:
        * ksvg2/svg/SVGFECompositeElement.cpp:
        * ksvg2/svg/SVGFECompositeElement.h:
        * ksvg2/svg/SVGFEDiffuseLightingElement.cpp:
        * ksvg2/svg/SVGFEDiffuseLightingElement.h:
        * ksvg2/svg/SVGFEDisplacementMapElement.cpp:
        * ksvg2/svg/SVGFEDisplacementMapElement.h:
        * ksvg2/svg/SVGFEGaussianBlurElement.cpp:
        * ksvg2/svg/SVGFEGaussianBlurElement.h:
        * ksvg2/svg/SVGFELightElement.cpp:
        * ksvg2/svg/SVGFELightElement.h:
        * ksvg2/svg/SVGFEOffsetElement.cpp:
        * ksvg2/svg/SVGFEOffsetElement.h:
        * ksvg2/svg/SVGFESpecularLightingElement.cpp:
        * ksvg2/svg/SVGFESpecularLightingElement.h:
        * ksvg2/svg/SVGFETurbulenceElement.cpp:
        * ksvg2/svg/SVGFETurbulenceElement.h:

2007-09-30  Julien  <julien.chaffraix@gmail.com>

        Reviewed by aroben & eseidel.

        fix http://bugs.webkit.org/show_bug.cgi?id=14898

        getAllResponseHeaders() separates each header with a CR LF according to the specification

        Test: http/tests/xmlhttprequest/xmlhttprequest-crlf-getAllResponseHeader.html

        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::getAllResponseHeaders):

2007-09-28  Eric Seidel  <eric@webkit.org>

        Reviewed by Sam Wenig.

        ASSERT when dragging <svg:image> with non-null prefix
        http://bugs.webkit.org/show_bug.cgi?id=15308

        * bindings/objc/DOM.mm:
        (WebCore::lookupElementClass): added
        (WebCore::elementClass): use new lookupElementClass function

2007-09-25  Eric Seidel  <eric@webkit.org>

        Reviewed by Mark Rowe.

        I managed to break the SVG build when fixing the --no-svg build for
        http://bugs.webkit.org/show_bug.cgi?id=15281
        This adds the appropriate DOMSVG headers to the copy headers phase
        (in fixing the no-svg build I mistakenly re-marked them project-only)

        * WebCore.xcodeproj/project.pbxproj:

2007-09-25  Eric Seidel  <eric@webkit.org>

        Reviewed by Rob Buis.

        Already tested by SVG/W3C-SVG-1.1/linking-a-07-t.svg

        * ksvg2/svg/SVGAElement.cpp:
        (WebCore::SVGAElement::defaultEventHandler): properly pass along target values

2007-09-22  Oliver Hunt  <oliver@apple.com>

        Reviewed by NOBODY (Build fix).

        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::teardown):
        (WebCore::SVGPaintServerGradient::renderPath):
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBoxPaintWalker::chunkPortionCallback):

2007-09-09  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Rework <pattern> support to take overflow & viewBox into account.
        Also fix all possible combinations of patternUnits/patternContentUnits, tested by several batik testcases.
        (Status: <mask>, <pattern>, <linearGradient>, <radialGradient>, <filter> regions work perfectly. <clipPath> is sill todo)

        While I'm at it, add a very helpful debugging tool "dumpCGOutputImage" and rename "dumpOutputImage" to "dumpCIOutputImage".
        Also fix possible null image buffer problems. (ie. large alloc)

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=12221 (Webkit ToT fails to render this pattern example)

        * ksvg2/svg/PatternAttributes.h:
        (WebCore::PatternAttributes::PatternAttributes):
        (WebCore::PatternAttributes::x):
        (WebCore::PatternAttributes::y):
        (WebCore::PatternAttributes::width):
        (WebCore::PatternAttributes::height):
        (WebCore::PatternAttributes::setX):
        (WebCore::PatternAttributes::setY):
        (WebCore::PatternAttributes::setWidth):
        (WebCore::PatternAttributes::setHeight):
        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::buildPattern):
        (WebCore::SVGPatternElement::collectPatternProperties):
        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::setup):
        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        (WebCore::patternCallback):
        (WebCore::SVGPaintServerPattern::setup):
        * platform/graphics/svg/cg/SVGResourceFilterCg.mm:
        (WebCore::dumpCIOutputImage):
        (WebCore::dumpCGOutputImage):

2007-09-05  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fix <mask> in userSpaceOnUse coordinates. Verified by new testcase taken from Batik.

        * ksvg2/svg/SVGMaskElement.cpp:
        (WebCore::SVGMaskElement::drawMaskerContent):

2007-09-03  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Rewrite text painting code path, to be based on "text chunks" instead of using the InlineBox* hierarchy.
        This allows us to reuse paint servers as long as possible - and to actually paint in the way didacted by the spec.

        This also implements advanced SVG text decorations (ie. stroked/filled decos with gradient/pattern).
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=7200 (Gradient appears and disappears in SVG when text is off screen)

        Fixes paint server usage on text paths. (ie. styled text paths, with gradients/filters).

        * platform/graphics/svg/SVGPaintServer.h:
        * platform/graphics/svg/SVGPaintServerGradient.h:
        * platform/graphics/svg/cg/SVGPaintServerCg.cpp:
        (WebCore::SVGPaintServer::draw):
        (WebCore::SVGPaintServer::renderPath):
        (WebCore::SVGPaintServer::strokePath):
        (WebCore::SVGPaintServer::clipToStrokePath):
        (WebCore::SVGPaintServer::fillPath):
        (WebCore::SVGPaintServer::clipToFillPath):
        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::findTextRootObject):
        (WebCore::SVGPaintServerGradient::teardown):
        (WebCore::SVGPaintServerGradient::renderPath):
        (WebCore::SVGPaintServerGradient::handleBoundingBoxModeAndGradientTransformation):
        (WebCore::SVGPaintServerGradient::setup):
        * platform/graphics/svg/cg/SVGPaintServerSolidCg.cpp:
        (WebCore::SVGPaintServerSolid::setup):
        * platform/graphics/svg/qt/SVGPaintServerQt.cpp:
        (WebCore::SVGPaintServer::draw):
        (WebCore::SVGPaintServer::renderPath):
        * rendering/RenderSVGInlineText.cpp:
        * rendering/RenderSVGTSpan.cpp:
        * rendering/RenderSVGText.cpp:
        * rendering/RenderSVGTextPath.cpp:
        * rendering/SVGCharacterLayoutInfo.h:
        (WebCore::SVGTextChunkWalkerBase::~SVGTextChunkWalkerBase):
        (WebCore::SVGTextChunkWalker::SVGTextChunkWalker):
        (WebCore::SVGTextChunkWalker::operator()):
        (WebCore::SVGTextChunkWalker::start):
        (WebCore::SVGTextChunkWalker::end):
        (WebCore::SVGTextChunkWalker::setupFill):
        (WebCore::SVGTextChunkWalker::setupStroke):
        * rendering/SVGInlineFlowBox.h:
        * rendering/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBoxClosestCharacterToPositionWalker::SVGInlineTextBoxClosestCharacterToPositionWalker):
        (WebCore::SVGInlineTextBoxClosestCharacterToPositionWalker::chunkPortionCallback):
        (WebCore::SVGInlineTextBoxClosestCharacterToPositionWalker::character):
        (WebCore::SVGInlineTextBoxClosestCharacterToPositionWalker::offset):
        (WebCore::SVGInlineTextBoxSelectionRectWalker::SVGInlineTextBoxSelectionRectWalker):
        (WebCore::SVGInlineTextBoxSelectionRectWalker::chunkPortionCallback):
        (WebCore::SVGInlineTextBoxSelectionRectWalker::selectionRect):
        (WebCore::SVGInlineTextBox::closestCharacterToPosition):
        (WebCore::SVGInlineTextBox::selectionRect):
        (WebCore::SVGInlineTextBox::paintCharacters):
        (WebCore::SVGInlineTextBox::paintSelection):
        (WebCore::pathForDecoration):
        (WebCore::SVGInlineTextBox::paintDecoration):
        * rendering/SVGInlineTextBox.h:
        * rendering/SVGRenderSupport.cpp:
        (WebCore::prepareToRenderSVGContent):
        * rendering/SVGRenderSupport.h:
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBoxPaintWalker::SVGRootInlineBoxPaintWalker):
        (WebCore::SVGRootInlineBoxPaintWalker::~SVGRootInlineBoxPaintWalker):
        (WebCore::SVGRootInlineBoxPaintWalker::teardownFillPaintServer):
        (WebCore::SVGRootInlineBoxPaintWalker::teardownStrokePaintServer):
        (WebCore::SVGRootInlineBoxPaintWalker::chunkStartCallback):
        (WebCore::SVGRootInlineBoxPaintWalker::chunkEndCallback):
        (WebCore::SVGRootInlineBoxPaintWalker::chunkSetupFillCallback):
        (WebCore::SVGRootInlineBoxPaintWalker::chunkSetupStrokeCallback):
        (WebCore::SVGRootInlineBoxPaintWalker::chunkPortionCallback):
        (WebCore::SVGRootInlineBox::paint):
        (WebCore::SVGRootInlineBox::buildLayoutInformationForTextBox):
        (WebCore::addPaintServerToTextDecorationInfo):
        (WebCore::SVGRootInlineBox::retrievePaintServersForTextDecoration):
        (WebCore::SVGRootInlineBox::walkTextChunks):
        * rendering/SVGRootInlineBox.h:

2007-08-27  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Mitz.

        Expose unitsPerEm() in Font classes.
        This is needed to implement SVG's advanced text decorations. We won't draw lines for text-decorations
        but fillable & strokable rectangles with a certain height, computed through unitsPerEm & font size.

        * platform/Font.cpp:
        (WebCore::Font::unitsPerEm):
        * platform/Font.h:
        * platform/FontData.h:
        (WebCore::FontData::unitsPerEm):
        * platform/gdk/FontDataGdk.cpp:
        (WebCore::FontData::platformInit):
        * platform/mac/FontDataMac.mm:
        (WebCore::FontData::platformInit):
        * platform/qt/FontDataQt.cpp:
        (WebCore::FontData::platformInit):
        * platform/win/FontDataWin.cpp:
        (WebCore::FontData::platformInit):
        * platform/wx/FontDataWx.cpp:
        (WebCore::FontData::platformInit):

2007-08-27  Oliver Hunt  <oliver@apple.com>

        Reviewed by NOBODY (Build fix).

        Initialise iterators to appease gcc

        * rendering/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::closestCharacterToPosition):

2007-08-22  Rob Buis  <buis@kde.org>

        Reviewed by Sam.

        http://bugs.webkit.org/show_bug.cgi?id=12059
        SVG colors have two separate parsing paths (one CSS and one SVGColor::setRGBColor)

        Reuse the css parser as much as possible in setRGBColor.

        * css/cssparser.cpp:
        (WebCore::CSSParser::parseColor):
        * css/cssparser.h:
        * editing/ApplyStyleCommand.cpp:
        (WebCore::StyleChange::checkForLegacyHTMLStyleChange):
        * html/CanvasGradient.cpp:
        (WebCore::CanvasGradient::addColorStop):
        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::setShadow):
        (WebCore::CanvasRenderingContext2D::applyShadow):
        * html/CanvasStyle.cpp:
        (WebCore::CanvasStyle::applyStrokeColor):
        (WebCore::CanvasStyle::applyFillColor):
        * ksvg2/svg/SVGColor.cpp:
        (WebCore::SVGColor::colorFromRGBColorString):

2007-08-21  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Large SVG filter rework. Bring it back in a useable state.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=5527 (Filters need subregion support)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=5579 (WebKit+SVG renders full-filters-example incorrectly)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=5976 (filterUnits="userSpaceOnUse" is broken (breaking feTile test case))
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=12064 (Need function for manual style-resolution for things like gradient stops)

        filters-blend-01-b.svg & filters-example-01-b.svg & filters-displace-01-b.svg & filters-diffuse-01-f.svg are fixed now.

        In detail:
        - flood-color & flood-opacity have been incorrectly resolved on the <feBlend> parent element!
        - sizing of filter region was truncated in some cases, as the bbox was used to resolve the needed filter region instead of the filter rect
        - add subregion support to all filter primitives (primitiveUnits & filterUnits handled in all cases)
        - WKDisplacmentMap.cikernel incorrectly flipped the y-axis.
        - Correctly specify default values for all filter primitives in ksvg2/svg!
        - Initialize all variables of the SVGFE* classes in platform/graphics/svg/filters.
        - Fix 'flood-color' initial value (was set to the _stop_ color initial value)
          -> both initial values were pointing to 'black' though, so it was no visible problem.
        - Parse 'lighting-color' css property, no more hacking in SVGFEDiffuseLighting.
          -> Correct it's initial from black to white value fixes SVG lighting filters!
        - Add diffuseConstant support to feDiffuseLighting filter.
        - Centralize manual style resolution (needed for stop-color, flood-color & flood-opacity, lighting-color)

        * ksvg2/css/SVGCSSParser.cpp:
        * ksvg2/css/SVGCSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applySVGProperty):
        * ksvg2/css/SVGRenderStyle.h:
        * ksvg2/css/SVGRenderStyleDefs.cpp:
        (StyleMiscData::StyleMiscData):
        (StyleMiscData::operator==):
        * ksvg2/css/SVGRenderStyleDefs.h:
        * ksvg2/svg/SVGComponentTransferFunctionElement.cpp:
        (WebCore::SVGComponentTransferFunctionElement::SVGComponentTransferFunctionElement):
        * ksvg2/svg/SVGFEBlendElement.cpp:
        (WebCore::SVGFEBlendElement::SVGFEBlendElement):
        (WebCore::SVGFEBlendElement::filterEffect):
        * ksvg2/svg/SVGFEBlendElement.h:
        * ksvg2/svg/SVGFEColorMatrixElement.cpp:
        (WebCore::SVGFEColorMatrixElement::SVGFEColorMatrixElement):
        (WebCore::SVGFEColorMatrixElement::filterEffect):
        * ksvg2/svg/SVGFEColorMatrixElement.h:
        * ksvg2/svg/SVGFEComponentTransferElement.cpp:
        (WebCore::SVGFEComponentTransferElement::filterEffect):
        * ksvg2/svg/SVGFEComponentTransferElement.h:
        * ksvg2/svg/SVGFECompositeElement.cpp:
        (WebCore::SVGFECompositeElement::SVGFECompositeElement):
        (WebCore::SVGFECompositeElement::parseMappedAttribute):
        (WebCore::SVGFECompositeElement::filterEffect):
        * ksvg2/svg/SVGFECompositeElement.h:
        * ksvg2/svg/SVGFEDiffuseLightingElement.cpp:
        (WebCore::SVGFEDiffuseLightingElement::SVGFEDiffuseLightingElement):
        (WebCore::SVGFEDiffuseLightingElement::parseMappedAttribute):
        (WebCore::SVGFEDiffuseLightingElement::filterEffect):
        * ksvg2/svg/SVGFEDiffuseLightingElement.h:
        * ksvg2/svg/SVGFEDisplacementMapElement.cpp:
        (WebCore::SVGFEDisplacementMapElement::SVGFEDisplacementMapElement):
        (WebCore::SVGFEDisplacementMapElement::filterEffect):
        * ksvg2/svg/SVGFEDisplacementMapElement.h:
        * ksvg2/svg/SVGFEDistantLightElement.cpp:
        (WebCore::SVGFEDistantLightElement::SVGFEDistantLightElement):
        * ksvg2/svg/SVGFEDistantLightElement.h:
        * ksvg2/svg/SVGFEFloodElement.cpp:
        (WebCore::SVGFEFloodElement::filterEffect):
        * ksvg2/svg/SVGFEFloodElement.h:
        * ksvg2/svg/SVGFEFuncAElement.cpp:
        * ksvg2/svg/SVGFEFuncAElement.h:
        * ksvg2/svg/SVGFEFuncBElement.cpp:
        * ksvg2/svg/SVGFEFuncBElement.h:
        * ksvg2/svg/SVGFEFuncGElement.cpp:
        (WebCore::SVGFEFuncGElement::SVGFEFuncGElement):
        * ksvg2/svg/SVGFEFuncGElement.h:
        * ksvg2/svg/SVGFEFuncRElement.cpp:
        * ksvg2/svg/SVGFEFuncRElement.h:
        * ksvg2/svg/SVGFEGaussianBlurElement.cpp:
        (WebCore::SVGFEGaussianBlurElement::filterEffect):
        * ksvg2/svg/SVGFEGaussianBlurElement.h:
        * ksvg2/svg/SVGFEImageElement.cpp:
        (WebCore::SVGFEImageElement::notifyFinished):
        (WebCore::SVGFEImageElement::filterEffect):
        * ksvg2/svg/SVGFEImageElement.h:
        * ksvg2/svg/SVGFELightElement.cpp:
        (WebCore::SVGFELightElement::SVGFELightElement):
        * ksvg2/svg/SVGFELightElement.h:
        * ksvg2/svg/SVGFEMergeElement.cpp:
        (WebCore::SVGFEMergeElement::filterEffect):
        * ksvg2/svg/SVGFEMergeElement.h:
        * ksvg2/svg/SVGFEMergeNodeElement.cpp:
        * ksvg2/svg/SVGFEMergeNodeElement.h:
        * ksvg2/svg/SVGFEOffsetElement.cpp:
        (WebCore::SVGFEOffsetElement::filterEffect):
        * ksvg2/svg/SVGFEOffsetElement.h:
        * ksvg2/svg/SVGFEPointLightElement.h:
        * ksvg2/svg/SVGFESpecularLightingElement.cpp:
        (WebCore::SVGFESpecularLightingElement::SVGFESpecularLightingElement):
        (WebCore::SVGFESpecularLightingElement::parseMappedAttribute):
        (WebCore::SVGFESpecularLightingElement::filterEffect):
        (WebCore::SVGFESpecularLightingElement::updateLights):
        * ksvg2/svg/SVGFESpecularLightingElement.h:
        * ksvg2/svg/SVGFESpotLightElement.cpp:
        (WebCore::SVGFESpotLightElement::lightSource):
        * ksvg2/svg/SVGFESpotLightElement.h:
        * ksvg2/svg/SVGFETileElement.cpp:
        (WebCore::SVGFETileElement::filterEffect):
        * ksvg2/svg/SVGFETileElement.h:
        * ksvg2/svg/SVGFETurbulenceElement.cpp:
        (WebCore::SVGFETurbulenceElement::SVGFETurbulenceElement):
        (WebCore::SVGFETurbulenceElement::filterEffect):
        * ksvg2/svg/SVGFETurbulenceElement.h:
        * ksvg2/svg/SVGFilterElement.cpp:
        (WebCore::SVGFilterElement::canvasResource):
        * ksvg2/svg/SVGFilterElement.h:
        * ksvg2/svg/SVGFilterPrimitiveStandardAttributes.cpp:
        (WebCore::SVGFilterPrimitiveStandardAttributes::SVGFilterPrimitiveStandardAttributes):
        (WebCore::SVGFilterPrimitiveStandardAttributes::setStandardAttributes):
        * ksvg2/svg/SVGFilterPrimitiveStandardAttributes.h:
        * ksvg2/svg/SVGGradientElement.cpp:
        (WebCore::SVGGradientElement::buildStops):
        * ksvg2/svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::resolveStyle):
        * ksvg2/svg/SVGStyledElement.h:
        * platform/graphics/svg/SVGResourceFilter.cpp:
        (WebCore::SVGResourceFilter::addFilterEffect):
        (WebCore::SVGResourceFilter::filterBBoxForItemBBox):
        * platform/graphics/svg/SVGResourceFilter.h:
        (WebCore::SVGResourceFilter::xBoundingBoxMode):
        (WebCore::SVGResourceFilter::setXBoundingBoxMode):
        (WebCore::SVGResourceFilter::yBoundingBoxMode):
        (WebCore::SVGResourceFilter::setYBoundingBoxMode):
        * platform/graphics/svg/cg/SVGResourceFilterCg.mm:
        (WebCore::SVGResourceFilter::SVGResourceFilter):
        (WebCore::SVGResourceFilter::createFilterEffect):
        (WebCore::SVGResourceFilter::prepareFilter):
        (WebCore::dumpOutputImage):
        (WebCore::SVGResourceFilter::applyFilter):
        (WebCore::SVGResourceFilter::getCIFilterStack):
        (WebCore::SVGResourceFilter::imageForName):
        (WebCore::SVGResourceFilter::setImageForName):
        (WebCore::SVGResourceFilter::setOutputImage):
        (WebCore::alphaImageForImage):
        (WebCore::SVGResourceFilter::inputImage):
        * platform/graphics/svg/filters/SVGDistantLightSource.h:
        * platform/graphics/svg/filters/SVGFEBlend.cpp:
        (WebCore::SVGFEBlend::SVGFEBlend):
        * platform/graphics/svg/filters/SVGFEBlend.h:
        * platform/graphics/svg/filters/SVGFEColorMatrix.cpp:
        (WebCore::SVGFEColorMatrix::SVGFEColorMatrix):
        * platform/graphics/svg/filters/SVGFEColorMatrix.h:
        * platform/graphics/svg/filters/SVGFEComponentTransfer.cpp:
        (WebCore::SVGFEComponentTransfer::SVGFEComponentTransfer):
        * platform/graphics/svg/filters/SVGFEComponentTransfer.h:
        (WebCore::SVGComponentTransferFunction::SVGComponentTransferFunction):
        * platform/graphics/svg/filters/SVGFEComposite.cpp:
        (WebCore::SVGFEComposite::SVGFEComposite):
        * platform/graphics/svg/filters/SVGFEComposite.h:
        * platform/graphics/svg/filters/SVGFEConvolveMatrix.cpp:
        (WebCore::SVGFEConvolveMatrix::SVGFEConvolveMatrix):
        * platform/graphics/svg/filters/SVGFEConvolveMatrix.h:
        * platform/graphics/svg/filters/SVGFEDiffuseLighting.cpp:
        (WebCore::SVGFEDiffuseLighting::SVGFEDiffuseLighting):
        * platform/graphics/svg/filters/SVGFEDiffuseLighting.h:
        * platform/graphics/svg/filters/SVGFEDisplacementMap.cpp:
        (WebCore::SVGFEDisplacementMap::SVGFEDisplacementMap):
        * platform/graphics/svg/filters/SVGFEDisplacementMap.h:
        * platform/graphics/svg/filters/SVGFEFlood.cpp:
        (WebCore::SVGFEFlood::SVGFEFlood):
        * platform/graphics/svg/filters/SVGFEFlood.h:
        * platform/graphics/svg/filters/SVGFEGaussianBlur.cpp:
        (WebCore::SVGFEGaussianBlur::SVGFEGaussianBlur):
        * platform/graphics/svg/filters/SVGFEGaussianBlur.h:
        * platform/graphics/svg/filters/SVGFEImage.cpp:
        (WebCore::SVGFEImage::SVGFEImage):
        * platform/graphics/svg/filters/SVGFEImage.h:
        * platform/graphics/svg/filters/SVGFEMerge.cpp:
        * platform/graphics/svg/filters/SVGFEMerge.h:
        (WebCore::SVGFEMerge::SVGFEMerge):
        * platform/graphics/svg/filters/SVGFEMorphology.cpp:
        (WebCore::SVGFEMorphology::SVGFEMorphology):
        * platform/graphics/svg/filters/SVGFEMorphology.h:
        * platform/graphics/svg/filters/SVGFEOffset.cpp:
        (WebCore::SVGFEOffset::SVGFEOffset):
        * platform/graphics/svg/filters/SVGFEOffset.h:
        * platform/graphics/svg/filters/SVGFESpecularLighting.cpp:
        (WebCore::SVGFESpecularLighting::SVGFESpecularLighting):
        * platform/graphics/svg/filters/SVGFESpecularLighting.h:
        * platform/graphics/svg/filters/SVGFETile.h:
        (WebCore::SVGFETile::SVGFETile):
        * platform/graphics/svg/filters/SVGFETurbulence.cpp:
        (WebCore::SVGFETurbulence::SVGFETurbulence):
        * platform/graphics/svg/filters/SVGFETurbulence.h:
        * platform/graphics/svg/filters/SVGFilterEffect.cpp:
        (WebCore::SVGFilterEffect::SVGFilterEffect):
        (WebCore::SVGFilterEffect::primitiveBBoxForFilterBBox):
        (WebCore::SVGFilterEffect::filter):
        (WebCore::SVGFilterEffect::setFilter):
        * platform/graphics/svg/filters/SVGFilterEffect.h:
        (WebCore::SVGFilterEffect::xBoundingBoxMode):
        (WebCore::SVGFilterEffect::setXBoundingBoxMode):
        (WebCore::SVGFilterEffect::yBoundingBoxMode):
        (WebCore::SVGFilterEffect::setYBoundingBoxMode):
        (WebCore::SVGFilterEffect::widthBoundingBoxMode):
        (WebCore::SVGFilterEffect::setWidthBoundingBoxMode):
        (WebCore::SVGFilterEffect::heightBoundingBoxMode):
        (WebCore::SVGFilterEffect::setHeightBoundingBoxMode):
        * platform/graphics/svg/filters/SVGLightSource.cpp:
        * platform/graphics/svg/filters/SVGLightSource.h:
        * platform/graphics/svg/filters/SVGPointLightSource.h:
        (WebCore::SVGPointLightSource::SVGPointLightSource):
        * platform/graphics/svg/filters/SVGSpotLightSource.h:
        (WebCore::SVGSpotLightSource::SVGSpotLightSource):
        * platform/graphics/svg/filters/cg/SVGFEBlendCg.mm:
        (WebCore::SVGFEBlend::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEColorMatrixCg.mm:
        (WebCore::SVGFEColorMatrix::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEComponentTransferCg.mm:
        (WebCore::filterForComponentFunc):
        (WebCore::SVGFEComponentTransfer::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFECompositeCg.mm:
        (WebCore::SVGFEComposite::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEDiffuseLightingCg.mm:
        (WebCore::SVGFEDiffuseLighting::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEDisplacementMapCg.mm:
        (WebCore::SVGFEDisplacementMap::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEFloodCg.mm:
        (WebCore::SVGFEFlood::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEGaussianBlurCg.mm:
        (WebCore::SVGFEGaussianBlur::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEHelpersCg.h:
        * platform/graphics/svg/filters/cg/SVGFEImageCg.mm:
        (WebCore::SVGFEImage::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEMergeCg.mm:
        (WebCore::SVGFEMerge::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFEOffsetCg.mm:
        (WebCore::SVGFEOffset::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFESpecularLightingCg.mm:
        (WebCore::SVGFESpecularLighting::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFETileCg.mm:
        (WebCore::SVGFETile::getCIFilter):
        * platform/graphics/svg/filters/cg/SVGFilterEffectCg.mm:
        (WebCore::SVGFilterEffect::getCIFilter):
        * platform/graphics/svg/filters/cg/WKDiffuseLightingFilter.cikernel:
        * platform/graphics/svg/filters/cg/WKDisplacementMapFilter.cikernel:
        * platform/graphics/svg/filters/cg/WKSpotLightFilter.m:
        (-[WKSpotLightFilter outputImage]):
        * platform/graphics/svg/qt/SVGResourceFilterQt.cpp:
        (WebCore::SVGResourceFilter::createFilterEffect):

2007-08-20  Rob Buis  <buis@kde.org>

        Reviewed by Nikolas.

        http://bugs.webkit.org/show_bug.cgi?id=14924
        rotated rect with pattern draws incorrectly

        Use the bounding box before transformation.

        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        (WebCore::SVGPaintServerPattern::setup):

2007-08-19  Rob Buis  <buis@kde.org>

        Reviewed by Nikolas.

        http://bugs.webkit.org/show_bug.cgi?id=14926
        WebKit has 'em' length handling problems related to CSS properties

        Parse the properties in inline style attributes non-strict for SVG.

        * dom/StyledElement.cpp:
        (WebCore::StyledElement::createInlineStyleDecl):

2007-08-17  Rob Buis  <buis@kde.org>

        Reviewed by Oliver.

        http://bugs.webkit.org/show_bug.cgi?id=14927
        use element in SVG does not render after parent is displayed off and on

        Also detach the shadow tree when detaching the <use>.

        * ksvg2/svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::detach):
        * ksvg2/svg/SVGUseElement.h:

2007-08-10  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Rob.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=14153

        Final, long-awaited RenderSVGContainer split. Make RenderSVGContainer really a simple
        container without special cases for inner <svg> elements or <marker>. Create a new
        RenderSVGViewportContainer class handling these cases now.

        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/svg/SVGMarkerElement.cpp:
        (WebCore::SVGMarkerElement::createRenderer):
        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::createRenderer):
        * ksvg2/svg/SVGSVGElement.h:
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::layout):
        (WebCore::RenderSVGContainer::applyContentTransforms):
        (WebCore::RenderSVGContainer::applyAdditionalTransforms):
        (WebCore::RenderSVGContainer::paint):
        (WebCore::RenderSVGContainer::viewportTransform):
        (WebCore::RenderSVGContainer::relativeBBox):
        (WebCore::RenderSVGContainer::nodeAtPoint):
        * rendering/RenderSVGContainer.h:
        * rendering/RenderSVGRoot.cpp:
        * rendering/RenderSVGViewportContainer.cpp: Added.
        (WebCore::RenderSVGViewportContainer::RenderSVGViewportContainer):
        (WebCore::RenderSVGViewportContainer::~RenderSVGViewportContainer):
        (WebCore::RenderSVGViewportContainer::layout):
        (WebCore::RenderSVGViewportContainer::paint):
        (WebCore::RenderSVGViewportContainer::applyContentTransforms):
        (WebCore::RenderSVGViewportContainer::applyAdditionalTransforms):
        (WebCore::RenderSVGViewportContainer::viewport):
        (WebCore::RenderSVGViewportContainer::calcViewport):
        (WebCore::RenderSVGViewportContainer::viewportTransform):
        (WebCore::RenderSVGViewportContainer::absoluteTransform):
        (WebCore::RenderSVGViewportContainer::nodeAtPoint):
        * rendering/RenderSVGViewportContainer.h: Added.
        (WebCore::RenderSVGViewportContainer::isSVGContainer):
        (WebCore::RenderSVGViewportContainer::renderName):

2007-08-10  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver & Rob.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=12501 (SVG Text fails to respect opacity, fill-opacity and stroke-opacity)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=14045 (Incorrect support for opacity, fill-opacity and stroke-opacity)

        Based on an older patch from Rob, this fixes SVG text opacity as well as group opacity for solid fills & gradients.
        The pattern changes are still missing a testcase (need to wait for Antoine Quint for that).

        * platform/graphics/svg/SVGResourceFilter.h:
        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::setup):
        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        (WebCore::SVGPaintServerPattern::setup):
        * platform/graphics/svg/cg/SVGPaintServerSolidCg.cpp:
        (WebCore::colorFromFloatComponents):
        (WebCore::SVGPaintServerSolid::setup):
        * platform/graphics/svg/cg/SVGResourceFilterCg.mm:
        (WebCore::SVGResourceFilter::SVGResourceFilter):
        (WebCore::SVGResourceFilter::prepareFilter):
        (WebCore::SVGResourceFilter::applyFilter):
        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::paint):
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::paint):
        (WebCore::RenderSVGContainer::absoluteClippedOverflowRect):
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::paint):
        (WebCore::RenderSVGImage::absoluteClippedOverflowRect):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::paint):
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::absoluteClippedOverflowRect):
        * rendering/SVGRenderSupport.cpp:
        (WebCore::prepareToRenderSVGContent):
        (WebCore::finishRenderSVGContent):
        * rendering/SVGRenderSupport.h:
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::prepareTextRendering):
        (WebCore::SVGRootInlineBox::paint):
        (WebCore::SVGRootInlineBox::paintChildInlineFlowBox):

2007-08-08  Rob Buis  <buis@kde.org>

        Reviewed by Nikolas.

        http://bugs.webkit.org/show_bug.cgi?id=11909
        Regression: large SVG from Illustrator comes out blank

        Fix last issue with the Illustrator file by making relativeBBox
        calculation take into account viewBox.

        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::relativeBBox):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::relativeBBox):

2007-08-08  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=14896 (SVG InlineText/Flow box sizes don't take rotated glyphs into account)

        Introduce new helper function calculateGlyphBoundaries, which takes into account any per-character transformation.
        This fixes box size calculations in svg/W3C-SVG-1.1/text-text-07-t.svg, svg/batik/text/textEffect3.svg (rotated glyphs)
        -> These strings can be properly selected now, just as well as text path elements.

        * rendering/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::calculateGlyphBoundaries):
        (WebCore::SVGInlineTextBox::closestCharacterToPosition):
        (WebCore::SVGInlineTextBox::nodeAtPoint):
        (WebCore::SVGInlineTextBox::selectionRect):
        * rendering/SVGInlineTextBox.h:
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBox::layoutInlineBoxes):

2007-08-08  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=13909 (SVG text selection doesn't work with RTL text)

        Use drawHighlightForText() to draw the selection, instead of my home-brewn solution.
        Affected code in SVGRootInlineBox::paintSelectionForTextBox. Removed not anymore needed
        helper function cummulatedWidthOfSelectionRange.

        Dump all contained InlineTextBox(es) in SVGRenderTreeAsText, take into account multiple
        child text boxes in ie. a RenderSVGInlineText objects (which happens for RTL text and
        LTR text cases where newlines were involved - see changed testcase results.)
        This affects a lot of LTR tests which actually had more than one child text box, that
        wasn't taken properly into account before (in terms of selection, not rendering.)

        Fix selection for RTL text by taking box start offsets into account in closestCharacterToPosition()
        and by offering RTL text selection special cases in svgCharacterHitsPosition().

        Centralized the creation of a TextStyle object for text selection/painting in a new helper function
        svgTextStyleForInlineTextBox. Add new helper functions calculateGlyphWidth/calculateGlyphHeight to
        centralize these calculations -> use these new helpers everywhere to avoid code duplication.

        A single fix in bidi.cpp was needed to fix SVG's unicode-bidi/direction handling, to fix text-intro-02-b.svg.
        SVG didacts that the 'direction' attribute is ignored if unicode-bidi is set to 'normal' (default).
        Discussed with Mitz.

        * rendering/RenderSVGInlineText.cpp:
        (WebCore::RenderSVGInlineText::positionForCoordinates):
        * rendering/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::calculateGlyphWidth):
        (WebCore::SVGInlineTextBox::calculateGlyphHeight):
        (WebCore::SVGInlineTextBox::closestCharacterToPosition):
        (WebCore::SVGInlineTextBox::svgCharacterHitsPosition):
        (WebCore::SVGInlineTextBox::nodeAtPoint):
        (WebCore::SVGInlineTextBox::selectionRect):
        * rendering/SVGInlineTextBox.h:
        * rendering/SVGRenderTreeAsText.cpp:
        (WebCore::writeSVGInlineTextBox):
        (WebCore::writeSVGInlineText):
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::cummulatedWidthOfInlineBoxCharacterRange): Take box start offset into account.
        (WebCore::svgTextStyleForInlineTextBox): New helper function.
        (WebCore::totalAdvanceOfInlineTextBox): Take box start offset into account.
        (WebCore::SVGRootInlineBox::buildLayoutInformationForTextBox): Ditto. (correctly calculate advance values in RTL mode!)
        (WebCore::SVGRootInlineBox::paintSelectionForTextBox): Use GraphicsContext drawHighlightForText() instead of self-made hacks.
        (WebCore::SVGRootInlineBox::paintCharacterRangeForTextBox): Use new helper function svgTextStyleForInlineTextBox.
        * rendering/SVGRootInlineBox.h:
        * rendering/bidi.cpp: Add special case for SVG.
        (WebCore::RenderBlock::layoutInlineChildren):

2007-07-30  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver & Rob.

        Enable SVG textPath selection. Actually build chunks for them instead of
        ignoring them - was easier than I thought. Respect per-character transformation
        when calculating the chunk boundaries for the selection rectangles. Also fixes
        selection rect drawing of rotated characters.

        Next thing todo is to unify the glyph size calculations, as per-glyph transformations
        are not respected when calculating flow box sizes in SVGRootInlineBox.
 
        * rendering/RenderObject.h:
        (WebCore::RenderObject::isSVGHiddenContainer):
        * rendering/RenderSVGHiddenContainer.h:
        (WebCore::RenderSVGHiddenContainer::isSVGHiddenContainer):
        * rendering/RenderSVGInlineText.cpp:
        (WebCore::isChildOfHiddenContainer):
        (WebCore::RenderSVGInlineText::selectionRect):
        (WebCore::RenderSVGInlineText::computeAbsoluteRectForRange):
        * rendering/SVGCharacterLayoutInfo.h:
        (WebCore::SVGTextChunk::SVGTextChunk):
        (WebCore::SVGTextChunkLayoutInfo::SVGTextChunkLayoutInfo):
        * rendering/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::selectionRect):
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::applyTextAnchorToTextChunk):
        (WebCore::SVGRootInlineBox::buildTextChunks):

2007-07-25  Rob Buis  <buis@kde.org>

        Reviewed by Nikolas.

        http://bugs.webkit.org/show_bug.cgi?id=14312
        Removing an attribute has no effect on SVG

        Update the transform matrix also when transform attribute is empty.

        * ksvg2/svg/SVGStyledTransformableElement.cpp:
        (WebCore::SVGStyledTransformableElement::updateLocalTransform):

2007-07-26  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Unify absoluteRects() of RenderSVGTSpan & RenderSVGTextPath.
        The RenderSVGTextPath one was still using the old, wrong concept.

        * rendering/RenderSVGTSpan.cpp: Remove unused params tx, ty, while I'm at it.
        (WebCore::RenderSVGTSpan::absoluteRects):
        * rendering/RenderSVGTextPath.cpp:
        (WebCore::RenderSVGTextPath::absoluteRects):

2007-07-25  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Sam.

        Let <textPath> be recognized within the ObjC bindings.
        Forgot to add that months ago.

        * bindings/objc/DOM.mm:
        (WebCore::createElementClassMap):
        * bindings/objc/DOMInternal.h:
        * bindings/objc/DOMSVG.h:

2007-07-25  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=14065

        Fix all known bugs regarding to SVG text selection, when embedded in XHTML.
        Also fix inspecting <text> elements when embedded in XHTML. (WebInspector)

        Short story: selectionRect() & friends are special in terms of the "HTML parent translation".
        Caused by ie. CSS translation like "left: 50px; top: 50px" when <svg> is a child of a <div>.
        For non-textual objects like RenderPath, we can easily add a translation to a new coordinate
        space in RenderSVGRoot::applyContentTransformations() and we're done with it.

        Same for painting text, but text selection makes problems in this concept.
        We have to remove the 'html parent translation' from our selection rects that we return
        from RenderSVGText & RenderSVGInlineText. Hopefully all issues are fixed now.

        Long story:
        - RenderSVGRoot::nodeAtPoint didn't take the parent 'scroll offset' into account. We exited
          too early, because the overflow rect wasn't correctly sized. Fixed.
        - RenderSVGRoot::absoluteRects() can't return the absoluteClippedOverflowRect() as it includes
          the 'html parent translation', which needs to be removed, otherwhise the painted rects are off
          when inspecting with WebInspector. -> Pass down absoluteRects() call to it's children..
        - RenderSVGText::absoluteRects() can't use absoluteClippedOverflowRect() for the same reason.
        - Add RenderSVGInlineText::computeAbsoluteRectForRange() function - shared by absoluteRects() and
          selectionRect() - and remove the 'html parent translation' there by asking the RenderSVGRoot
          object for the correct offsets.

        This lead to nasty bugs showing that SVGInlineTextBox::selectionRect() wasn't actually returning
        correct rectangles. It couldn't work for text chunks the way it was implemented. Fixed by implementing
        it exactly the same way that closestCharacterToPosition() was done - could share more code later on.

        * rendering/RenderSVGInlineText.cpp:
        (WebCore::RenderSVGInlineText::absoluteRects):
        (WebCore::RenderSVGInlineText::selectionRect):
        (WebCore::RenderSVGInlineText::computeAbsoluteRectForRange):
        * rendering/RenderSVGInlineText.h:
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::absoluteRects):
        (WebCore::RenderSVGRoot::nodeAtPoint):
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::absoluteRects):
        * rendering/SVGCharacterLayoutInfo.h: Removed unused variable 'bool selected'
        * rendering/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::closestCharacterToPosition):
        (WebCore::SVGInlineTextBox::nodeAtPoint):
        (WebCore::SVGInlineTextBox::selectionRect):
        * rendering/SVGRootInlineBox.cpp: Add 'findSVGRootObject' helper function.
        (WebCore::findSVGRootObject):
        (WebCore::SVGRootInlineBox::buildLayoutInformationForTextBox):
        (WebCore::SVGRootInlineBox::paintSelectionForTextBox): Remove unused tx/ty parameters.
        (WebCore::SVGRootInlineBox::paintChildInlineTextBox):
        (WebCore::SVGRootInlineBox::paintCharacterRangeForTextBox):
        * rendering/SVGRootInlineBox.h:

2007-07-17  Nikolas Zimmermann  <zimmermann@kde.org>

        Build fix. Not reviewed.

        Rob forgot to land the changes to SVGResourceMarker in his last commit.

        * platform/graphics/svg/SVGResourceMarker.cpp:
        (WebCore::SVGResourceMarker::draw):

2007-07-17  Rob Buis  <buis@kde.org>

        Reviewed by Nikolas.

        http://bugs.webkit.org/show_bug.cgi?id=5996
        SVG <view> is unimplemented

        Implement <view> and refactor the code in the svg renderer container classes.

        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/svg/SVGDocument.cpp:
        (WebCore::SVGDocument::zoomAndPanEnabled): Take into account currentView for zoom/pan
        * ksvg2/svg/SVGDocument.h:
        * ksvg2/svg/SVGFEImageElement.cpp:
        (WebCore::SVGFEImageElement::parseMappedAttribute):
        * ksvg2/svg/SVGFitToViewBox.cpp:
        (WebCore::SVGFitToViewBox::parseViewBox):
        (WebCore::SVGFitToViewBox::parseMappedAttribute):
        * ksvg2/svg/SVGFitToViewBox.h:
        * ksvg2/svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::parseMappedAttribute):
        * ksvg2/svg/SVGLocatable.h:
        * ksvg2/svg/SVGMarkerElement.cpp:
        (WebCore::SVGMarkerElement::createRenderer):
        (WebCore::SVGMarkerElement::notifyAttributeChange):
        * ksvg2/svg/SVGPreserveAspectRatio.cpp:
        (WebCore::SVGPreserveAspectRatio::parsePreserveAspectRatio):
        * ksvg2/svg/SVGPreserveAspectRatio.h:
        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::SVGSVGElement):
        (WebCore::SVGSVGElement::currentView):
        (WebCore::SVGSVGElement::parseMappedAttribute):
        (WebCore::SVGSVGElement::createRenderer):
        (WebCore::SVGSVGElement::viewBoxToViewTransform):
        (WebCore::SVGSVGElement::inheritViewAttributes):
        * ksvg2/svg/SVGSVGElement.h:
        * ksvg2/svg/SVGTransformable.cpp:
        (WebCore::SVGTransformable::parseTransformAttribute):
        * ksvg2/svg/SVGTransformable.h:
        * ksvg2/svg/SVGViewElement.cpp:
        (WebCore::SVGViewElement::parseMappedAttribute):
        * ksvg2/svg/SVGViewElement.h:
        * ksvg2/svg/SVGViewSpec.cpp: Added.
        (WebCore::SVGViewSpec::SVGViewSpec):
        (WebCore::SVGViewSpec::~SVGViewSpec):
        (WebCore::SVGViewSpec::setTransform):
        (WebCore::SVGViewSpec::setViewBoxString):
        (WebCore::SVGViewSpec::setPreserveAspectRatioString):
        (WebCore::SVGViewSpec::setViewTargetString):
        (WebCore::SVGViewSpec::viewTarget):
        (WebCore::SVGViewSpec::contextElement):
        (WebCore::):
        (WebCore::SVGViewSpec::parseViewSpec):
        * ksvg2/svg/SVGViewSpec.h: Added.
        (WebCore::SVGViewSpec::transform):
        (WebCore::SVGViewSpec::viewTargetString):
        * ksvg2/svg/SVGZoomAndPan.cpp:
        (WebCore::SVGZoomAndPan::parseMappedAttribute):
        (WebCore::):
        (WebCore::SVGZoomAndPan::parseZoomAndPan):
        * ksvg2/svg/SVGZoomAndPan.h:
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::gotoAnchor):
        * page/Frame.cpp:
        (WebCore::Frame::setZoomFactor): do not zoom when it is disabled
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::RenderSVGContainer):
        (WebCore::RenderSVGContainer::paint):
        (WebCore::RenderSVGContainer::viewportTransform):
        * rendering/RenderSVGContainer.h:
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::RenderSVGRoot):
        (WebCore::RenderSVGRoot::applyContentTransforms):
        (WebCore::RenderSVGRoot::paint):
        (WebCore::RenderSVGRoot::absoluteTransform):
        (WebCore::RenderSVGRoot::localTransform):
        * rendering/RenderSVGRoot.h:

2007-07-16  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Rob.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=13611 (Crash in setAttributeNS setting href of SVG <use> to nonexistent symbol)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=14631 (<use> doesn't deep-expand <symbol> elements.)

        Rework <use> on <foreignObject> cases, to not just ignore these cases, but actually proceed and skip <fO> objects
        from the resulting cloned tree. This fixes parts of "treasure_map.svg" (no bug report availabe on that one, private "testcase").

        Fix assertion happening with <use> on <g> containing <symbol>. Introduce expandSymbolElementsInShadowTree()
        concept, just like it's done for <use> on <use>, to deep-replace all <symbol> elements by <svg>, as demanded
        by the spec. This only worked on <use> on <symbol> direct cases so far.

        Added testcase: svg/custom/use-on-g-containing-foreignObject-and-image.svg (testcase for treasure_map.svg)
                        svg/custom/use-on-disallowed-foreign-object-5.svg (<use> on <symbol> containg <foreignObject>)
                        svg/custom/use-on-disallowed-foreign-object-6.svg (<use> on <g> containing <svg> containing <foreignObject>)
                        svg/custom/use-on-disallowed-foreign-object-7.svg (<use> on <g> containing <symbol> containing <foreignObject>)
                        svg/custom/use-scripting-changes-to-nonexistant-href.svg

        * ksvg2/svg/SVGUseElement.cpp:
        (WebCore::isDisallowedElement):
        (WebCore::subtreeContainsDisallowedElement):
        (WebCore::SVGUseElement::buildPendingResource):
        (WebCore::SVGUseElement::buildInstanceTree):
        (WebCore::SVGUseElement::removeDisallowedElementsFromSubtree):
        (WebCore::SVGUseElement::buildShadowTree):
        (WebCore::SVGUseElement::expandUseElementsInShadowTree):
        (WebCore::SVGUseElement::expandSymbolElementsInShadowTree):
        * ksvg2/svg/SVGUseElement.h:

2007-07-15  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Rob.

        Fix invisible-text-after-scrolling.xhtml regression. Scroll offset not
        taken into account properly. Also fix RenderSVGInlineText::selectionRect(),
        so that SVG text can be selected, when being embedded in XHTML.

        * rendering/RenderSVGInlineText.cpp:
        (WebCore::RenderSVGInlineText::selectionRect):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::applyContentTransforms):

2007-07-15  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=5940 (<svg> inside <body> incorrectly extends over top/bottom borders)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=14145 (RenderSVGContainer should not inherit from RenderContainer)

        Make RenderSVGContainer inherit from RenderObject directly, instead of RenderContainer.
        Itdoes a lot of things that we don't need for SVG, and by removing this inheritance
        we can finally fix the differences about SVG object positioning, as we don't need
        parent translation (tx/ty). Fixes SVG text rendering within XHTML.

        Fix requireLayer() function on RenderSVGRoot, as it can actually be a layer now.
        This change is based on Rob's patch at 5940 - fixing z-order indexing.

        Change RenderSVGRoot renderName() and update all layout tests, because of this change.
        
        Fix absoluteRects() function for RenderSVGInlineText & RenderSVGTSpan.
        Checked extensively using WebInspector, to assure all rects are correctly displayed.

        Testcases fixed: junk-data.svg, missing-xlink.svg hixie/013.xml (all regressions!)
        (junk-data.svg & missing-xlink.svg previously relied on SVG text painting out of <svg> overflow rect.
         Fix these testcases, as within this new RenderSVGContainer concept, that bug is now fixed, and breaks them)

        Testcases added: custom/absolute-sized-svg-in-xhtml.xhtml, custom/inline-svg-in-xhtml.xml (Mozilla XTech demo)

        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::parseMappedAttribute):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::containingBlock):
        * rendering/RenderObject.h:
        (WebCore::RenderObject::isSVGRoot):
        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::paint):
        (WebCore::RenderPath::addFocusRingRects):
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::RenderSVGContainer):
        (WebCore::RenderSVGContainer::canHaveChildren):
        (WebCore::RenderSVGContainer::addChild):
        (WebCore::RenderSVGContainer::removeChild):
        (WebCore::RenderSVGContainer::destroy):
        (WebCore::RenderSVGContainer::destroyLeftoverChildren):
        (WebCore::RenderSVGContainer::removeChildNode):
        (WebCore::RenderSVGContainer::appendChildNode):
        (WebCore::RenderSVGContainer::insertChildNode):
        (WebCore::RenderSVGContainer::layout):
        (WebCore::RenderSVGContainer::calcReplacedWidth):
        (WebCore::RenderSVGContainer::calcReplacedHeight):
        (WebCore::RenderSVGContainer::applyContentTransforms):
        (WebCore::RenderSVGContainer::paint):
        (WebCore::RenderSVGContainer::absoluteTransform):
        (WebCore::RenderSVGContainer::nodeAtPoint):
        * rendering/RenderSVGContainer.h:
        (WebCore::RenderSVGContainer::firstChild):
        (WebCore::RenderSVGContainer::lastChild):
        (WebCore::RenderSVGContainer::width):
        (WebCore::RenderSVGContainer::height):
        (WebCore::RenderSVGContainer::moveChildNode):
        (WebCore::RenderSVGContainer::calcPrefWidths):
        * rendering/RenderSVGHiddenContainer.cpp:
        (WebCore::RenderSVGHiddenContainer::RenderSVGHiddenContainer):
        (WebCore::RenderSVGHiddenContainer::paint):
        (WebCore::RenderSVGHiddenContainer::absoluteRects):
        (WebCore::RenderSVGHiddenContainer::relativeBBox):
        * rendering/RenderSVGHiddenContainer.h:
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::paint):
        * rendering/RenderSVGInline.cpp:
        (WebCore::RenderSVGInline::RenderSVGInline):
        * rendering/RenderSVGInlineText.cpp:
        (WebCore::RenderSVGInlineText::absoluteRects):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::applyContentTransforms):
        (WebCore::RenderSVGRoot::paint):
        (WebCore::RenderSVGRoot::addFocusRingRects):
        * rendering/RenderSVGRoot.h:
        (WebCore::RenderSVGRoot::isSVGRoot):
        (WebCore::RenderSVGRoot::renderName):
        * rendering/RenderSVGTSpan.cpp:
        (WebCore::RenderSVGTSpan::RenderSVGTSpan):
        (WebCore::RenderSVGTSpan::absoluteRects):
        * rendering/RenderSVGTextPath.cpp:
        (WebCore::RenderSVGTextPath::absoluteRects):
        * rendering/RenderTreeAsText.cpp:
        (WebCore::write):
        * rendering/SVGRenderTreeAsText.cpp:
        (WebCore::operator<<):
        (WebCore::write):
        * rendering/SVGRenderTreeAsText.h:

2007-07-11  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Sam.

        Remove all "SVGElement* m_context" parameters spread over SVG primitives
        (like SVGAngle, SVGPreserveAspectRatio, SVGTransformList, ...)

        This is all handled by the JS generation in the bindings now, leading
        to a faster static rendering codepaths, and easier handling of the dynamic
        parts like JS scripting. Remove the mystified genericContext() concept alltogether.

        * bindings/js/JSSVGMatrixCustom.cpp: Adapt to the context() change.
        (WebCore::JSSVGMatrix::multiply):
        (WebCore::JSSVGMatrix::inverse):
        (WebCore::JSSVGMatrix::translate):
        (WebCore::JSSVGMatrix::scale):
        (WebCore::JSSVGMatrix::scaleNonUniform):
        (WebCore::JSSVGMatrix::rotate):
        (WebCore::JSSVGMatrix::rotateFromVector):
        (WebCore::JSSVGMatrix::flipX):
        (WebCore::JSSVGMatrix::flipY):
        (WebCore::JSSVGMatrix::skewX):
        (WebCore::JSSVGMatrix::skewY):
        * bindings/js/JSSVGPODTypeWrapper.h: Remove all nAC() calls here!
        (WebCore::JSSVGPODTypeWrapperCreatorReadWrite::commitChange):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::JSSVGPODTypeWrapperCreatorForList):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::~JSSVGPODTypeWrapperCreatorForList):
        * bindings/js/JSSVGPathSegCustom.cpp: Adapt to the context() change.
        (WebCore::toJS):
        * bindings/js/JSSVGPathSegListCustom.cpp: Ditto.
        (WebCore::JSSVGPathSegList::clear):
        (WebCore::JSSVGPathSegList::initialize):
        (WebCore::JSSVGPathSegList::getItem):
        (WebCore::JSSVGPathSegList::insertItemBefore):
        (WebCore::JSSVGPathSegList::replaceItem):
        (WebCore::JSSVGPathSegList::removeItem):
        (WebCore::JSSVGPathSegList::appendItem):
        * bindings/js/JSSVGPointListCustom.cpp: Ditto.
        (WebCore::JSSVGPointList::clear):
        (WebCore::JSSVGPointList::initialize):
        (WebCore::JSSVGPointList::getItem):
        (WebCore::JSSVGPointList::insertItemBefore):
        (WebCore::JSSVGPointList::replaceItem):
        (WebCore::JSSVGPointList::removeItem):
        (WebCore::JSSVGPointList::appendItem): 
        * bindings/js/JSSVGTransformListCustom.cpp: Ditto.
        (WebCore::JSSVGTransformList::clear):
        (WebCore::JSSVGTransformList::initialize):
        (WebCore::JSSVGTransformList::getItem):
        (WebCore::JSSVGTransformList::insertItemBefore):
        (WebCore::JSSVGTransformList::replaceItem):
        (WebCore::JSSVGTransformList::removeItem):
        (WebCore::JSSVGTransformList::appendItem):
        * bindings/js/kjs_binding.h: Add new cacheSVGDOMObject, taking third parameter: context.
        (KJS::cacheSVGDOMObject):
        * bindings/scripts/CodeGeneratorJS.pm: Change generation to step aways from genericContext().
        * ksvg2/misc/SVGDocumentExtensions.h: Kill all genericContext() stuff.
        (WebCore::SVGDocumentExtensions::hasBaseValue):
        * ksvg2/svg/SVGAngle.cpp: Kill context parameter.
        (WebCore::SVGAngle::SVGAngle):
        * ksvg2/svg/SVGAngle.h: ditto.
        * ksvg2/svg/SVGFEImageElement.cpp: SVG classes don't get context params passed anymore.
        (WebCore::SVGFEImageElement::SVGFEImageElement):
        * ksvg2/svg/SVGFitToViewBox.cpp: Ditto.
        (WebCore::SVGFitToViewBox::SVGFitToViewBox):
        * ksvg2/svg/SVGGradientElement.cpp: Ditto.
        (WebCore::SVGGradientElement::SVGGradientElement):
        * ksvg2/svg/SVGImageElement.cpp: Ditto.
        (WebCore::SVGImageElement::SVGImageElement):
        * ksvg2/svg/SVGMarkerElement.cpp: Ditto.
        (WebCore::SVGMarkerElement::SVGMarkerElement):
        (WebCore::SVGMarkerElement::parseMappedAttribute):
        * ksvg2/svg/SVGPathElement.cpp: Ditto.
        (WebCore::SVGPathElement::pathSegList):
        * ksvg2/svg/SVGPathSegList.cpp: Kill context parameter.
        (WebCore::SVGPathSegList::SVGPathSegList):
        * ksvg2/svg/SVGPathSegList.h:
        * ksvg2/svg/SVGPatternElement.cpp: SVG classes don't get context params passed anymore.
        (WebCore::SVGPatternElement::SVGPatternElement):
        * ksvg2/svg/SVGPointList.cpp: Kill context parameter.
        (SVGPointList::SVGPointList):
        * ksvg2/svg/SVGPointList.h:
        * ksvg2/svg/SVGPolyElement.cpp: SVG classes don't get context params passed anymore.
        (WebCore::SVGPolyElement::points):
        * ksvg2/svg/SVGPreserveAspectRatio.cpp: Kill context parameter.
        (WebCore::SVGPreserveAspectRatio::SVGPreserveAspectRatio):
        (WebCore::SVGPreserveAspectRatio::setAlign):
        (WebCore::SVGPreserveAspectRatio::setMeetOrSlice):
        (WebCore::SVGPreserveAspectRatio::parsePreserveAspectRatio):
        * ksvg2/svg/SVGPreserveAspectRatio.h:
        * ksvg2/svg/SVGSVGElement.cpp: SVG classes don't get cntext params passed anymore.
        (WebCore::SVGSVGElement::createSVGAngle):
        * ksvg2/svg/SVGStyledTransformableElement.cpp: Ditto.
        (WebCore::SVGStyledTransformableElement::SVGStyledTransformableElement):
        * ksvg2/svg/SVGTextElement.cpp: Ditto.
        (WebCore::SVGTextElement::SVGTextElement):
        * ksvg2/svg/SVGTransformList.cpp: Kill context parameter.
        (SVGTransformList::SVGTransformList):
        * ksvg2/svg/SVGTransformList.h:

2007-07-10  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Sam.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11167.

        Recognize <textPath> in SVG JS bindings.
        Add JSSVGTextPathElement to JSSVGElementWrapperFactory.

        Add SVGException.idl just for the JS generation.
        Turn on all SVG JS constructors and add them to DOMWindow.idl.

        Testcase added: LayoutTests/svg/custom/js-svg-constructors.svg
    
        * DerivedSources.make: Add JSSVGException.h
        * WebCore.xcodeproj/project.pbxproj: Correct paths for DOM/JS*SVGTextPathElement
        * bindings/scripts/CodeGeneratorJS.pm: Forward port hash fix from trunk.
        * bindings/js/JSSVGElementWrapperFactory.cpp: Add JSSVGTextPathElement support
        * ksvg2/svg/SVGComponentTransferFunctionElement.idl:
        * ksvg2/svg/SVGTextPathElement.h:
        * ksvg2/svg/SVGException.h:
        * ksvg2/svg/SVGException.idl: Added.
        * ksvg2/svg/SVGFEBlendElement.idl:
        * ksvg2/svg/SVGFEColorMatrixElement.idl:
        * ksvg2/svg/SVGFECompositeElement.idl:
        * ksvg2/svg/SVGFEDisplacementMapElement.idl:
        * ksvg2/svg/SVGFETurbulenceElement.idl:
        * ksvg2/svg/SVGGradientElement.idl:
        * ksvg2/svg/SVGMarkerElement.idl:
        * ksvg2/svg/SVGTextContentElement.idl:
        * ksvg2/svg/SVGTextPathElement.idl:
        * page/DOMWindow.idl: Recognize new js svg constructors.

2007-06-28  Rob Buis  <buis@kde.org>

        Reviewed by Maciej.

        http://bugs.webkit.org/show_bug.cgi?id=14241
        SVG <image> with height or width less than 1 fails to render image

        Keep extra member vars to get width/height as floats for accurate
        calculations.

        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::adjustRectsForAspectRatio):
        (WebCore::RenderSVGImage::paint):
        (WebCore::RenderSVGImage::calcWidth):
        (WebCore::RenderSVGImage::calcHeight):
        * rendering/RenderSVGImage.h:

2007-06-26  Rob Buis  <buis@kde.org>

        Reviewed by Maciej.

        http://bugs.webkit.org/show_bug.cgi?id=9976
        Fix negative width issue in Hixie's test

        Refuse to render zero or negative width/height.

        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::paint):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::paint):

2007-06-26  Rob Buis  <buis@kde.org>

        Reviewed by Maciej.

        http://bugs.webkit.org/show_bug.cgi?id=12062
        WebCore does not handle CSS-specified fill fallback correctly

        Implement fallback for fill and stroke.

        * ksvg2/css/SVGCSSParser.cpp:
        (WebCore::CSSParser::parseSVGValue):
        * ksvg2/svg/SVGPaint.cpp:
        (WebCore::SVGPaint::SVGPaint):
        * ksvg2/svg/SVGPaint.h:
        * platform/graphics/svg/SVGPaintServer.cpp:
        (WebCore::SVGPaintServer::fillPaintServer):
        (WebCore::SVGPaintServer::strokePaintServer):

2007-06-20  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=14157
        Rotated shape has wrong gradient rendering

        Use the untransformed bbox in objectBoundingBoxMode. Also
        don't do objectBoundingBoxMode should the bbox width ort height
        be zero.

        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::teardown):
        (WebCore::SVGPaintServerGradient::renderPath):

2007-06-20  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Eric & Oliver.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=14198

        Reeanble <foreignObject>. Explicitely disallow <use> on <foreignObject>
        as it may lead to bad problems. 

        While I'm at it disallow <use> on any non-svg element.

        * bindings/js/JSSVGElementWrapperFactory.cpp:
        * bindings/objc/DOM.mm:
        (WebCore::createElementClassMap):
        * ksvg2/svg/SVGForeignObjectElement.cpp:
        * ksvg2/svg/SVGForeignObjectElement.h:
        * ksvg2/svg/SVGForeignObjectElement.idl:
        * ksvg2/svg/SVGLocatable.cpp:
        (WebCore::SVGLocatable::nearestViewportElement):
        (WebCore::SVGLocatable::farthestViewportElement):
        * ksvg2/svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::buildPendingResource):
        * ksvg2/svg/svgtags.in:
        * rendering/RenderForeignObject.cpp:

2007-06-19  Rob Buis  <buis@kde.org>

        Reviewed by Oliver.

        http://bugs.webkit.org/show_bug.cgi?id=14144
        All tx/ty (parentX/parentY) usage should be removed from SVG renders
        http://bugs.webkit.org/show_bug.cgi?id=13981
        <br> prevents click handler from firing

        Fix the hit testing issues by making RenderSVGRoot take its m_x, m_y
        into account in the absolute transform.

        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::absoluteRects):
        (WebCore::RenderPath::nodeAtPoint):
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::nodeAtPoint):
        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::absoluteTransform):
        (WebCore::RenderSVGRoot::nodeAtPoint):

2007-06-16  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Eric.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=14015 (SVGTransformList::initialize() has no effect)

        Fix SVGTransformList usage in SVG DOM exposed to JS.
        This also fixes SVG space invaders including most repainting issues. (still some unrelated ones left)

        This is basically the _same_ fix applied to SVGPointList some months ago. We just forgot
        to add JSSVGTransformListCustom when switching from SVGTransform* -> SVGTransform (POD type).

        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSSVGTransformListCustom.cpp: Added.
        (WebCore::JSSVGTransformList::clear):
        (WebCore::JSSVGTransformList::initialize):
        (WebCore::JSSVGTransformList::getItem):
        (WebCore::JSSVGTransformList::insertItemBefore):
        (WebCore::JSSVGTransformList::replaceItem):
        (WebCore::JSSVGTransformList::removeItem):
        (WebCore::JSSVGTransformList::appendItem):
        * ksvg2/svg/SVGCircleElement.cpp:
        (WebCore::SVGCircleElement::notifyAttributeChange):
        * ksvg2/svg/SVGEllipseElement.cpp:
        (WebCore::SVGEllipseElement::notifyAttributeChange):
        * ksvg2/svg/SVGGradientElement.cpp:
        (WebCore::SVGGradientElement::SVGGradientElement):
        * ksvg2/svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::notifyAttributeChange):
        * ksvg2/svg/SVGLineElement.cpp:
        (WebCore::SVGLineElement::notifyAttributeChange):
        * ksvg2/svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::notifyAttributeChange):
        * ksvg2/svg/SVGPatternElement.cpp:
        (WebCore::SVGPatternElement::SVGPatternElement):
        * ksvg2/svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::notifyAttributeChange):
        * ksvg2/svg/SVGRectElement.cpp:
        (WebCore::SVGRectElement::notifyAttributeChange):
        * ksvg2/svg/SVGStyledTransformableElement.cpp:
        (WebCore::SVGStyledTransformableElement::SVGStyledTransformableElement):
        (WebCore::SVGStyledTransformableElement::notifyAttributeChange):
        * ksvg2/svg/SVGStyledTransformableElement.h:
        * ksvg2/svg/SVGTextElement.cpp:
        (WebCore::SVGTextElement::SVGTextElement):
        * ksvg2/svg/SVGTransformList.cpp:
        (SVGTransformList::SVGTransformList):
        (SVGTransformList::context):
        * ksvg2/svg/SVGTransformList.h:
        * ksvg2/svg/SVGTransformList.idl:

2007-06-15  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Eric.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=14155

        JSSVGMatrix was not working properly.
        "matrix.translate(10, 10)" actually altered 'matrix' instead of returning a
        new SVGMatrix object, as described in SVG 1.1 specification.

        * bindings/js/JSSVGMatrixCustom.cpp:
        (WebCore::JSSVGMatrix::multiply):
        (WebCore::JSSVGMatrix::inverse):
        (WebCore::JSSVGMatrix::translate):
        (WebCore::JSSVGMatrix::scale):
        (WebCore::JSSVGMatrix::scaleNonUniform):
        (WebCore::JSSVGMatrix::rotate):
        (WebCore::JSSVGMatrix::flipX):
        (WebCore::JSSVGMatrix::flipY):
        (WebCore::JSSVGMatrix::skewX):
        (WebCore::JSSVGMatrix::skewY):
        * ksvg2/svg/SVGMatrix.idl:

2007-06-15  Eric Seidel  <eric@webkit.org>

        Reviewed by Niko.

        Fix the release build.

        * rendering/SVGRootInlineBox.cpp:
        (WebCore::applyTextAnchorToTextChunk):

2007-06-15  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=14051
        <svg:image> fails to position correctly when <svg> is inside an inline <div>

        Leave parent translation to the containers.

        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::paint):

2007-06-15  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Eric.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=13963

        Fix SVG space invaders. It actually highlighted a bad problem with our JSSVGPODTypeWrapper's.
        Introduce a new "2nd-level cache" for all readwrite POD properties. Subsequent calls to ie.
        myRect.x.baseVal.value don't create a new wrapper everytime, but are properly cached now.
        This leads to a massive reduction in created wrappers.

        * bindings/js/JSSVGMatrixCustom.cpp:
        (WebCore::JSSVGMatrix::inverse):
        (WebCore::JSSVGMatrix::rotateFromVector):
        * bindings/js/JSSVGPODTypeWrapper.h:
        (WebCore::JSSVGPODTypeWrapperCreatorReadWrite::JSSVGPODTypeWrapperCreatorReadWrite):
        (WebCore::JSSVGPODTypeWrapperCreatorReadWrite::~JSSVGPODTypeWrapperCreatorReadWrite):
        (WebCore::JSSVGPODTypeWrapperCreatorReadWrite::operator PODType):
        (WebCore::JSSVGPODTypeWrapperCreatorReadWrite::commitChange):
        (WebCore::JSSVGPODTypeWrapperCreatorReadOnly::JSSVGPODTypeWrapperCreatorReadOnly):
        (WebCore::JSSVGPODTypeWrapperCreatorReadOnly::~JSSVGPODTypeWrapperCreatorReadOnly):
        (WebCore::JSSVGPODTypeWrapperCreatorReadOnly::operator PODType):
        (WebCore::JSSVGPODTypeWrapperCreatorReadOnly::commitChange):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::JSSVGPODTypeWrapperCreatorForList):
        (WebCore::JSSVGPODTypeWrapperCreatorForList::commitChange):
        (WebCore::PODTypeReadWriteHashInfo::PODTypeReadWriteHashInfo):
        (WebCore::PODTypeReadWriteHashInfo::operator==):
        (WebCore::PODTypeReadWriteHashInfoHash::hash):
        (WebCore::PODTypeReadWriteHashInfoHash::equal):
        (WebCore::PODTypeReadWriteHashInfoTraits::deletedValue):
        (WebCore::PODTypeReadWriteHashInfoTraits::emptyValue):
        (WebCore::JSSVGPODTypeWrapperCache::readWriteHashMap):
        (WebCore::JSSVGPODTypeWrapperCache::lookupOrCreateWrapper):
        (WebCore::JSSVGPODTypeWrapperCache::forgetWrapper):
        * bindings/js/JSSVGPointListCustom.cpp:
        (WebCore::JSSVGPointList::removeItem):
        * bindings/scripts/CodeGeneratorJS.pm:

2007-06-14  Eric Seidel  <eric@webkit.org>

        Reviewed by Niko.

        Text gradients are broken on feature branch
        http://bugs.webkit.org/show_bug.cgi?id=14142

        * rendering/SVGRenderSupport.cpp:
        (WebCore::prepareToRenderSVGContent):
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::prepareTextRendering):
        (WebCore::SVGRootInlineBox::paint):
        (WebCore::SVGRootInlineBox::paintInlineBoxes):
        (WebCore::SVGRootInlineBox::paintChildInlineTextBox):
        (WebCore::SVGRootInlineBox::paintChildInlineFlowBox):
        * rendering/SVGRootInlineBox.h:

2007-06-14  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Sam.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11273

        Implement pixelUnitToMillimeterX(), pixelUnitToMillimeterY() in SVGSVGElement.
        Use cssPixelsPerInch, just like done in CSSPrimitiveValue & SVGLength.

        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::pixelUnitToMillimeterX):
        (WebCore::SVGSVGElement::pixelUnitToMillimeterY):

2007-06-14  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=9752
        %-sizing of elements with a html parent is broken

        Calculate width/height for length percentages when embedded in xhtml.

        * ksvg2/svg/SVGLength.cpp:
        (WebCore::SVGLength::PercentageOfViewport):

2007-06-14  Rob Buis  <buis@kde.org>

        Build fix.

        * rendering/SVGCharacterLayoutInfo.cpp:

2007-06-14  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=12207
        RenderSVGContainer should be split into multiple classes
        http://bugs.webkit.org/show_bug.cgi?id=14125
        KCanvasRenderingStyle should be removed

        Introduce the RenderSVGRoot class and kill the KCanvas enums.

        * WebCore.xcodeproj/project.pbxproj:
        * ksvg2/css/SVGRenderStyle.cpp:
        (WebCore::SVGRenderStyle::cssPrimitiveToLength):
        * ksvg2/css/SVGRenderStyle.h:
        * ksvg2/misc/KCanvasRenderingStyle.cpp: Removed.
        * ksvg2/misc/KCanvasRenderingStyle.h: Removed.
        * ksvg2/svg/SVGMarkerElement.cpp:
        (WebCore::SVGMarkerElement::createRenderer):
        (WebCore::SVGMarkerElement::notifyAttributeChange):
        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::createRenderer):
        * ksvg2/svg/SVGSVGElement.h:
        * platform/graphics/svg/SVGPaintServer.cpp:
        (WebCore::sharedSolidPaintServer):
        (WebCore::SVGPaintServer::fillPaintServer):
        (WebCore::SVGPaintServer::strokePaintServer):
        (WebCore::dashArrayFromRenderingStyle):
        * platform/graphics/svg/SVGPaintServer.h:
        * platform/graphics/svg/cg/CgSupport.cpp:
        (WebCore::applyStrokeStyleToContext):
        * platform/graphics/svg/cg/RenderPathCg.cpp:
        (WebCore::RenderPath::strokeContains):
        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::fillContains):
        (WebCore::fillAndStrokePath):
        (WebCore::RenderPath::drawMarkersIfNeeded):
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::requiresLayer):
        (WebCore::RenderSVGContainer::layout):
        (WebCore::RenderSVGContainer::applyContentTransforms):
        (WebCore::RenderSVGContainer::paint):
        (WebCore::RenderSVGContainer::setAlign):
        (WebCore::RenderSVGContainer::align):
        (WebCore::RenderSVGContainer::viewportTransform):
        (WebCore::RenderSVGContainer::absoluteTransform):
        (WebCore::RenderSVGContainer::getAspectRatio):
        * rendering/RenderSVGContainer.h:
        * rendering/RenderSVGInlineText.cpp:
        * rendering/RenderSVGRoot.cpp: Added.
        (WebCore::RenderSVGRoot::RenderSVGRoot):
        (WebCore::RenderSVGRoot::~RenderSVGRoot):
        (WebCore::RenderSVGRoot::localTransform):
        (WebCore::RenderSVGRoot::setLocalTransform):
        (WebCore::RenderSVGRoot::requiresLayer):
        (WebCore::RenderSVGRoot::lineHeight):
        (WebCore::RenderSVGRoot::baselinePosition):
        (WebCore::RenderSVGRoot::layout):
        (WebCore::RenderSVGRoot::applyContentTransforms):
        (WebCore::RenderSVGRoot::paint):
        (WebCore::RenderSVGRoot::viewport):
        (WebCore::RenderSVGRoot::calcViewport):
        (WebCore::RenderSVGRoot::setViewBox):
        (WebCore::RenderSVGRoot::viewBox):
        (WebCore::RenderSVGRoot::setAlign):
        (WebCore::RenderSVGRoot::align):
        (WebCore::RenderSVGRoot::viewportTransform):
        (WebCore::RenderSVGRoot::absoluteClippedOverflowRect):
        (WebCore::RenderSVGRoot::addFocusRingRects):
        (WebCore::RenderSVGRoot::absoluteRects):
        (WebCore::RenderSVGRoot::absoluteTransform):
        (WebCore::RenderSVGRoot::fillContains):
        (WebCore::RenderSVGRoot::strokeContains):
        (WebCore::RenderSVGRoot::relativeBBox):
        (WebCore::RenderSVGRoot::setSlice):
        (WebCore::RenderSVGRoot::slice):
        (WebCore::RenderSVGRoot::getAspectRatio):
        (WebCore::RenderSVGRoot::nodeAtPoint):
        * rendering/RenderSVGRoot.h: Added.
        (WebCore::RenderSVGRoot::isSVGContainer):
        (WebCore::RenderSVGRoot::renderName):
        * rendering/RenderSVGTSpan.cpp:
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::relativeBBox):
        * rendering/SVGRenderTreeAsText.cpp:
        (WebCore::operator<<):
        (WebCore::writeStyle):
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBox::paint):
        (WebCore::SVGRootInlineBox::paintInlineBoxes):

2007-06-12  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Eric.

        Fix regression: SVG images drawn in the wrong paint phase.

        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::paint):

2007-06-11  Rob Buis  <buis@kde.org>

        Reviewed by weinig.

        http://bugs.webkit.org/show_bug.cgi?id=14064
        fill property is reported as type SVGColor

        Do the checks in the right order.

        * bindings/js/kjs_css.cpp:
        (KJS::toJS):

2007-06-07  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=12122
        SVGPathElement should not inherit from SVGPathParser

        Use path builders for building Path and PathSegLists.

        * ksvg2/svg/SVGAnimateMotionElement.cpp:
        (WebCore::SVGAnimateMotionElement::parseMappedAttribute):
        * ksvg2/svg/SVGParserUtilities.cpp:
        (WebCore::pointsListFromSVGData):
        (WebCore::SVGPathParser::~SVGPathParser):
        (WebCore::SVGPathParser::svgLineToHorizontal):
        (WebCore::SVGPathParser::svgLineToVertical):
        (WebCore::SVGPathParser::svgCurveToCubicSmooth):
        (WebCore::SVGPathParser::svgCurveToQuadratic):
        (WebCore::SVGPathParser::svgCurveToQuadraticSmooth):
        (WebCore::SVGPathParser::svgArcTo):
        (WebCore::PathBuilder::build):
        (WebCore::PathBuilder::svgMoveTo):
        (WebCore::PathBuilder::svgLineTo):
        (WebCore::PathBuilder::svgCurveToCubic):
        (WebCore::PathBuilder::svgClosePath):
        (WebCore::pathFromSVGData):
        (WebCore::SVGPathSegListBuilder::build):
        (WebCore::SVGPathSegListBuilder::svgMoveTo):
        (WebCore::SVGPathSegListBuilder::svgLineTo):
        (WebCore::SVGPathSegListBuilder::svgLineToHorizontal):
        (WebCore::SVGPathSegListBuilder::svgLineToVertical):
        (WebCore::SVGPathSegListBuilder::svgCurveToCubic):
        (WebCore::SVGPathSegListBuilder::svgCurveToCubicSmooth):
        (WebCore::SVGPathSegListBuilder::svgCurveToQuadratic):
        (WebCore::SVGPathSegListBuilder::svgCurveToQuadraticSmooth):
        (WebCore::SVGPathSegListBuilder::svgArcTo):
        (WebCore::SVGPathSegListBuilder::svgClosePath):
        (WebCore::pathSegListFromSVGData):
        * ksvg2/svg/SVGParserUtilities.h:
        * ksvg2/svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::SVGPathElement):
        (WebCore::SVGPathElement::parseMappedAttribute):
        * ksvg2/svg/SVGPathElement.h:
        * ksvg2/svg/SVGPolyElement.cpp:
        (WebCore::SVGPolyElement::SVGPolyElement):
        (WebCore::SVGPolyElement::parseMappedAttribute):
        * ksvg2/svg/SVGPolyElement.h:

2007-06-06  Eric Seidel  <eric@webkit.org>

        Reviewed by olliej.

        Add support for tabbing between links in an SVG file
        Also add support for drawing a focus ring around focused svg content.
        http://bugs.webkit.org/show_bug.cgi?id=8823
        
        Layout test is blocked by http://bugs.webkit.org/show_bug.cgi?id=14027

        * css/svg.css:
        * ksvg2/svg/SVGAElement.cpp:
        (WebCore::SVGAElement::defaultEventHandler):
        (WebCore::SVGAElement::supportsFocus):
        (WebCore::SVGAElement::isFocusable):
        (WebCore::SVGAElement::isMouseFocusable):
        (WebCore::SVGAElement::isKeyboardFocusable):
        * ksvg2/svg/SVGAElement.h:

2007-06-06  Eric Seidel  <eric@webkit.org>

        Reviewed by olliej.

        Make SVG (mostly) support CSS outline property (and thus focus rings)
        http://bugs.webkit.org/show_bug.cgi?id=10849

        Test: svg/custom/focus-ring.svg

        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::paint):
        (WebCore::RenderPath::addFocusRingRects):
        * rendering/RenderPath.h:
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::paint):
        (WebCore::RenderSVGContainer::addFocusRingRects):
        * rendering/RenderSVGContainer.h:
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::paint):
        (WebCore::RenderSVGImage::addFocusRingRects):
        * rendering/RenderSVGImage.h:

2007-06-06  Eric Seidel  <eric@webkit.org>

        Reviewed by weinig.
        
        Break out common SVG rendering logic into prepareToRenderSVGContent in SVGRenderSupport

        No test cases should be changed by this.

        * WebCore.xcodeproj/project.pbxproj:
        * rendering/RenderPath.cpp:
        (WebCore::fillAndStrokePath):
        (WebCore::RenderPath::paint):
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::RenderSVGContainer):
        (WebCore::RenderSVGContainer::requiresLayer):
        (WebCore::RenderSVGContainer::isOutermostSVG):
        (WebCore::RenderSVGContainer::layout):
        (WebCore::RenderSVGContainer::applyContentTransforms):
        (WebCore::RenderSVGContainer::paint):
        (WebCore::RenderSVGContainer::viewportTransform):
        (WebCore::RenderSVGContainer::absoluteTransform):
        * rendering/RenderSVGContainer.h:
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::paint):
        (WebCore::RenderSVGImage::translationForAttributes):
        * rendering/SVGRenderSupport.cpp: Added.
        (WebCore::prepareToRenderSVGContent):
        * rendering/SVGRenderSupport.h: Added.
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::prepareTextRendering):
        (WebCore::SVGRootInlineBox::paint):
        (WebCore::SVGRootInlineBox::paintInlineBoxes):

2007-06-06  Rob Buis  <buis@kde.org>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=13976
        getPresentationAttribute not implemented

        Implement getPresentationAttribute.

        * ksvg2/svg/SVGStylable.h:
        * ksvg2/svg/SVGStylable.idl:
        * ksvg2/svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::getPresentationAttribute):
        * ksvg2/svg/SVGStyledElement.h:

2007-06-06  Rob Buis  <buis@kde.org>

        Reviewed by olliej and eric.

        http://bugs.webkit.org/show_bug.cgi?id=12430
        SVG has two transform parsers when it should have one.

        Refactor SVGTransformable parser so SVGAnimateTransformElement can reuse it better.

        * ksvg2/svg/SVGAnimateTransformElement.cpp:
        (WebCore::SVGAnimateTransformElement::calculateFromAndToValues):
        * ksvg2/svg/SVGAnimateTransformElement.h:
        * ksvg2/svg/SVGTransformable.cpp:
        (WebCore::):
        (WebCore::SVGTransformable::parseTransformValue):
        (WebCore::SVGTransformable::parseTransformAttribute):
        * ksvg2/svg/SVGTransformable.h:

2007-06-05  Eric Seidel  <eric@webkit.org>

        Reviewed by olliej.

        Commit files missing from previous commit, oops!
        
        * platform/graphics/svg/SVGResourceMasker.cpp:
        (WebCore::SVGResourceMasker::SVGResourceMasker):
        (WebCore::SVGResourceMasker::invalidate):
        * platform/graphics/svg/SVGResourceMasker.h:
        * platform/graphics/svg/cg/SVGResourceMaskerCg.mm:
        (WebCore::SVGResourceMasker::applyMask):

2007-06-01  Eric Seidel  <eric@webkit.org>

        Reviewed by olliej.

        Add support for maskUnits and maskContentUnits
        http://bugs.webkit.org/show_bug.cgi?id=12568
        
        This is covered by the W3C tests (including mask-intro01)

        * ksvg2/svg/SVGMaskElement.cpp:
        (WebCore::SVGMaskElement::SVGMaskElement):
        (WebCore::SVGMaskElement::parseMappedAttribute):
        (WebCore::SVGMaskElement::drawMaskerContent):
        (WebCore::SVGMaskElement::canvasResource):
        (WebCore::SVGMaskElement::notifyAttributeChange):
        * ksvg2/svg/SVGMaskElement.h:
        * ksvg2/svg/SVGMaskElement.idl:
        * platform/graphics/svg/SVGResourceMasker.cpp:
        (WebCore::SVGResourceMasker::SVGResourceMasker):
        (WebCore::SVGResourceMasker::invalidate):
        * platform/graphics/svg/SVGResourceMasker.h:
        * platform/graphics/svg/cg/SVGResourceMaskerCg.mm:
        (WebCore::SVGResourceMasker::applyMask):

2007-06-01  Eric Seidel  <eric@webkit.org>

        Reviewed by lars.
        
        Cursor does not change to hand over links containing <use>
        http://bugs.webkit.org/show_bug.cgi?id=12630

        Test: manual-tests/svg-link-hover-use.svg

        * manual-tests/svg-link-hover-use.svg: Added.
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::hitTest): use eventParentNode instead of parentNode

2007-06-01  Eric Seidel  <eric@webkit.org>

        Reviewed by olliej.

        SVG is not correctly respecting scroll during hit testing
        http://bugs.webkit.org/show_bug.cgi?id=13083

        Test: svg/custom/scroll-hit-test.svg

        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::nodeAtPoint):
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::nodeAtPoint):

2007-06-01  Eric Seidel  <eric@webkit.org>

        Reviewed by hyatt.

        Fix for: http://bugs.webkit.org/show_bug.cgi?id=12187

        Tests: fast/dom/attribute-case-sensitivity.html, fast/dom/attribute-case-sensitivity2.xhtml

        * dom/Element.cpp:
        (WebCore::shouldIgnoreAttributeCase): check to make sure element is an HTMLElement
        (WebCore::Element::getAttribute):
        (WebCore::Element::setAttribute):
        (WebCore::Element::removeAttribute):
        (WebCore::Element::getAttributeNode):
        (WebCore::Element::hasAttribute):
        * dom/NamedAttrMap.cpp:
        (WebCore::shouldIgnoreAttributeCase):
        (WebCore::NamedAttrMap::getNamedItem):
        (WebCore::NamedAttrMap::removeNamedItem):

2007-05-31  Eric Seidel  <eric@webkit.org>

        Reviewed by Niko.

        Links are activated based on mouse down events instead of click events
        http://bugs.webkit.org/show_bug.cgi?id=12570
        
        Test: svg/custom/prevent-default.svg

        * html/HTMLAnchorElement.cpp: use MiddleButton and RightButton instead of 1 and 2
        (WebCore::HTMLAnchorElement::defaultEventHandler):
        * ksvg2/svg/SVGAElement.cpp:
        (WebCore::SVGAElement::defaultEventHandler): make it function more like the HTML side

2007-05-30  Rob Buis  <buis@kde.org>

        Reviewed by Darin.

        http://bugs.webkit.org/show_bug.cgi?id=11272
        Implement currentScale(), setCurrentScale() and currentTranslate() in SVGSVGElement

        Allow zooming and panning, thereby implementing the above methods.

        * ksvg2/svg/SVGDocument.cpp:
        (WebCore::SVGDocument::zoomAndPanEnabled):
        (WebCore::SVGDocument::startPan):
        (WebCore::SVGDocument::updatePan):
        * ksvg2/svg/SVGDocument.h:
        * ksvg2/svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::currentScale):
        (WebCore::SVGSVGElement::setCurrentScale):
        (WebCore::SVGSVGElement::currentTranslate):
        (WebCore::SVGSVGElement::setCurrentTranslate):
        * ksvg2/svg/SVGSVGElement.h:
        * page/EventHandler.cpp:
        (WebCore::EventHandler::EventHandler):
        (WebCore::EventHandler::handleMousePressEvent):
        (WebCore::EventHandler::handleMouseMoveEvent):
        (WebCore::EventHandler::handleMouseReleaseEvent):
        * page/EventHandler.h:
        * page/Frame.cpp:
        (WebCore::Frame::setZoomFactor):
        * rendering/RenderSVGContainer.cpp:
        (WebCore::RenderSVGContainer::layout):
        (WebCore::RenderSVGContainer::paint):
        (WebCore::RenderSVGContainer::absoluteTransform):

2007-05-30  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fix regression: gradient on fill of text works again!

        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        (WebCore::SVGPaintServerGradient::teardown):

2007-05-29  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fix "jumpy" selection by correcting the way svgCharacterHitsPosition works.
        I basically mixed up the "closest character to position" logic.

        * rendering/RenderSVGInlineText.cpp: Only call svgCharacterHitsPosition for the firstTextBox -> it handles all children anyway.
        (WebCore::RenderSVGInlineText::positionForCoordinates):
        * rendering/SVGInlineTextBox.cpp:
        (WebCore::SVGInlineTextBox::closestCharacterToPosition): Fix logic - was really broken!
        (WebCore::SVGInlineTextBox::svgCharacterHitsPosition):
        (WebCore::SVGInlineTextBox::nodeAtPoint): Do not use svgCharacterHitsPosition here - too accurate!
                                                  We don't want to loose the 'text' cursor if one is just between two characters.

2007-05-24  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Add new code path dumping SVG text engine specific layout test results.
        Finally the dumped results are actually accurate and respond to the
        rendered glyphs. This has never been correct so far.

        * rendering/RenderTreeAsText.cpp:
        (WebCore::quoteAndEscapeNonPrintables):
        (WebCore::write):
        * rendering/RenderTreeAsText.h:
        * rendering/SVGInlineTextBox.h:
        * rendering/SVGRenderTreeAsText.cpp:
        (WebCore::operator<<):
        (WebCore::containsInlineTextBox):
        (WebCore::writeSVGInlineText):
        (WebCore::write):
        * rendering/SVGRenderTreeAsText.h:
        * rendering/SVGRootInlineBox.cpp:
        (WebCore::topLeftPositionOfCharacterRange):
        (WebCore::cummulatedWidthOfInlineBoxCharacterRange):
        (WebCore::cummulatedHeightOfInlineBoxCharacterRange):
        (WebCore::SVGRootInlineBox::computePerCharacterLayoutInformation):
        * rendering/SVGRootInlineBox.h:

2007-05-20  Nikolas Zimmermann  <zimmermann@kde.org>

        Reviewed by Oliver.

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=12698 (SVG text needs a special per-character layout mode.)

        Fixes: http://bugs.webkit.org/show_bug.cgi?id=6420 (<text> does not respect x,y offset lists)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=6425 (<textPath> element not implemented)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=6481 (text-anchor (vertical) does not work in SVG text elements)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=11941 (REGRESSION: Missing text stroke in svg/W3C-SVG-1.1/text-deco-01-b.svg)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=12376 (glyph rotation in text/tspan not implemented)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=12377 (multiple dx and dy attributes not respected in text and tspan elements)
        Fixes: http://bugs.webkit.org/show_bug.cgi?id=12574 (<text> does not handle baseline-shift correctly)

        Introduce new experimental SVG text engine - after 5+ months of hacking.

        Add textPath support, absolute positioned SVG characters, vertical text,
        text rotation, baseline-shift, text chunks spanning <tspan>'s etc.

        Check my Flickr page for screenshots: http://www.flickr.com/photos/43532360@N00 (a bit outdated)

        Fixes/Improvments:
        - animate-elem-40-t.svg (x/y lists respected on <text> now)
        - interact-cursor-01-f.svg (text-anchor correctly handled in <text><a> situations)
        - struct-frag-05-t.svg (ditto)
        - text-align-02-b.svg (baseline-shift recognized)
        - text-align-04-b.svg (textPath displayed)
        - text-align-05-b.svg (text-anchor & vertical text handled correctly)
        - text-align-06-b.svg (baseline-shift & vertical text handled correctly)
        - text-deco-01-b.svg (longstanding regression fixed for text-decoration)
        - text-path-01-b.svg (all textPaths are displayed correctly)
        - text-text-04-t.svg (all x/y/dx/dy list situations work fine now)
        - text-text-05-t.svg (ditto)
        - text-text-06-t.svg (ditto)
        - text-text-07-t.svg (rotation works fine now)
        - text-tspan-01-b.svg (per character placment works great in all situations)

        Most files using text-anchor show 0.5-1% differences because the shift offset calculation is more correct now.

        Regressions:    
        - Gradient on fill is broken (on stroke works) -> this is a regression (easy to fix soon)
          js-late-gradient-and-object-creation.svg & js-late-gradient-creation.svg & pservers-grad-08-b.svg & pservers-grad-11-b.svg are broken

        Complete list of missing things:
        - 'textLength' / 'lengthAdjust' properties on <text>/<tspan> not yet handled.
        - 'dominant-baseline / alignment-baseline missing (neither FF/Opera/Batik support this)
        - 'kerning' property ignored
        - 'glyph-orientation-vertical' / 'glyph-orientation-horizontal' not yet handled.
        - Hebrew text selection broken (discontinous selection doesn't work)
        - <textPath> doesn't yet participate in text selection
        - <textPath> 'text-anchor' handling is flawed
        - <textPath> doesn't yet handle 'method' / 'spacing' properties
        - 'letter-spacing' / 'word-spacing' is still handled in the "legacy" mode. That means it only works
          for simple cases -> won't work for textPath's for instance
        - SVG fonts (<altGlyph>, <font> ..... tons more)

        * DerivedSources.make: Add DOM/JSSVGTextPathElement.h to build
        * WebCore.xcodeproj/project.pbxproj: Add textPath related files to build
        * css/svg.css: Correct white-space default setting for textPath element
        * ksvg2/svg/SVGFEFloodElement.cpp: Missing include (experimental build was broken)
        * ksvg2/svg/SVGTSpanElement.cpp: Recognize textPath children.
        (WebCore::SVGTSpanElement::childShouldCreateRenderer):
        * ksvg2/svg/SVGTextElement.cpp: Ditto.
        (WebCore::SVGTextElement::childShouldCreateRenderer):
        * ksvg2/svg/SVGTextPathElement.cpp: Added.
        (WebCore::SVGTextPathElement::SVGTextPathElement):
        (WebCore::SVGTextPathElement::~SVGTextPathElement):
        (WebCore::SVGTextPathElement::parseMappedAttribute):
        (WebCore::SVGTextPathElement::createRenderer):
        (WebCore::SVGTextPathElement::childShouldCreateRenderer):
        (WebCore::SVGTextPathElement::insertedIntoDocument):
        (WebCore::SVGTextPathElement::buildPendingResource):
        (WebCore::SVGTextPathElement::attach):
        * ksvg2/svg/SVGTextPathElement.h: Added.
        (WebCore::):
        (WebCore::SVGTextPathElement::rendererIsNeeded):
        (WebCore::SVGTextPathElement::contextElement):
        * ksvg2/svg/SVGTextPathElement.idl: Added.
        * ksvg2/svg/svgtags.in: Add textPath tag.
        * rendering/InlineTextBox.cpp: Make two methods non static to share with SVG.
        (WebCore::correctedTextColor):
        (WebCore::updateGraphicsContext):
        * rendering/InlineTextBox.h:
        * rendering/RenderSVGInlineText.cpp: Special positionForCoordinates() implementation. Stub caretRect() for SVG.
        (WebCore::RenderSVGInlineText::selectionRect):
        (WebCore::RenderSVGInlineText::caretRect):
        (WebCore::RenderSVGInlineText::positionForCoordinates):
        * rendering/RenderSVGInlineText.h:
        * rendering/RenderSVGTextPath.cpp: Added.
        (WebCore::RenderSVGTextPath::RenderSVGTextPath):
        (WebCore::RenderSVGTextPath::layoutPath):
        (WebCore::RenderSVGTextPath::setLayoutPath):
        (WebCore::RenderSVGTextPath::startOffset):
        (WebCore::RenderSVGTextPath::setStartOffset):
        (WebCore::RenderSVGTextPath::exactAlignment):
        (WebCore::RenderSVGTextPath::setExactAlignment):
        (WebCore::RenderSVGTextPath::stretchMethod):
        (WebCore::RenderSVGTextPath::setStretchMethod):
        (WebCore::RenderSVGTextPath::absoluteRects):
        * rendering/RenderSVGTextPath.h: Added.
        (WebCore::RenderSVGTextPath::renderName):
        * rendering/RenderText.cpp: Fix indention and use StringImpl::empty() instead of creating an empty string manually.
        (WebCore::RenderText::setTextInternal):
        * rendering/RootInlineBox.h: Add virtual no-op computePerCharacterLayoutInformation().
        (WebCore::RootInlineBox::computePerCharacterLayoutInformation):
        * rendering/SVGCharacterLayoutInfo.cpp: Added.
        (WebCore::calculateBaselineShift):
        (WebCore::SVGCharacterLayoutInfo::SVGCharacterLayoutInfo):
        (WebCore::SVGCharacterLayoutInfo::xValueAvailable):
        (WebCore::SVGCharacterLayoutInfo::yValueAvailable):
        (WebCore::SVGCharacterLayoutInfo::dxValueAvailable):
        (WebCore::SVGCharacterLayoutInfo::dyValueAvailable):
        (WebCore::SVGCharacterLayoutInfo::angleValueAvailable):
        (WebCore::SVGCharacterLayoutInfo::baselineShiftValueAvailable):
        (WebCore::SVGCharacterLayoutInfo::xValueNext):
        (WebCore::SVGCharacterLayoutInfo::yValueNext):
        (WebCore::SVGCharacterLayoutInfo::dxValueNext):
        (WebCore::SVGCharacterLayoutInfo::dyValueNext):
        (WebCore::SVGCharacterLayoutInfo::angleValueNext):
        (WebCore::SVGCharacterLayoutInfo::baselineShiftValueNext):
        (WebCore::SVGCharacterLayoutInfo::processedSingleCharacter):
        (WebCore::SVGCharacterLayoutInfo::processedChunk):
        (WebCore::SVGCharacterLayoutInfo::nextPathLayoutPointAndAngle):
        (WebCore::SVGCharacterLayoutInfo::inPathLayout):
        (WebCore::SVGCharacterLayoutInfo::setInPathLayout):
        (WebCore::SVGCharacterLayoutInfo::addLayoutInformation):
        (WebCore::SVGCharacterLayoutInfo::addStackContent):
        (WebCore::SVGCharacterLayoutInfo::xStackWalk):
        (WebCore::SVGCharacterLayoutInfo::yStackWalk):
        (WebCore::SVGCharacterLayoutInfo::dxStackWalk):
        (WebCore::SVGCharacterLayoutInfo::dyStackWalk):
        (WebCore::SVGCharacterLayoutInfo::angleStackWalk):
        (WebCore::SVGCharacterLayoutInfo::baselineShiftStackWalk):
        * rendering/SVGCharacterLayoutInfo.h: Added.
        (WebCore::PositionedVector::Type):
        (WebCore::PositionedVector::position):
        (WebCore::PositionedVector::advance):
        (WebCore::PositionedVector::valueAtCurrentPosition):
        (WebCore::SVGCharacterLayoutInfo::):
        (WebCore::SVGInlineBoxCharacterRange::SVGInlineBoxCharacterRange):
        (WebCore::SVGInlineBoxCharacterRange::isOpen):
        (WebCore::SVGInlineBoxCharacterRange::isClosed):
        (WebCore::SVGTextChunk::SVGTextChunk):
        (WebCore::SVGTextChunkLayoutInfo::SVGTextChunkLayoutInfo):
        * rendering/SVGInlineFlowBox.cpp: Make all methods no-ops when using the new text engine.
        (WebCore::SVGInlineFlowBox::paint):
        (WebCore::SVGInlineFlowBox::placeBoxesHorizontally):
        (WebCore::SVGInlineFlowBox::verticallyAlignBoxes):
        * rendering/SVGInlineFlowBox.h:
        * rendering/SVGInlineTextBox.cpp: Add new text selection / character hit detection related code.
        (WebCore::SVGInlineTextBox::SVGInlineTextBox):
        (WebCore::SVGInlineTextBox::selectionTop):
        (WebCore::SVGInlineTextBox::svgRootInlineBox):
        (WebCore::SVGInlineTextBox::closestCharacterToPosition):
        (WebCore::SVGInlineTextBox::svgCharacterHitsPosition):
        (WebCore::SVGInlineTextBox::offsetForPosition):
        (WebCore::SVGInlineTextBox::positionForOffset):
        (WebCore::SVGInlineTextBox::nodeAtPoint):
        (WebCore::SVGInlineTextBox::selectionRect):
        * rendering/SVGInlineTextBox.h:
        * rendering/SVGRootInlineBox.cpp: The heart of the new text engine lives here.
        (WebCore::prepareTextRendering):
        (WebCore::isVerticalWritingMode):
        (WebCore::SVGRootInlineBox::paint):
        (WebCore::SVGRootInlineBox::placeBoxesHorizontally):
        (WebCore::SVGRootInlineBox::verticallyAlignBoxes):
        (WebCore::SVGRootInlineBox::cummulatedWidthOfSelectionRange):
        (WebCore::cummulatedWidthOfInlineBoxCharacterRange):
        (WebCore::cummulatedWidthOfTextChunk):
        (WebCore::cummulatedHeightOfTextChunk):
        (WebCore::applyTextAnchorToTextChunk):
        (WebCore::SVGRootInlineBox::computePerCharacterLayoutInformation):
        (WebCore::totalAdvanceOfInlineTextBox):
        (WebCore::totalAdvanceOfInlineBox):
        (WebCore::SVGRootInlineBox::buildLayoutInformation):
        (WebCore::SVGRootInlineBox::layoutInlineBoxes):
        (WebCore::SVGRootInlineBox::buildLayoutInformationForTextBox):
        (WebCore::SVGRootInlineBox::buildTextChunks):
        (WebCore::SVGRootInlineBox::svgTextChunks):
        (WebCore::SVGRootInlineBox::layoutTextChunks):
        (WebCore::SVGRootInlineBox::paintSelectionForTextBox):
        (WebCore::SVGRootInlineBox::paintInlineBoxes):
        (WebCore::SVGRootInlineBox::paintCharacterRangeForTextBox):
        * rendering/SVGRootInlineBox.h:
        * rendering/bidi.cpp: Call the new computePerCharacterLayoutInformation() method.
        (WebCore::RenderBlock::layoutInlineChildren):

2007-05-10  Eric Seidel  <eric@webkit.org>

        Reviewed by olliej.

        http://bugs.webkit.org/show_bug.cgi?id=11931
        PathCG fails to hit on unclosed sub-paths

        Test: svg/custom/hit-test-unclosed-subpaths.svg

        * platform/graphics/cg/PathCG.cpp:
        (WebCore::copyClosingSubpathsApplierFunction):
        (WebCore::copyCGPathClosingSubpaths):
        (WebCore::Path::contains): use new copy & close function

=== End merge of feature-branch 2007-10-12 ===

2007-10-11  Jon Honeycutt  <jhoneycutt@apple.com>

        Reviewed by Anders.

        Handle a race condition that could arise if a plugin was loaded while it
        was scheduled to be freed: check whether the timer that schedules
        library frees is active in PluginPackageWin::load().

        * plugins/win/PluginPackageWin.cpp:
        (WebCore::PluginPackageWin::freeLibrarySoon): Added assertions
        (WebCore::PluginPackageWin::freeLibraryTimerFired): Added assertion
        (WebCore::PluginPackageWin::load): If we are scheduled to free this
        library, cancel the timer, and don't call LoadLibrary

2007-10-11  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Harrison.

        <rdar://problem/5483567> REGRESSION (Tiger only): Pasting words copied from TextEdit in Mail adds extra newline
        
        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::removeUnrenderedTextNodesAtEnds): Added.
        We would like to insert the fragment as-is if possible, but AppKit on Tiger
        creates fragments from RTF data that have carriage returns and spaces at the
        beginning and end, and those need to be removed since they'll interfere with 
        paragraph merging.
        (WebCore::ReplaceSelectionCommand::doApply):
        * editing/ReplaceSelectionCommand.h:

2007-10-10  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Maciej.
        
        <rdar://problem/5521237> Pasting a word copied from TextEdit after a regular, breaking space, adds a leading newline
        
        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::prepareWhitespaceAtPositionForSplit):
        Fixed a typo.

2007-10-10  Jon Honeycutt  <jhoneycutt@apple.com>

        Reviewed by Darin.

        <rdar://5530519> REGRESSION (303-310A18): Crash when closing tab with
        pdf file (Reader 7 only)

        Reader 7 subclasses its parent window, so posting a WM_DESTROY to this
        window puts us in plugin code. When the plugin forwards the message
        back to the original window proc, and we free the plugin library from
        there, we will jump back to code we just freed when we return, so delay 
        calling FreeLibrary at least until the next message loop

        * plugins/win/PluginPackageWin.cpp:
        (WebCore::PluginPackageWin::freeLibrarySoon): Start a timer to free the
        plugin library
        (WebCore::PluginPackageWin::freeLibraryTimerFired): Free the library
        (WebCore::PluginPackageWin::PluginPackageWin): Initialize the timer that
        will free this library
        (WebCore::PluginPackageWin::unloadWithoutShutdown): Call
        freeLibrarySoon()
        * plugins/win/PluginPackageWin.h: Added m_freeLibraryTimer

2007-10-11  Ada Chan  <adachan@apple.com>

        <rdar://problem/5534421> 
        Switched to using wkGetDefaultHTTPCookieStorage() and removed some cookie-related
        methods we no longer need in ResourceHandle.
        
        <rdar://problem/5244261> "Never" cookie policy was ignored on windows
        Need to set the cookie accept policy on each CFURLRequest.
        
        Reviewed by Oliver.

        * platform/network/ResourceHandle.h:
        * platform/network/cf/ResourceHandleCFNet.cpp:
        (WebCore::makeFinalRequest):
        * platform/network/cf/ResourceRequestCFNet.cpp:
        (WebCore::ResourceRequest::doUpdatePlatformRequest):
        * platform/network/win/CookieJarWin.cpp:
        (WebCore::setCookies):
        (WebCore::cookies):
        (WebCore::cookiesEnabled):

2007-10-11  Mark Rowe  <mrowe@apple.com>

        Reviewed by Tim Hatcher.

        Fix for <rdar://problem/5488678>.  Disable debugging symbols in production builds for 10.4
        PowerPC to prevent a huge STABS section from being generated.

        * Configurations/Base.xcconfig:

2007-10-11  Lars Knoll  <lars@trolltech.com>

        Reviewed by Erik Seidel and Simon.

        Ensure that setting innerHTML on an element doesn't do
        weird things with the document.
        Fixes most issues with http://bugs.webkit.org/show_bug.cgi?id=15456

        Test: fast/innerHTML/innerHTML-changing-document-properties.xhtml

        * dom/XMLTokenizer.cpp:
        (WebCore::XMLTokenizer::write):
        (WebCore::XMLTokenizer::startDocument):
        (WebCore::XMLTokenizer::end):
        (WebCore::):

2007-10-10  George Staikos  <staikos@kde.org>

        Reviewed by Adam Roben.

        Fix Qt build on Win32 with VS2005.

        * loader/FTPDirectoryDocument.cpp:
        (WebCore::processFileDateString):
        * loader/FTPDirectoryParser.cpp:
        (WebCore::parseOneFTPLine):

2007-10-10  Alice Liu  <alice.liu@apple.com>

        Reviewed by Geoff Garen.

        Fixed <rdar://5464402> Crash when running fast/frames/onload-remove-iframe-crash.html in DRT
        createFrame() now returns a RefPtr instead of a raw Frame pointer. 
        Making this change improves the way we handle frames on Windows webkit. 

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::loadSubframe):
        * loader/FrameLoaderClient.h:
        * platform/graphics/svg/SVGImageEmptyClients.h:
        (WebCore::SVGEmptyFrameLoaderClient::createFrame):

2007-10-10  Simon Hausmann  <hausmann@kde.org>

        Reviewed by Lars.

        Fix compilation using gcc 4.3. Header files have been reorganized and as a result some extra
        includes are needed for INT_MAX, std::auto_ptr and the like.

        WARNING: NO TEST CASES ADDED OR CHANGED

        * bridge/AXObjectCache.h:
        * ksvg2/misc/SVGDocumentExtensions.h:
        * platform/Base64.cpp:
        * platform/graphics/svg/SVGPaintServerPattern.h:
        * platform/graphics/svg/SVGResourceMasker.h:

2007-10-08  Sam Weinig  <sam@webkit.org>

        Reviewed by Steve Falkenburg.

        Fix for <rdar://problem/5519698> CrashTracer: [USER] 47 crashes in Safari at com.apple.WebCore: WebCore::XMLTokenizer::lineNumber const + 9

        Test: fast/innerHTML/innerHTML-script-tag-crash.xhtml

        * dom/XMLTokenizer.cpp:
        (WebCore::XMLTokenizer::lineNumber): Return 1 when there is no context.
        (WebCore::XMLTokenizer::columnNumber): ditto.

2007-10-08  Adam Roben  <aroben@apple.com>

        Fix Bug 15305: Crash when dragging an image when "load images automatically" preference is off

        http://bugs.webkit.org/show_bug.cgi?id=15305
        <rdar://problem/5524774>

        Reviewed by Eric Seidel.

        No test possible: to reproduce this you have to change a WebKit
        preference and reload the page. See
        http://bugs.webkit.org/show_bug.cgi?id=15414

        * platform/win/ClipboardWin.cpp:
        (WebCore::createGlobalImageFileDescriptor): ASSERT that we have an
        image and that it has a SharedBuffer.
        (WebCore::writeImageToDataObject): The fix: null-check imageBuffer.

2007-10-05  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Sam Weinig.
        
        New fix for <rdar://problem/5522487> REGRESSION: With JavaScript 
        disabled, any page load causes a crash in PropertyMap::put
        
        Explicitly remove the "document" property from the window. The old 
        solution would leave a stale "document" property around after JavaScript
        was re-enabled.

        The architecture for disabling JavaScript could use some consolidation. 
        It seems wrong that a script proxy even exists when JavaScript is 
        disabled. It also seems wrong that so many individual call sites are 
        responsible for checking whether JavaScript is enabled. I've filed a 
        bug about this: http://bugs.webkit.org/show_bug.cgi?id=15385.

        * bindings/js/kjs_proxy.cpp:
        (WebCore::KJSProxy::clearDocumentWrapper):
        * bindings/js/kjs_proxy.h:
        * page/Frame.cpp:
        (WebCore::Frame::setDocument):

2007-10-05  Jon Honeycutt  <jhoneycutt@apple.com>

        Reviewed by Anders.

        <rdar://5520913> Ticketmaster.com doesn't display correctly (Flash
        related?)

        The plugin is requesting files that don't exist on the server, and
        we are passing the 404 error page to the plugin. This change cancels the
        stream if the response code indicates a failure.

        This is a port of the safari / mac code.

        * loader/win/NetscapePlugInStreamLoaderWin.cpp:
        (WebCore::NetscapePlugInStreamLoader::didReceiveResponse): If the
        response code indicates a failure, cancel the stream

2007-10-05  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Sam Weinig.
        
        Fixed <rdar://problem/5522487> REGRESSION: With JavaScript disabled, 
        any page load causes a crash in PropertyMap::put
        
        The problem was that we were using JavaScript when JavaScript was
        disabled. The architecture for disabling JavaScript could use some
        consolidation, but this is the simplest, safest change for now.
        
        Currently passing layout tests still pass.

        * bindings/js/kjs_proxy.cpp:
        (WebCore::KJSProxy::updateDocumentWrapper):

2007-10-04  Beth Dakin  <bdakin@apple.com>

        Reviewed by John Sullivan.

        Fix for <rdar://problem/5441823> REGRESSION (r25142, Tiger only): 
        Vertical scroll bar not redrawn properly when going back in history 
        (15033)

        This fix if-defs r25142 to be Leopard-only since it causes 
        correctness issues on Tiger and does not seem to have any 
        performance impact on Tiger either.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::transitionToCommitted):

2007-10-05  Ada Chan  <adachan@apple.com>

        <rdar://problem/5436617> Favicons sometimes don't show up even when they are
        in the database
        - A client can try to retain an icon for a page before the database is actually
        opened.  Since isOpened() is not a requirement to retain an icon, remove the check
        for that.  Instead, we'll check to make sure whether this database is enabled
        before proceeding.

        Reviewed by Brady.

        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::retainIconForPageURL):
        (WebCore::IconDatabase::releaseIconForPageURL): only check isOpen() before we
        schedule for a sync.

2007-10-05  Lars Knoll  <lars@trolltech.com>

        Reviewed by olliej.

        fix a hang in editing/selection/extend-by-word-002.html

        * platform/qt/TextBreakIteratorQt.cpp:
        (WebCore::CharBreakIteratorQt::next):
        (WebCore::characterBreakIterator):

2007-10-04  Mark Rowe  <mrowe@apple.com>

        Reviewed by Oliver.

        Switch to default level of debugging symbols to resolve <rdar://problem/5488678>.
        The "full" level appears to offer no observable benefits even though the documentation
        suggests it be used for dead code stripping.  This should also decrease link times.

        * Configurations/Base.xcconfig:

2007-10-04  Adele Peterson  <adele@apple.com>

        Reviewed by Darin.

        WebCore part of fix for <rdar://problem/5369017> REGRESSION: Can't tab to webview that doesn't have editable content

        * page/FocusController.h: Added FocusDirection argument.
        * page/FocusController.cpp: (WebCore::FocusController::setInitialFocus):
          Use FocusDirection argument instead of key modifiers to send direction to advanceFocus.
        * WebCore.exp: Updated symbol.

2007-10-04  Kevin Decker  <kdecker@apple.com>

        Reviewed by John.
        
        <rdar://problems/5516309>
        
        * page/FrameView.cpp:
        (WebCore::FrameView::updateControlTints): Avoid the expense of updating tints on controls for the
        empty-window case since this can take a significant amount of time even on windows that have no
        content at all. Note this fix specifically optimizes the empty window/tab case; for a more broad
        fix John wrote up rdar://problem/5521050.

2007-10-04  Darin Adler  <darin@apple.com>

        * page/Frame.h: Put functions into categories to indicate other classes
        we'd like to move them into in the future. Just organizational -- no code
        change.

2007-10-04  Lars Knoll  <lars@trolltech.com>

        Reviewed by maciej.

        fix a crash in the FrameLoader that can happen under certain
        conditions in the Qt port.

        Test: fast/loader/iframe-crash-on-missing-image.xhtml

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::receivedMainResourceError):

2007-10-03  Alp Toker  <alp@atoker.com>

        Reviewed by Adam.

        http://bugs.webkit.org/show_bug.cgi?id=14726
        [gtk] API design. Mapping the WebView delegates to signals.

        Change the API namespace of the Gtk+ port from 'WebKitGtk' to 'WebKit'.

        * WebCore.pro:

2007-10-03  Alp Toker  <alp@atoker.com>

        Reviewed by Eric.

        http://bugs.webkit.org/show_bug.cgi?id=14129
        [CAIRO] Support the canvas element

        Add a new canvas implementation using Cairo for rendering.

        * html/CanvasGradient.cpp:
        (WebCore::CanvasGradient::CanvasGradient):
        (WebCore::CanvasGradient::~CanvasGradient):
        (WebCore::CanvasGradient::addColorStop):
        (WebCore::CanvasGradient::platformShading):
        * html/CanvasGradient.h:
        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::setFillStyle):
        (WebCore::CanvasRenderingContext2D::fill):
        (WebCore::CanvasRenderingContext2D::stroke):
        (WebCore::CanvasRenderingContext2D::fillRect):
        (WebCore::CanvasRenderingContext2D::drawImage):
        (WebCore::CanvasRenderingContext2D::applyStrokePattern):
        * html/CanvasStyle.cpp:
        (WebCore::CanvasStyle::applyStrokeColor):
        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::~HTMLCanvasElement):
        (WebCore::HTMLCanvasElement::reset):
        (WebCore::HTMLCanvasElement::paint):
        (WebCore::HTMLCanvasElement::createDrawingContext):
        (WebCore::HTMLCanvasElement::createPlatformImage):
        * html/HTMLCanvasElement.h:

2007-10-03  Lars Knoll  <lars@trolltech.com>

        Signed off by olliej.

        move WebKitQt to WebKit/qt for consistency with the other ports.

        WARNING: NO TEST CASES ADDED OR CHANGED

        * WebCore.pro:

2007-10-02  Sam Weinig  <sam@webkit.org>

        Reviewed by Oliver and Adam.

        Patch for <rdar://problem/5506968> Fail to DnD local file with non-ascii character in path from desktop to Safari (can open it with file menu)

        Use CoreFoundation to do the conversion from path to URL, as the Windows API was not
        correctly converting to UTF-8 and we know CFURL will.

        * platform/win/ClipboardUtilitiesWin.cpp:
        (WebCore::urlFromPath):
        (WebCore::getURL):

2007-10-02  Tristan O'Tierney  <tristan@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/5511842> REGRESSION: Webkit stops responding while loading Apple Store Canada page (15304)
        
        Included the NSSynchronousURLConnection_PrivateMode mode, in addition to the default run loop modes
        as an acceptable mode when using performSelectorOnMainThread with our syncronous url callbacks.

        * platform/network/mac/ResourceHandleMac.mm:
        (-[WebCoreResourceHandleAsDelegate connection:willCacheResponse:]):
        Added NSSynchronousURLConnection_PrivateMode to the list of accepted modes.

2007-10-02  Darin Adler  <darin@apple.com>

        Reviewed by Adam.

        - add support for GDI objects to OwnPtr; I plan to use this
          to fix some GDI handle leaks

        * css/CSSGrammar.y: Change parser to avoid macro that conflicts
        with macro defined in Windows system headers: FLOAT. This is needed
        because OwnPtr.h will now include <windows.h>.
        * css/CSSParser.cpp: (WebCore::CSSParser::lex): Ditto.
        * css/tokenizer.flex: Ditto.

        * platform/win/CursorWin.cpp: (WebCore::Cursor::Cursor):
        Use OwnPtr for a few HBITMAP objects as a test case.

        * platform/win/COMPtr.h: (COMPtr::COMPtr): Fix so that we can use
        Query with other COMPtr. Before this would not compile if it was
        ever instantiated.

2007-10-02  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Adam, Ada.

        Fix leak of GDI handle when we call MLANG.

        * platform/win/FontCacheWin.cpp:
        (WebCore::FontCache::getFontDataForCharacters):

2007-10-02  Lars Knoll  <lars@trolltech.com>

        Reviewed by Olliej.

        The cookies() method should only return the value of the
        cookie, not additional info such as the expiration date.

        * platform/qt/CookieJarQt.cpp:
        (WebCore::cookies):

2007-10-01  Lars Knoll  <lars@trolltech.com>

        Reviewed by Eric.

        Fix a wrong extension mapping in the MIMETypeRegistry and identify about: url's as frames in the FrameLoaderClient.

        * platform/qt/MIMETypeRegistryQt.cpp:
        (WebCore::):

2007-10-01  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Harrison.

        <rdar://problem/5516183> REGRESSION: Creating a ToDo on an incoming message fails
        
        Rolling out r25721.

        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::doApply):
        * editing/ReplaceSelectionCommand.h:

2007-10-01  Beth Dakin  <bdakin@apple.com>

        Reviewed by Adam.

        Fix for <rdar://problem/5515426> NetNewsWire 3 crashes at launch in 
        WebCore::FrameView::layout (other repro scenarios too)

        The new call to updateWidget() that we added to FrameView::layout() 
        can destroy the RenderPartObject. And so we were crashing on the 
        subsequent call to updateWidgetPosition(). This patch fixes that by 
        checking to make sure the RenderPartObject is still in the HashSet 
        after updateWidget(). Because m_widgetUpdateSet can be modified 
        during the call to updateWidget(), we need it to be intact while we 
        are iterating through the copy, so we cannot use the HashSet::swap 
        call we were using before. This patch instead uses a Vector to 
        iterate through the HashSet data and calls clear() on the HashSet 
        at the end.

        * page/FrameView.cpp:
        (WebCore::FrameView::layout):

2007-10-01  Eli Fidler  <eli@staikos.net>

        Reviewed by George Staikos.

        Switch bogus assert to a conditional and return.  This case happens
        when a widget is hidden.

        * platform/qt/WidgetQt.cpp:
        (WebCore::Widget::invalidateRect):

2007-09-30  Darin Adler  <darin@apple.com>

        Reviewed by Maciej.

        - tone down the assertion I asked Harrison to include in his fix for
          <rdar://problem/5511128>; it's OK to re-ref and deref the document
          as long as you do so after the children are done being destroyed

        No effect on release builds. Assertion change only.

        Besides the changes listed below, renamed m_hasDeleted flag to
        m_deletionHasBegun.

        * dom/ContainerNode.cpp: (WebCore::ContainerNode::removeAllChildren):
        Added code to set the m_deletionHasBegun flag and some assertions
        that test its state.

        * dom/Document.h: Removed m_hasDeleted -- we now use m_deletionHasBegun
        in the base class TreeShared.
        * dom/Document.cpp:
        (WebCore::Document::Document): Removed initialization of m_hasDeleted.
        (WebCore::Document::removedLastRef): Added code to clear
        m_inRemovedLastRefFunction if we end up deciding not to delete this.

        * platform/Shared.h:
        (WebCore::TreeShared::TreeShared): Added m_deletionHasBegun in addition to
        m_inRemovedLastRefFunction (formerly named m_hasRemovedLastRef).
        (WebCore::TreeShared::~TreeShared): Assert that m_deletionHasBegun is true.
        (WebCore::TreeShared::ref): Assert neither flag is true.
        (WebCore::TreeShared::deref): Ditto.
        (WebCore::TreeShared::hasOneRef): Ditto.
        (WebCore::TreeShared::removedLastRef): Made private. Added code to
        set m_hasDeleted to true. Also removed cast; since this class template
        has a virtual destructor, we don't need to cast before calling delete.

2007-09-29  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Mark.

        -Fix http://bugs.webkit.org/show_bug.cgi?id=13226.
        Remove Bakefiles from svn.

        * Projects/gdk/webcore-gdk.bkl: Removed.
        * Projects/wx/webcore-wx.bkl: Removed.
        * WebCoreSources.bkl: Removed.
        * webcore-base.bkl: Removed.

2007-09-28  Jan Michael Alonzo  <jmalonzo@unpluggable.com>

        Reviewed by Mark.

        -Fix http://bugs.webkit.org/show_bug.cgi?id=15254.

        * platform/gtk/RenderThemeGtk.cpp:
        (WebCore::RenderThemeGtk::determineState):
            - Apply state if control is readonly
            - Added state GTK_STATE_SELECTED of object is checked
            - Apply GTK_STATE_ACTIVE if RenderObject isFocused()
        (WebCore::RenderThemeGtk::paintTextField):
        (WebCore::RenderThemeGtk::gtkEntry):
            - Implemented theme-aware text field based on gtk/gtkentry.c implementation

2007-09-29  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Eric.

        Build fix for Mac Gtk+ and Qt builds. In revision 25798 changing
        XSLTProcessor.cpp was forgotten.

        * xml/XSLTProcessor.cpp: Use PLATFORM(MAC) instead of PLATFORM(DARWIN)

2007-09-29  Adam Roben  <aroben@apple.com>

        Fix <rdar://4965715> Horizontal scrollwheel scrolling moves in opposite direction on Vista

        Reviewed by Sam.

        No regression test possible.

        * platform/win/WheelEventWin.cpp:
        (WebCore::PlatformWheelEvent::PlatformWheelEvent): Use a negative
        delta when scrolling right to match EventHandler's expectations (which
        are based on AppKit).

2007-09-28  Kevin Decker  <kdecker@apple.com>

        Reviewed by Mark Rowe

        Build fix for Mac Gtk+ and Qt builds.
        
        * xml/XSLStyleSheet.cpp: Use PLATFORM(MAC) instead of PLATFORM(DARWIN)
        * xml/XSLTExtensions.cpp: Ditto.

2007-09-28  David Harrison  <harrison@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/5511128> Crash closing or reloading this SVG

        * dom/ContainerNode.cpp:
        (WebCore::dispatchChildInsertionEvents):
        (WebCore::dispatchChildRemovalEvents):
        Use DocPtr instead of RefPtr, since these events are dispatched
        when the Document is being being torn down by removedLastRef().

        * dom/DocPtr.h:
        (WebCore::DocPtr::DocPtr):
        Fix longstanding typo in template so that the DocPtr(DocPtr) constructor can be used.

        * dom/Document.cpp:
        (WebCore::Document::Document):
        (WebCore::Document::removedLastRef):
        * dom/Document.h:
        (WebCore::Document::selfOnlyRef):
        (WebCore::Document::selfOnlyDeref):
        * platform/Shared.h:
        (WebCore::Shared::Shared):
        (WebCore::Shared::ref):
        (WebCore::Shared::deref):
        (WebCore::Shared::hasOneRef):
        (WebCore::TreeShared::TreeShared):
        (WebCore::TreeShared::ref):
        (WebCore::TreeShared::deref):
        (WebCore::TreeShared::hasOneRef):
        (WebCore::TreeShared::refCount):
        Add debug-only checks for a document being ref-counted while being deleted.

2007-09-27  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Darin.

        - <rdar://5261371> Nothing downloaded when exporting bookmarks from iGoogle web history

        Function for use by WebKit. Currently used only on Windows.

        * platform/network/ResourceResponse.cpp:
        (WebCore::ResourceResponse::isAttachment):
        * platform/network/ResourceResponse.h:

2007-09-27  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Dave Hyatt.

        - fix http://bugs.webkit.org/show_bug.cgi?id=15262
          REGRESSION: Margin-top:18px is pushing down the multiple select list box outside the div.

        Reflected in existing tests.

        * css/html4.css: Changed listboxes to use border-box sizing, to match Firefox,
        WinIE and apparently also Safari 2.

2007-09-27  Kevin Decker  <kdecker@apple.com>

        <rdar://problem/5493093>
    
        Rubber stamped by John Sullivan.
        
        * WebCore.order: Added.
        * WebCore.xcodeproj/project.pbxproj:  We're changing from using an order file built by another team to using one
         we actually check into our project repository. Linker settings for Symbol Ordering Flags have been updated
         accordingly.
         
2007-09-27  Antti Koivisto  <antti@apple.com>

        Reviewed by Geoff.
        
        Fix for <rdar://problem/5499125>
        REGRESSION (r21367): After launching Kidzui beta, a webview frame fails to appear in its main window
        
        If window object properties were modified when it had initial empty document (synchronously after 
        window.open() for example) those modifications were lost when the real document was switched in.
        
        Match Firefox behavior where window properties are not cleared if the inital document and the loaded one
        have matching security domains.

        Tests: fast/dom/Window/window-early-properties.html
               http/tests/security/window-properties-clear-domain.html
               http/tests/security/window-properties-clear-port.html
               http/tests/security/window-properties-pass.html

        * WebCore.exp:
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::FrameLoader):
        (WebCore::FrameLoader::init):
        (WebCore::FrameLoader::clear):
        (WebCore::FrameLoader::isSecureTransition):
        (WebCore::FrameLoader::begin):
        * loader/FrameLoader.h:
        If we are transitioning from initial empty document to the final one, do a domain security check
        between old security policy URL and new URL. If that passes don't clear script proxy and script objects.
        
        * bindings/js/kjs_proxy.cpp:
        (WebCore::KJSProxy::updateDocumentWrapper):
        * bindings/js/kjs_proxy.h:
        * page/Frame.cpp:
        (WebCore::Frame::setDocument):
        Since we don't always clear window properties anymore, we need to update the document property to point to
        the newly created one. 
        
2007-09-27  Kevin Decker  <kdecker@apple.com>

        Reviewed by Darin.

        <rdar://problem/5493093>
        
        * WebCore.xcodeproj/project.pbxproj: Removed libxslt from statically linked frameworks.
        * platform/mac/SoftLinking.h: Formatting tweakes, added SOFT_LINK_LIBRARY, and if'def for 
        PLATFORM(DARWIN)
        * xml/XSLStyleSheet.cpp: Soft-linked libxslt.
        * xml/XSLTExtensions.cpp: Removed the call to xsltGenericError, and added a FIXME comment stating
        that it might be helpful to push any errors from xmlXPathNewValueTree up to the Javascript Console. 
        * xml/XSLTProcessor.cpp: Soft-linked libxslt.
        
2007-09-27  Adele Peterson  <adele@apple.com>

        Reviewed by Brady.

        Fix for <rdar://problem/5453350> REGRESSION (r18541, Tiger only): Refreshing a cached https page does not reload CSS and JavaScript resources
        http://bugs.webkit.org/show_bug.cgi?id=15121

        * loader/FrameLoader.cpp: (WebCore::FrameLoader::addExtraFieldsToRequest): Now sets the cache policy to ReloadIgnoringCacheData.  Without setting the cache policy,
        the default policy in this case was ReturnCacheDataElseLoad.  If we're in a situation where the resource is in the cache, we want to make sure to avoid loading from the cache in this case.

2007-09-27  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5199546> CrashTracer: [REGRESSION] 8216 crashes in Safari at com.apple.WebCore: WebCore::ResourceHandle::client const + 6

        On Tiger NSURLConnection can sometimes call the connection:willCacheResponse: delegate method on
        a secondary thread instead of the main thread. This was never an issue before, since the implementation 
        of this method was very simple and thread safe.

        The fix is to block during connection:willCacheResponse: and perform the work on the main thread.
        We need to block since this delegate method needs to return a result. If we are already on the
        main thread (which sometimes we are), the method does nothing different. If we are on a secondary
        thread, we make a mutable dictionary to hold all the arguments and later the result object.
        Then performSelectorOnMainThread:withObject: using the _callConnectionWillCacheResponseWithInfo:
        selector. This new method just pulls the arguments out for the dictionary and calls the real
        connection:willCacheResponse: delegate method (this time on the main thread). The result is stored
        in the dictionary, and when performSelectorOnMainThread:withObject: finishes the result is pulled
        out and returned.

        * platform/network/mac/ResourceHandleMac.mm:
        (-[WebCoreResourceHandleAsDelegate _callConnectionWillCacheResponseWithInfo:]):
        (-[WebCoreResourceHandleAsDelegate connection:willCacheResponse:]):

2007-09-27  David Hyatt  <hyatt@apple.com>

        Update to reflect the minimal WebKitSystemInterface changes required
        to support @font-face.

        Reviewed by john

        * platform/mac/FontDataMac.mm:
        (WebCore::FontData::platformInit):
        (WebCore::FontData::platformWidthForGlyph):
        * platform/mac/WebCoreSystemInterface.h:
        * platform/mac/WebCoreSystemInterface.mm:

2007-09-26  Darin Adler  <darin@apple.com>

        - fix Windows build

        * platform/win/ClipboardWin.cpp:
        (WebCore::writeURL): Add a check for empty URL. Remove the check for invalid URL.
        (WebCore::ClipboardWin::setData): Remove the check for invalid URL.
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginViewWin::start): Check for empty URL instead of invalid URL.
        (WebCore::PluginViewWin::load): Same here.

2007-09-26  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fix <rdar://problem/5491054> REGRESSION (Mail, plain-text only): Nothing happens
          when you click on rdar://<num>&<num> links (or AOL links in Safari)

        Remove the non-useful concept of a "malformed"/"invalid" URL.

        There are URLs we can parse, and others we can't, but that's not sufficient to
        determine if we should try to work with the URL. It's entirely possible that
        a so-called "malformed" URL will work just fine if it's passed to the right
        software.

        * platform/KURL.h: Removed isMalformed() and isValid().

        * loader/Cache.cpp: (WebCore::Cache::requestResource): Removed unneeded check
        if the URL is valid. But do check for an empty URL just to guarantee we don't
        trip up with a null string. It's possible we can remove this empty URL check
        later, but it's less risky to leave the empty string behavior alone for now.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::urlSelected): Removed unneeded check if the URL is valid.
        Back on 2007-07-08, we realized that we needed to allow empty URLs. But we also
        need to allow other URLs here. This is the code path from the Mail case.
        (WebCore::FrameLoader::submitForm): Replaced URL validity check with a check
        for an empty URL (same reasoning as for requestResource above).

        * page/InspectorController.cpp: (WebCore::InspectorResource::type):
        * rendering/RenderObject.cpp: (WebCore::RenderObject::addPDFURLRect):
        Removed unneeded check for an invalid URL. In both of these cases it's definitely
        safe to allow event an empty URL.

2007-09-26  George Staikos  <staikos@kde.org>

        Reviewed by John Sullivan.

        Only highlight the applicable portion of the text run for a search
        highlight.  No way to make a testcase for this presently.

        * rendering/InlineTextBox.cpp:
        (WebCore::InlineTextBox::paintTextMatchMarker):

2007-09-25  David Kilzer  <ddkilzer@webkit.org>

        Reviewed by Adam.

        - Fix http://bugs.webkit.org/show_bug.cgi?id=14885
          LGPL'ed files contain incorrect FSF address

        * LICENSE-LGPL-2:
        * LICENSE-LGPL-2.1:
        * WebCorePrefix.h:
        * bindings/js/JSCanvasRenderingContext2DCustom.cpp:
        * bindings/js/JSDOMWindowCustom.cpp:
        * bindings/js/JSDocumentCustom.cpp:
        * bindings/js/JSHTMLCollectionCustom.cpp:
        * bindings/js/JSHTMLElementWrapperFactory.cpp:
        * bindings/js/JSHTMLElementWrapperFactory.h:
        * bindings/js/JSHTMLInputElementBase.cpp:
        * bindings/js/JSHTMLInputElementBase.h:
        * bindings/js/JSHTMLOptionElementConstructor.cpp:
        * bindings/js/JSHTMLOptionElementConstructor.h:
        * bindings/js/JSHTMLOptionsCollectionCustom.cpp:
        * bindings/js/JSHTMLSelectElementCustom.cpp:
        * bindings/js/JSNodeFilterCondition.cpp:
        * bindings/js/JSNodeFilterCondition.h:
        * bindings/js/JSNodeIteratorCustom.cpp:
        * bindings/js/JSSVGElementWrapperFactory.cpp:
        * bindings/js/JSSVGElementWrapperFactory.h:
        * bindings/js/JSSVGMatrixCustom.cpp:
        * bindings/js/JSSVGPathSegCustom.cpp:
        * bindings/js/JSSVGPathSegListCustom.cpp:
        * bindings/js/JSSVGPointListCustom.cpp:
        * bindings/js/JSTreeWalkerCustom.cpp:
        * bindings/js/JSXMLHttpRequest.cpp:
        * bindings/js/JSXMLHttpRequest.h:
        * bindings/js/kjs_binding.cpp:
        * bindings/js/kjs_binding.h:
        * bindings/js/kjs_css.cpp:
        * bindings/js/kjs_css.h:
        * bindings/js/kjs_dom.cpp:
        * bindings/js/kjs_dom.h:
        * bindings/js/kjs_events.cpp:
        * bindings/js/kjs_events.h:
        * bindings/js/kjs_html.cpp:
        * bindings/js/kjs_html.h:
        * bindings/js/kjs_navigator.cpp:
        * bindings/js/kjs_navigator.h:
        * bindings/js/kjs_proxy.cpp:
        * bindings/js/kjs_proxy.h:
        * bindings/js/kjs_window.cpp:
        * bindings/js/kjs_window.h:
        * bindings/objc/DOMImplementationFront.cpp:
        * bindings/objc/DOMImplementationFront.h:
        * bindings/scripts/CodeGenerator.pm:
        * bindings/scripts/CodeGeneratorJS.pm:
        * bindings/scripts/CodeGeneratorObjC.pm:
        * bindings/scripts/IDLParser.pm:
        * bindings/scripts/IDLStructure.pm:
        * bindings/scripts/generate-bindings.pl:
        * config.h:
        * css/CSSBorderImageValue.cpp:
        * css/CSSBorderImageValue.h:
        * css/CSSCharsetRule.cpp:
        * css/CSSCharsetRule.h:
        * css/CSSCharsetRule.idl:
        * css/CSSComputedStyleDeclaration.cpp:
        * css/CSSComputedStyleDeclaration.h:
        * css/CSSCursorImageValue.cpp:
        * css/CSSCursorImageValue.h:
        * css/CSSFontFaceRule.cpp:
        * css/CSSFontFaceRule.h:
        * css/CSSFontFaceRule.idl:
        * css/CSSGrammar.y:
        * css/CSSHelper.cpp:
        * css/CSSHelper.h:
        * css/CSSImageValue.cpp:
        * css/CSSImageValue.h:
        * css/CSSImportRule.cpp:
        * css/CSSImportRule.h:
        * css/CSSImportRule.idl:
        * css/CSSInheritedValue.cpp:
        * css/CSSInheritedValue.h:
        * css/CSSInitialValue.cpp:
        * css/CSSInitialValue.h:
        * css/CSSMediaRule.cpp:
        * css/CSSMediaRule.h:
        * css/CSSMediaRule.idl:
        * css/CSSMutableStyleDeclaration.cpp:
        * css/CSSMutableStyleDeclaration.h:
        * css/CSSNamespace.h:
        * css/CSSPageRule.cpp:
        * css/CSSPageRule.h:
        * css/CSSPageRule.idl:
        * css/CSSParser.cpp:
        * css/CSSParser.h:
        * css/CSSPrimitiveValue.cpp:
        * css/CSSPrimitiveValue.h:
        * css/CSSPrimitiveValue.idl:
        * css/CSSProperty.cpp:
        * css/CSSProperty.h:
        * css/CSSQuirkPrimitiveValue.h:
        * css/CSSRule.cpp:
        * css/CSSRule.h:
        * css/CSSRule.idl:
        * css/CSSRuleList.cpp:
        * css/CSSRuleList.h:
        * css/CSSSelector.cpp:
        * css/CSSSelector.h:
        * css/CSSStyleDeclaration.cpp:
        * css/CSSStyleDeclaration.h:
        * css/CSSStyleDeclaration.idl:
        * css/CSSStyleRule.cpp:
        * css/CSSStyleRule.h:
        * css/CSSStyleRule.idl:
        * css/CSSStyleSelector.cpp:
        * css/CSSStyleSelector.h:
        * css/CSSStyleSheet.cpp:
        * css/CSSStyleSheet.h:
        * css/CSSStyleSheet.idl:
        * css/CSSUnknownRule.h:
        * css/CSSUnknownRule.idl:
        * css/CSSValue.h:
        * css/CSSValue.idl:
        * css/CSSValueList.cpp:
        * css/CSSValueList.h:
        * css/Counter.h:
        * css/Counter.idl:
        * css/DashboardRegion.h:
        * css/FontFamilyValue.cpp:
        * css/FontFamilyValue.h:
        * css/FontValue.cpp:
        * css/FontValue.h:
        * css/MediaFeatureNames.cpp:
        * css/MediaFeatureNames.h:
        * css/MediaList.cpp:
        * css/MediaList.h:
        * css/Pair.h:
        * css/RGBColor.idl:
        * css/Rect.h:
        * css/Rect.idl:
        * css/ShadowValue.cpp:
        * css/ShadowValue.h:
        * css/StyleBase.cpp:
        * css/StyleBase.h:
        * css/StyleList.cpp:
        * css/StyleList.h:
        * css/StyleSheet.cpp:
        * css/StyleSheet.h:
        * css/StyleSheet.idl:
        * css/StyleSheetList.cpp:
        * css/StyleSheetList.h:
        * css/StyleSheetList.idl:
        * css/html4.css:
        * css/make-css-file-arrays.pl:
        * css/makegrammar.pl:
        * css/makeprop.pl:
        * css/maketokenizer:
        * css/makevalues.pl:
        * css/quirks.css:
        * dom/AtomicStringList.h:
        * dom/Attr.cpp:
        * dom/Attr.h:
        * dom/Attr.idl:
        * dom/Attribute.cpp:
        * dom/Attribute.h:
        * dom/BeforeUnloadEvent.cpp:
        * dom/BeforeUnloadEvent.h:
        * dom/CDATASection.cpp:
        * dom/CDATASection.h:
        * dom/CDATASection.idl:
        * dom/CSSMappedAttributeDeclaration.cpp:
        * dom/CSSMappedAttributeDeclaration.h:
        * dom/CharacterData.cpp:
        * dom/CharacterData.h:
        * dom/CharacterData.idl:
        * dom/ChildNodeList.cpp:
        * dom/ChildNodeList.h:
        * dom/Clipboard.h:
        * dom/ClipboardEvent.cpp:
        * dom/ClipboardEvent.h:
        * dom/Comment.cpp:
        * dom/Comment.h:
        * dom/Comment.idl:
        * dom/ContainerNode.cpp:
        * dom/ContainerNode.h:
        * dom/DOMImplementation.cpp:
        * dom/DOMImplementation.h:
        * dom/DOMImplementation.idl:
        * dom/DocPtr.h:
        * dom/Document.cpp:
        * dom/Document.h:
        * dom/Document.idl:
        * dom/DocumentFragment.cpp:
        * dom/DocumentFragment.h:
        * dom/DocumentFragment.idl:
        * dom/DocumentMarker.h:
        * dom/DocumentType.cpp:
        * dom/DocumentType.h:
        * dom/DocumentType.idl:
        * dom/EditingText.cpp:
        * dom/EditingText.h:
        * dom/Element.cpp:
        * dom/Element.h:
        * dom/Element.idl:
        * dom/Entity.cpp:
        * dom/Entity.h:
        * dom/Entity.idl:
        * dom/EntityReference.cpp:
        * dom/EntityReference.h:
        * dom/EntityReference.idl:
        * dom/Event.cpp:
        * dom/Event.h:
        * dom/Event.idl:
        * dom/EventListener.h:
        * dom/EventListener.idl:
        * dom/EventNames.cpp:
        * dom/EventNames.h:
        * dom/EventTarget.idl:
        * dom/EventTargetNode.cpp:
        * dom/EventTargetNode.h:
        * dom/ExceptionCode.h:
        * dom/KeyboardEvent.cpp:
        * dom/KeyboardEvent.h:
        * dom/KeyboardEvent.idl:
        * dom/MappedAttribute.cpp:
        * dom/MappedAttribute.h:
        * dom/MappedAttributeEntry.h:
        * dom/MouseEvent.cpp:
        * dom/MouseEvent.h:
        * dom/MouseEvent.idl:
        * dom/MouseRelatedEvent.cpp:
        * dom/MouseRelatedEvent.h:
        * dom/MutationEvent.cpp:
        * dom/MutationEvent.h:
        * dom/MutationEvent.idl:
        * dom/NameNodeList.cpp:
        * dom/NameNodeList.h:
        * dom/NamedAttrMap.cpp:
        * dom/NamedAttrMap.h:
        * dom/NamedMappedAttrMap.cpp:
        * dom/NamedMappedAttrMap.h:
        * dom/NamedNodeMap.h:
        * dom/NamedNodeMap.idl:
        * dom/Node.cpp:
        * dom/Node.h:
        * dom/Node.idl:
        * dom/NodeFilter.cpp:
        * dom/NodeFilter.h:
        * dom/NodeFilter.idl:
        * dom/NodeFilterCondition.cpp:
        * dom/NodeFilterCondition.h:
        * dom/NodeIterator.cpp:
        * dom/NodeIterator.h:
        * dom/NodeIterator.idl:
        * dom/NodeList.cpp:
        * dom/NodeList.h:
        * dom/NodeList.idl:
        * dom/Notation.cpp:
        * dom/Notation.h:
        * dom/Notation.idl:
        * dom/ProcessingInstruction.cpp:
        * dom/ProcessingInstruction.h:
        * dom/ProcessingInstruction.idl:
        * dom/QualifiedName.cpp:
        * dom/QualifiedName.h:
        * dom/Range.cpp:
        * dom/Range.h:
        * dom/Range.idl:
        * dom/RangeException.h:
        * dom/RangeException.idl:
        * dom/RegisteredEventListener.cpp:
        * dom/RegisteredEventListener.h:
        * dom/StyleElement.cpp:
        * dom/StyleElement.h:
        * dom/StyledElement.cpp:
        * dom/StyledElement.h:
        * dom/Text.cpp:
        * dom/Text.h:
        * dom/Text.idl:
        * dom/Tokenizer.h:
        * dom/Traversal.cpp:
        * dom/Traversal.h:
        * dom/TreeWalker.cpp:
        * dom/TreeWalker.h:
        * dom/TreeWalker.idl:
        * dom/UIEvent.cpp:
        * dom/UIEvent.h:
        * dom/UIEvent.idl:
        * dom/UIEventWithKeyState.cpp:
        * dom/UIEventWithKeyState.h:
        * dom/WheelEvent.cpp:
        * dom/WheelEvent.h:
        * dom/WheelEvent.idl:
        * dom/XMLTokenizer.cpp:
        * dom/XMLTokenizer.h:
        * html/FormDataList.cpp:
        * html/FormDataList.h:
        * html/HTMLAnchorElement.cpp:
        * html/HTMLAnchorElement.h:
        * html/HTMLAnchorElement.idl:
        * html/HTMLAppletElement.cpp:
        * html/HTMLAppletElement.h:
        * html/HTMLAppletElement.idl:
        * html/HTMLAreaElement.cpp:
        * html/HTMLAreaElement.h:
        * html/HTMLAreaElement.idl:
        * html/HTMLBRElement.cpp:
        * html/HTMLBRElement.h:
        * html/HTMLBRElement.idl:
        * html/HTMLBaseElement.cpp:
        * html/HTMLBaseElement.h:
        * html/HTMLBaseElement.idl:
        * html/HTMLBaseFontElement.cpp:
        * html/HTMLBaseFontElement.h:
        * html/HTMLBaseFontElement.idl:
        * html/HTMLBlockquoteElement.cpp:
        * html/HTMLBlockquoteElement.h:
        * html/HTMLBlockquoteElement.idl:
        * html/HTMLBodyElement.cpp:
        * html/HTMLBodyElement.h:
        * html/HTMLBodyElement.idl:
        * html/HTMLButtonElement.cpp:
        * html/HTMLButtonElement.h:
        * html/HTMLButtonElement.idl:
        * html/HTMLCollection.cpp:
        * html/HTMLCollection.h:
        * html/HTMLCollection.idl:
        * html/HTMLDListElement.cpp:
        * html/HTMLDListElement.h:
        * html/HTMLDListElement.idl:
        * html/HTMLDirectoryElement.cpp:
        * html/HTMLDirectoryElement.h:
        * html/HTMLDirectoryElement.idl:
        * html/HTMLDivElement.cpp:
        * html/HTMLDivElement.h:
        * html/HTMLDivElement.idl:
        * html/HTMLDocument.cpp:
        * html/HTMLDocument.h:
        * html/HTMLDocument.idl:
        * html/HTMLElement.cpp:
        * html/HTMLElement.h:
        * html/HTMLElement.idl:
        * html/HTMLElementFactory.cpp:
        * html/HTMLElementFactory.h:
        * html/HTMLEmbedElement.cpp:
        * html/HTMLEmbedElement.h:
        * html/HTMLEmbedElement.idl:
        * html/HTMLEntityNames.gperf:
        * html/HTMLFieldSetElement.cpp:
        * html/HTMLFieldSetElement.h:
        * html/HTMLFieldSetElement.idl:
        * html/HTMLFontElement.cpp:
        * html/HTMLFontElement.h:
        * html/HTMLFontElement.idl:
        * html/HTMLFormCollection.cpp:
        * html/HTMLFormCollection.h:
        * html/HTMLFormElement.cpp:
        * html/HTMLFormElement.h:
        * html/HTMLFormElement.idl:
        * html/HTMLFrameElement.cpp:
        * html/HTMLFrameElement.h:
        * html/HTMLFrameElement.idl:
        * html/HTMLFrameElementBase.cpp:
        * html/HTMLFrameElementBase.h:
        * html/HTMLFrameOwnerElement.cpp:
        * html/HTMLFrameOwnerElement.h:
        * html/HTMLFrameSetElement.cpp:
        * html/HTMLFrameSetElement.h:
        * html/HTMLFrameSetElement.idl:
        * html/HTMLGenericFormElement.cpp:
        * html/HTMLGenericFormElement.h:
        * html/HTMLHRElement.cpp:
        * html/HTMLHRElement.h:
        * html/HTMLHRElement.idl:
        * html/HTMLHeadElement.cpp:
        * html/HTMLHeadElement.h:
        * html/HTMLHeadElement.idl:
        * html/HTMLHeadingElement.cpp:
        * html/HTMLHeadingElement.h:
        * html/HTMLHeadingElement.idl:
        * html/HTMLHtmlElement.cpp:
        * html/HTMLHtmlElement.h:
        * html/HTMLHtmlElement.idl:
        * html/HTMLIFrameElement.cpp:
        * html/HTMLIFrameElement.h:
        * html/HTMLIFrameElement.idl:
        * html/HTMLImageElement.cpp:
        * html/HTMLImageElement.h:
        * html/HTMLImageElement.idl:
        * html/HTMLImageLoader.cpp:
        * html/HTMLImageLoader.h:
        * html/HTMLInputElement.cpp:
        * html/HTMLInputElement.h:
        * html/HTMLInputElement.idl:
        * html/HTMLIsIndexElement.cpp:
        * html/HTMLIsIndexElement.h:
        * html/HTMLIsIndexElement.idl:
        * html/HTMLKeygenElement.cpp:
        * html/HTMLKeygenElement.h:
        * html/HTMLLIElement.cpp:
        * html/HTMLLIElement.h:
        * html/HTMLLIElement.idl:
        * html/HTMLLabelElement.cpp:
        * html/HTMLLabelElement.h:
        * html/HTMLLabelElement.idl:
        * html/HTMLLegendElement.cpp:
        * html/HTMLLegendElement.h:
        * html/HTMLLegendElement.idl:
        * html/HTMLLinkElement.cpp:
        * html/HTMLLinkElement.h:
        * html/HTMLLinkElement.idl:
        * html/HTMLMapElement.cpp:
        * html/HTMLMapElement.h:
        * html/HTMLMapElement.idl:
        * html/HTMLMarqueeElement.cpp:
        * html/HTMLMarqueeElement.h:
        * html/HTMLMarqueeElement.idl:
        * html/HTMLMenuElement.cpp:
        * html/HTMLMenuElement.h:
        * html/HTMLMenuElement.idl:
        * html/HTMLMetaElement.cpp:
        * html/HTMLMetaElement.h:
        * html/HTMLMetaElement.idl:
        * html/HTMLModElement.cpp:
        * html/HTMLModElement.h:
        * html/HTMLModElement.idl:
        * html/HTMLNameCollection.cpp:
        * html/HTMLNameCollection.h:
        * html/HTMLOListElement.cpp:
        * html/HTMLOListElement.h:
        * html/HTMLOListElement.idl:
        * html/HTMLObjectElement.cpp:
        * html/HTMLObjectElement.h:
        * html/HTMLObjectElement.idl:
        * html/HTMLOptGroupElement.cpp:
        * html/HTMLOptGroupElement.h:
        * html/HTMLOptGroupElement.idl:
        * html/HTMLOptionElement.cpp:
        * html/HTMLOptionElement.h:
        * html/HTMLOptionElement.idl:
        * html/HTMLOptionsCollection.cpp:
        * html/HTMLOptionsCollection.h:
        * html/HTMLOptionsCollection.idl:
        * html/HTMLParagraphElement.cpp:
        * html/HTMLParagraphElement.h:
        * html/HTMLParagraphElement.idl:
        * html/HTMLParamElement.cpp:
        * html/HTMLParamElement.h:
        * html/HTMLParamElement.idl:
        * html/HTMLParser.cpp:
        * html/HTMLParser.h:
        * html/HTMLPlugInElement.cpp:
        * html/HTMLPlugInElement.h:
        * html/HTMLPreElement.cpp:
        * html/HTMLPreElement.h:
        * html/HTMLPreElement.idl:
        * html/HTMLQuoteElement.cpp:
        * html/HTMLQuoteElement.h:
        * html/HTMLQuoteElement.idl:
        * html/HTMLScriptElement.cpp:
        * html/HTMLScriptElement.h:
        * html/HTMLScriptElement.idl:
        * html/HTMLSelectElement.cpp:
        * html/HTMLSelectElement.h:
        * html/HTMLSelectElement.idl:
        * html/HTMLStyleElement.cpp:
        * html/HTMLStyleElement.h:
        * html/HTMLStyleElement.idl:
        * html/HTMLTableCaptionElement.cpp:
        * html/HTMLTableCaptionElement.h:
        * html/HTMLTableCaptionElement.idl:
        * html/HTMLTableCellElement.cpp:
        * html/HTMLTableCellElement.h:
        * html/HTMLTableCellElement.idl:
        * html/HTMLTableColElement.cpp:
        * html/HTMLTableColElement.h:
        * html/HTMLTableColElement.idl:
        * html/HTMLTableElement.cpp:
        * html/HTMLTableElement.h:
        * html/HTMLTableElement.idl:
        * html/HTMLTablePartElement.cpp:
        * html/HTMLTablePartElement.h:
        * html/HTMLTableRowElement.cpp:
        * html/HTMLTableRowElement.h:
        * html/HTMLTableRowElement.idl:
        * html/HTMLTableSectionElement.cpp:
        * html/HTMLTableSectionElement.h:
        * html/HTMLTableSectionElement.idl:
        * html/HTMLTextAreaElement.cpp:
        * html/HTMLTextAreaElement.h:
        * html/HTMLTextAreaElement.idl:
        * html/HTMLTitleElement.cpp:
        * html/HTMLTitleElement.h:
        * html/HTMLTitleElement.idl:
        * html/HTMLTokenizer.cpp:
        * html/HTMLTokenizer.h:
        * html/HTMLUListElement.cpp:
        * html/HTMLUListElement.h:
        * html/HTMLUListElement.idl:
        * ksvg2/css/SVGCSSParser.cpp:
        * ksvg2/css/SVGCSSStyleSelector.cpp:
        * ksvg2/css/SVGRenderStyle.cpp:
        * ksvg2/css/SVGRenderStyle.h:
        * ksvg2/css/SVGRenderStyleDefs.cpp:
        * ksvg2/css/SVGRenderStyleDefs.h:
        * ksvg2/events/JSSVGLazyEventListener.cpp:
        * ksvg2/events/JSSVGLazyEventListener.h:
        * ksvg2/events/SVGZoomEvent.cpp:
        * ksvg2/events/SVGZoomEvent.h:
        * ksvg2/misc/KCanvasRenderingStyle.cpp:
        * ksvg2/misc/KCanvasRenderingStyle.h:
        * ksvg2/misc/PointerEventsHitRules.cpp:
        * ksvg2/misc/PointerEventsHitRules.h:
        * ksvg2/misc/SVGDocumentExtensions.cpp:
        * ksvg2/misc/SVGDocumentExtensions.h:
        * ksvg2/misc/SVGImageLoader.cpp:
        * ksvg2/misc/SVGImageLoader.h:
        * ksvg2/misc/SVGTimer.cpp:
        * ksvg2/misc/SVGTimer.h:
        * ksvg2/misc/TimeScheduler.cpp:
        * ksvg2/misc/TimeScheduler.h:
        * ksvg2/scripts/cssmakeprops:
        * ksvg2/scripts/cssmakevalues:
        * ksvg2/svg/ColorDistance.cpp:
        * ksvg2/svg/ColorDistance.h:
        * ksvg2/svg/GradientAttributes.h:
        * ksvg2/svg/LinearGradientAttributes.h:
        * ksvg2/svg/PatternAttributes.h:
        * ksvg2/svg/RadialGradientAttributes.h:
        * ksvg2/svg/SVGAElement.cpp:
        * ksvg2/svg/SVGAElement.h:
        * ksvg2/svg/SVGAngle.cpp:
        * ksvg2/svg/SVGAngle.h:
        * ksvg2/svg/SVGAngle.idl:
        * ksvg2/svg/SVGAnimateColorElement.cpp:
        * ksvg2/svg/SVGAnimateColorElement.h:
        * ksvg2/svg/SVGAnimateElement.cpp:
        * ksvg2/svg/SVGAnimateElement.h:
        * ksvg2/svg/SVGAnimateMotionElement.cpp:
        * ksvg2/svg/SVGAnimateMotionElement.h:
        * ksvg2/svg/SVGAnimateTransformElement.cpp:
        * ksvg2/svg/SVGAnimateTransformElement.h:
        * ksvg2/svg/SVGAnimatedPathData.cpp:
        * ksvg2/svg/SVGAnimatedPathData.h:
        * ksvg2/svg/SVGAnimatedPoints.cpp:
        * ksvg2/svg/SVGAnimatedPoints.h:
        * ksvg2/svg/SVGAnimatedTemplate.h:
        * ksvg2/svg/SVGAnimationElement.cpp:
        * ksvg2/svg/SVGAnimationElement.h:
        * ksvg2/svg/SVGCircleElement.cpp:
        * ksvg2/svg/SVGCircleElement.h:
        * ksvg2/svg/SVGClipPathElement.cpp:
        * ksvg2/svg/SVGClipPathElement.h:
        * ksvg2/svg/SVGColor.cpp:
        * ksvg2/svg/SVGColor.h:
        * ksvg2/svg/SVGColor.idl:
        * ksvg2/svg/SVGComponentTransferFunctionElement.cpp:
        * ksvg2/svg/SVGComponentTransferFunctionElement.h:
        * ksvg2/svg/SVGCursorElement.cpp:
        * ksvg2/svg/SVGCursorElement.h:
        * ksvg2/svg/SVGDefsElement.cpp:
        * ksvg2/svg/SVGDefsElement.h:
        * ksvg2/svg/SVGDescElement.cpp:
        * ksvg2/svg/SVGDescElement.h:
        * ksvg2/svg/SVGDocument.cpp:
        * ksvg2/svg/SVGDocument.h:
        * ksvg2/svg/SVGDocument.idl:
        * ksvg2/svg/SVGElement.cpp:
        * ksvg2/svg/SVGElement.h:
        * ksvg2/svg/SVGElement.idl:
        * ksvg2/svg/SVGElementInstance.cpp:
        * ksvg2/svg/SVGElementInstance.h:
        * ksvg2/svg/SVGElementInstanceList.cpp:
        * ksvg2/svg/SVGElementInstanceList.h:
        * ksvg2/svg/SVGEllipseElement.cpp:
        * ksvg2/svg/SVGEllipseElement.h:
        * ksvg2/svg/SVGException.h:
        * ksvg2/svg/SVGExternalResourcesRequired.cpp:
        * ksvg2/svg/SVGExternalResourcesRequired.h:
        * ksvg2/svg/SVGFEBlendElement.cpp:
        * ksvg2/svg/SVGFEBlendElement.h:
        * ksvg2/svg/SVGFEColorMatrixElement.cpp:
        * ksvg2/svg/SVGFEColorMatrixElement.h:
        * ksvg2/svg/SVGFEComponentTransferElement.cpp:
        * ksvg2/svg/SVGFEComponentTransferElement.h:
        * ksvg2/svg/SVGFECompositeElement.cpp:
        * ksvg2/svg/SVGFECompositeElement.h:
        * ksvg2/svg/SVGFEDiffuseLightingElement.cpp:
        * ksvg2/svg/SVGFEDiffuseLightingElement.h:
        * ksvg2/svg/SVGFEDisplacementMapElement.cpp:
        * ksvg2/svg/SVGFEDisplacementMapElement.h:
        * ksvg2/svg/SVGFEDistantLightElement.cpp:
        * ksvg2/svg/SVGFEDistantLightElement.h:
        * ksvg2/svg/SVGFEFloodElement.cpp:
        * ksvg2/svg/SVGFEFloodElement.h:
        * ksvg2/svg/SVGFEFuncAElement.cpp:
        * ksvg2/svg/SVGFEFuncAElement.h:
        * ksvg2/svg/SVGFEFuncBElement.cpp:
        * ksvg2/svg/SVGFEFuncBElement.h:
        * ksvg2/svg/SVGFEFuncGElement.cpp:
        * ksvg2/svg/SVGFEFuncGElement.h:
        * ksvg2/svg/SVGFEFuncRElement.cpp:
        * ksvg2/svg/SVGFEFuncRElement.h:
        * ksvg2/svg/SVGFEGaussianBlurElement.cpp:
        * ksvg2/svg/SVGFEGaussianBlurElement.h:
        * ksvg2/svg/SVGFEImageElement.cpp:
        * ksvg2/svg/SVGFEImageElement.h:
        * ksvg2/svg/SVGFELightElement.cpp:
        * ksvg2/svg/SVGFELightElement.h:
        * ksvg2/svg/SVGFEMergeElement.cpp:
        * ksvg2/svg/SVGFEMergeElement.h:
        * ksvg2/svg/SVGFEMergeNodeElement.cpp:
        * ksvg2/svg/SVGFEMergeNodeElement.h:
        * ksvg2/svg/SVGFEOffsetElement.cpp:
        * ksvg2/svg/SVGFEOffsetElement.h:
        * ksvg2/svg/SVGFEPointLightElement.cpp:
        * ksvg2/svg/SVGFEPointLightElement.h:
        * ksvg2/svg/SVGFESpecularLightingElement.cpp:
        * ksvg2/svg/SVGFESpecularLightingElement.h:
        * ksvg2/svg/SVGFESpotLightElement.cpp:
        * ksvg2/svg/SVGFESpotLightElement.h:
        * ksvg2/svg/SVGFETileElement.cpp:
        * ksvg2/svg/SVGFETileElement.h:
        * ksvg2/svg/SVGFETurbulenceElement.cpp:
        * ksvg2/svg/SVGFETurbulenceElement.h:
        * ksvg2/svg/SVGFilterElement.cpp:
        * ksvg2/svg/SVGFilterElement.h:
        * ksvg2/svg/SVGFilterPrimitiveStandardAttributes.cpp:
        * ksvg2/svg/SVGFilterPrimitiveStandardAttributes.h:
        * ksvg2/svg/SVGFitToViewBox.cpp:
        * ksvg2/svg/SVGFitToViewBox.h:
        * ksvg2/svg/SVGForeignObjectElement.cpp:
        * ksvg2/svg/SVGForeignObjectElement.h:
        * ksvg2/svg/SVGGElement.cpp:
        * ksvg2/svg/SVGGElement.h:
        * ksvg2/svg/SVGGradientElement.cpp:
        * ksvg2/svg/SVGGradientElement.h:
        * ksvg2/svg/SVGImageElement.cpp:
        * ksvg2/svg/SVGImageElement.h:
        * ksvg2/svg/SVGLangSpace.cpp:
        * ksvg2/svg/SVGLangSpace.h:
        * ksvg2/svg/SVGLength.cpp:
        * ksvg2/svg/SVGLength.h:
        * ksvg2/svg/SVGLength.idl:
        * ksvg2/svg/SVGLengthList.cpp:
        * ksvg2/svg/SVGLengthList.h:
        * ksvg2/svg/SVGLineElement.cpp:
        * ksvg2/svg/SVGLineElement.h:
        * ksvg2/svg/SVGLinearGradientElement.cpp:
        * ksvg2/svg/SVGLinearGradientElement.h:
        * ksvg2/svg/SVGList.h:
        * ksvg2/svg/SVGListTraits.h:
        * ksvg2/svg/SVGLocatable.cpp:
        * ksvg2/svg/SVGLocatable.h:
        * ksvg2/svg/SVGMPathElement.cpp:
        * ksvg2/svg/SVGMPathElement.h:
        * ksvg2/svg/SVGMarkerElement.cpp:
        * ksvg2/svg/SVGMarkerElement.h:
        * ksvg2/svg/SVGMaskElement.cpp:
        * ksvg2/svg/SVGMaskElement.h:
        * ksvg2/svg/SVGMatrix.idl:
        * ksvg2/svg/SVGMetadataElement.cpp:
        * ksvg2/svg/SVGMetadataElement.h:
        * ksvg2/svg/SVGMetadataElement.idl:
        * ksvg2/svg/SVGNumber.idl:
        * ksvg2/svg/SVGNumberList.cpp:
        * ksvg2/svg/SVGNumberList.h:
        * ksvg2/svg/SVGPaint.cpp:
        * ksvg2/svg/SVGPaint.h:
        * ksvg2/svg/SVGParserUtilities.cpp:
        * ksvg2/svg/SVGParserUtilities.h:
        * ksvg2/svg/SVGPathElement.cpp:
        * ksvg2/svg/SVGPathElement.h:
        * ksvg2/svg/SVGPathSeg.h:
        * ksvg2/svg/SVGPathSegArc.cpp:
        * ksvg2/svg/SVGPathSegArc.h:
        * ksvg2/svg/SVGPathSegClosePath.cpp:
        * ksvg2/svg/SVGPathSegClosePath.h:
        * ksvg2/svg/SVGPathSegCurvetoCubic.cpp:
        * ksvg2/svg/SVGPathSegCurvetoCubic.h:
        * ksvg2/svg/SVGPathSegCurvetoCubicSmooth.cpp:
        * ksvg2/svg/SVGPathSegCurvetoCubicSmooth.h:
        * ksvg2/svg/SVGPathSegCurvetoQuadratic.cpp:
        * ksvg2/svg/SVGPathSegCurvetoQuadratic.h:
        * ksvg2/svg/SVGPathSegCurvetoQuadraticSmooth.cpp:
        * ksvg2/svg/SVGPathSegCurvetoQuadraticSmooth.h:
        * ksvg2/svg/SVGPathSegLineto.cpp:
        * ksvg2/svg/SVGPathSegLineto.h:
        * ksvg2/svg/SVGPathSegLinetoHorizontal.cpp:
        * ksvg2/svg/SVGPathSegLinetoHorizontal.h:
        * ksvg2/svg/SVGPathSegLinetoVertical.cpp:
        * ksvg2/svg/SVGPathSegLinetoVertical.h:
        * ksvg2/svg/SVGPathSegList.cpp:
        * ksvg2/svg/SVGPathSegList.h:
        * ksvg2/svg/SVGPathSegMoveto.cpp:
        * ksvg2/svg/SVGPathSegMoveto.h:
        * ksvg2/svg/SVGPatternElement.cpp:
        * ksvg2/svg/SVGPatternElement.h:
        * ksvg2/svg/SVGPoint.idl:
        * ksvg2/svg/SVGPointList.cpp:
        * ksvg2/svg/SVGPointList.h:
        * ksvg2/svg/SVGPolyElement.cpp:
        * ksvg2/svg/SVGPolyElement.h:
        * ksvg2/svg/SVGPolygonElement.cpp:
        * ksvg2/svg/SVGPolygonElement.h:
        * ksvg2/svg/SVGPolylineElement.cpp:
        * ksvg2/svg/SVGPolylineElement.h:
        * ksvg2/svg/SVGPreserveAspectRatio.cpp:
        * ksvg2/svg/SVGPreserveAspectRatio.h:
        * ksvg2/svg/SVGRadialGradientElement.cpp:
        * ksvg2/svg/SVGRadialGradientElement.h:
        * ksvg2/svg/SVGRect.idl:
        * ksvg2/svg/SVGRectElement.cpp:
        * ksvg2/svg/SVGRectElement.h:
        * ksvg2/svg/SVGRenderingIntent.h:
        * ksvg2/svg/SVGSVGElement.cpp:
        * ksvg2/svg/SVGSVGElement.h:
        * ksvg2/svg/SVGSVGElement.idl:
        * ksvg2/svg/SVGScriptElement.cpp:
        * ksvg2/svg/SVGScriptElement.h:
        * ksvg2/svg/SVGSetElement.cpp:
        * ksvg2/svg/SVGSetElement.h:
        * ksvg2/svg/SVGStopElement.cpp:
        * ksvg2/svg/SVGStopElement.h:
        * ksvg2/svg/SVGStringList.cpp:
        * ksvg2/svg/SVGStringList.h:
        * ksvg2/svg/SVGStylable.cpp:
        * ksvg2/svg/SVGStylable.h:
        * ksvg2/svg/SVGStyleElement.cpp:
        * ksvg2/svg/SVGStyleElement.h:
        * ksvg2/svg/SVGStyledElement.cpp:
        * ksvg2/svg/SVGStyledElement.h:
        * ksvg2/svg/SVGStyledLocatableElement.cpp:
        * ksvg2/svg/SVGStyledLocatableElement.h:
        * ksvg2/svg/SVGStyledTransformableElement.cpp:
        * ksvg2/svg/SVGStyledTransformableElement.h:
        * ksvg2/svg/SVGSwitchElement.cpp:
        * ksvg2/svg/SVGSwitchElement.h:
        * ksvg2/svg/SVGSymbolElement.cpp:
        * ksvg2/svg/SVGSymbolElement.h:
        * ksvg2/svg/SVGTRefElement.cpp:
        * ksvg2/svg/SVGTRefElement.h:
        * ksvg2/svg/SVGTSpanElement.cpp:
        * ksvg2/svg/SVGTSpanElement.h:
        * ksvg2/svg/SVGTests.cpp:
        * ksvg2/svg/SVGTests.h:
        * ksvg2/svg/SVGTextContentElement.cpp:
        * ksvg2/svg/SVGTextContentElement.h:
        * ksvg2/svg/SVGTextElement.cpp:
        * ksvg2/svg/SVGTextElement.h:
        * ksvg2/svg/SVGTextPositioningElement.cpp:
        * ksvg2/svg/SVGTextPositioningElement.h:
        * ksvg2/svg/SVGTitleElement.cpp:
        * ksvg2/svg/SVGTitleElement.h:
        * ksvg2/svg/SVGTransform.cpp:
        * ksvg2/svg/SVGTransform.h:
        * ksvg2/svg/SVGTransform.idl:
        * ksvg2/svg/SVGTransformDistance.cpp:
        * ksvg2/svg/SVGTransformDistance.h:
        * ksvg2/svg/SVGTransformList.cpp:
        * ksvg2/svg/SVGTransformList.h:
        * ksvg2/svg/SVGTransformable.cpp:
        * ksvg2/svg/SVGTransformable.h:
        * ksvg2/svg/SVGURIReference.cpp:
        * ksvg2/svg/SVGURIReference.h:
        * ksvg2/svg/SVGUnitTypes.h:
        * ksvg2/svg/SVGUseElement.cpp:
        * ksvg2/svg/SVGUseElement.h:
        * ksvg2/svg/SVGViewElement.cpp:
        * ksvg2/svg/SVGViewElement.h:
        * ksvg2/svg/SVGZoomAndPan.cpp:
        * ksvg2/svg/SVGZoomAndPan.h:
        * loader/Cache.cpp:
        * loader/Cache.h:
        * loader/CachedCSSStyleSheet.cpp:
        * loader/CachedCSSStyleSheet.h:
        * loader/CachedImage.cpp:
        * loader/CachedImage.h:
        * loader/CachedResource.cpp:
        * loader/CachedResource.h:
        * loader/CachedResourceClient.h:
        * loader/CachedResourceClientWalker.cpp:
        * loader/CachedResourceClientWalker.h:
        * loader/CachedScript.cpp:
        * loader/CachedScript.h:
        * loader/CachedXBLDocument.cpp:
        * loader/CachedXBLDocument.h:
        * loader/CachedXSLStyleSheet.cpp:
        * loader/CachedXSLStyleSheet.h:
        * loader/DocLoader.cpp:
        * loader/DocLoader.h:
        * loader/FTPDirectoryParser.cpp:
        * loader/FTPDirectoryParser.h:
        * loader/Request.cpp:
        * loader/Request.h:
        * loader/TextResourceDecoder.cpp:
        * loader/TextResourceDecoder.h:
        * loader/loader.cpp:
        * loader/loader.h:
        * page/Chrome.cpp:
        * page/Chrome.h:
        * page/ChromeClient.h:
        * page/Frame.cpp:
        * page/Frame.h:
        * page/FramePrivate.h:
        * page/FrameTree.cpp:
        * page/FrameTree.h:
        * page/FrameView.cpp:
        * page/FrameView.h:
        * page/MouseEventWithHitTestResults.cpp:
        * page/MouseEventWithHitTestResults.h:
        * page/Page.cpp:
        * page/Page.h:
        * page/Plugin.h:
        * page/mac/ChromeMac.mm:
        * platform/Arena.cpp:
        * platform/Arena.h:
        * platform/AtomicString.cpp:
        * platform/AtomicString.h:
        * platform/AtomicStringImpl.h:
        * platform/BidiContext.cpp:
        * platform/BidiContext.h:
        * platform/BidiResolver.h:
        * platform/Font.cpp:
        * platform/Font.h:
        * platform/FontData.h:
        * platform/FontDescription.h:
        * platform/FontFallbackList.h:
        * platform/PlatformString.h:
        * platform/PopupMenu.h:
        * platform/PopupMenuClient.h:
        * platform/SearchPopupMenu.h:
        * platform/SegmentedString.cpp:
        * platform/SegmentedString.h:
        * platform/Shared.h:
        * platform/StaticConstructors.h:
        * platform/String.cpp:
        * platform/StringHash.h:
        * platform/StringImpl.cpp:
        * platform/StringImpl.h:
        * platform/TextBreakIterator.h:
        * platform/TextBreakIteratorICU.cpp:
        * platform/TextBreakIteratorInternalICU.h:
        * platform/TextStyle.h:
        * platform/UnicodeRange.cpp:
        * platform/UnicodeRange.h:
        * platform/cf/StringCF.cpp:
        * platform/cf/StringImplCF.cpp:
        * platform/graphics/FloatPoint3D.cpp:
        * platform/graphics/FloatPoint3D.h:
        * platform/graphics/Icon.h:
        * platform/graphics/IntSizeHash.h:
        * platform/graphics/PathTraversalState.cpp:
        * platform/graphics/cairo/CairoPath.h:
        * platform/graphics/cairo/PathCairo.cpp:
        * platform/graphics/mac/IconMac.mm:
        * platform/graphics/qt/IconQt.cpp:
        * platform/graphics/svg/SVGResourceFilter.cpp:
        * platform/graphics/svg/SVGResourceFilter.h:
        * platform/graphics/svg/cg/SVGPaintServerCg.cpp:
        * platform/graphics/svg/cg/SVGPaintServerGradientCg.cpp:
        * platform/graphics/svg/cg/SVGPaintServerPatternCg.cpp:
        * platform/graphics/svg/cg/SVGPaintServerSolidCg.cpp:
        * platform/graphics/svg/filters/SVGDistantLightSource.h:
        * platform/graphics/svg/filters/SVGFEBlend.cpp:
        * platform/graphics/svg/filters/SVGFEBlend.h:
        * platform/graphics/svg/filters/SVGFEColorMatrix.cpp:
        * platform/graphics/svg/filters/SVGFEColorMatrix.h:
        * platform/graphics/svg/filters/SVGFEComponentTransfer.cpp:
        * platform/graphics/svg/filters/SVGFEComponentTransfer.h:
        * platform/graphics/svg/filters/SVGFEComposite.cpp:
        * platform/graphics/svg/filters/SVGFEComposite.h:
        * platform/graphics/svg/filters/SVGFEConvolveMatrix.cpp:
        * platform/graphics/svg/filters/SVGFEConvolveMatrix.h:
        * platform/graphics/svg/filters/SVGFEDiffuseLighting.cpp:
        * platform/graphics/svg/filters/SVGFEDiffuseLighting.h:
        * platform/graphics/svg/filters/SVGFEDisplacementMap.cpp:
        * platform/graphics/svg/filters/SVGFEDisplacementMap.h:
        * platform/graphics/svg/filters/SVGFEFlood.cpp:
        * platform/graphics/svg/filters/SVGFEFlood.h:
        * platform/graphics/svg/filters/SVGFEGaussianBlur.cpp:
        * platform/graphics/svg/filters/SVGFEGaussianBlur.h:
        * platform/graphics/svg/filters/SVGFEImage.cpp:
        * platform/graphics/svg/filters/SVGFEImage.h:
        * platform/graphics/svg/filters/SVGFEMerge.cpp:
        * platform/graphics/svg/filters/SVGFEMerge.h:
        * platform/graphics/svg/filters/SVGFEMorphology.cpp:
        * platform/graphics/svg/filters/SVGFEMorphology.h:
        * platform/graphics/svg/filters/SVGFEOffset.cpp:
        * platform/graphics/svg/filters/SVGFEOffset.h:
        * platform/graphics/svg/filters/SVGFESpecularLighting.cpp:
        * platform/graphics/svg/filters/SVGFESpecularLighting.h:
        * platform/graphics/svg/filters/SVGFETile.h:
        * platform/graphics/svg/filters/SVGFETurbulence.cpp:
        * platform/graphics/svg/filters/SVGFETurbulence.h:
        * platform/graphics/svg/filters/SVGFilterEffect.cpp:
        * platform/graphics/svg/filters/SVGFilterEffect.h:
        * platform/graphics/svg/filters/SVGLightSource.cpp:
        * platform/graphics/svg/filters/SVGLightSource.h:
        * platform/graphics/svg/filters/SVGPointLightSource.h:
        * platform/graphics/svg/filters/SVGSpotLightSource.h:
        * platform/graphics/svg/filters/cg/SVGFEBlendCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEColorMatrixCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEComponentTransferCg.mm:
        * platform/graphics/svg/filters/cg/SVGFECompositeCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEDiffuseLightingCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEDisplacementMapCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEFloodCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEGaussianBlurCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEHelpersCg.h:
        * platform/graphics/svg/filters/cg/SVGFEHelpersCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEImageCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEMergeCg.mm:
        * platform/graphics/svg/filters/cg/SVGFEOffsetCg.mm:
        * platform/graphics/svg/filters/cg/SVGFESpecularLightingCg.mm:
        * platform/graphics/svg/filters/cg/SVGFETileCg.mm:
        * platform/graphics/svg/filters/cg/SVGFilterEffectCg.mm:
        * platform/graphics/svg/qt/RenderPathQt.cpp:
        * platform/graphics/svg/qt/SVGPaintServerGradientQt.cpp:
        * platform/graphics/svg/qt/SVGPaintServerLinearGradientQt.cpp:
        * platform/graphics/svg/qt/SVGPaintServerPatternQt.cpp:
        * platform/graphics/svg/qt/SVGPaintServerQt.cpp:
        * platform/graphics/svg/qt/SVGPaintServerRadialGradientQt.cpp:
        * platform/graphics/svg/qt/SVGPaintServerSolidQt.cpp:
        * platform/graphics/svg/qt/SVGResourceClipperQt.cpp:
        * platform/graphics/svg/qt/SVGResourceFilterQt.cpp:
        * platform/graphics/svg/qt/SVGResourceMaskerQt.cpp:
        * platform/graphics/win/IconWin.cpp:
        * platform/gtk/FontPlatformData.h:
        * platform/gtk/FontPlatformDataGtk.cpp:
        * platform/gtk/PopupMenuGtk.cpp:
        * platform/gtk/RenderThemeGtk.cpp:
        * platform/gtk/RenderThemeGtk.h:
        * platform/image-decoders/jpeg/JPEGImageDecoder.cpp:
        * platform/image-decoders/png/PNGImageDecoder.cpp:
        * platform/mac/FontMac.mm:
        * platform/mac/FontPlatformData.h:
        * platform/mac/LocalCurrentGraphicsContext.h:
        * platform/mac/LocalCurrentGraphicsContext.mm:
        * platform/mac/PopupMenuMac.mm:
        * platform/mac/SearchPopupMenuMac.mm:
        * platform/mac/StringImplMac.mm:
        * platform/mac/StringMac.mm:
        * platform/mac/TextBreakIteratorInternalICUMac.mm:
        * platform/network/FormData.cpp:
        * platform/network/FormData.h:
        * platform/qt/FileChooserQt.cpp:
        * platform/qt/FontQt.cpp:
        * platform/qt/MenuEventProxy.h:
        * platform/qt/PlugInInfoStoreQt.cpp:
        * platform/qt/PopupMenuQt.cpp:
        * platform/qt/QWebPopup.cpp:
        * platform/qt/QWebPopup.h:
        * platform/qt/RenderThemeQt.cpp:
        * platform/qt/RenderThemeQt.h:
        * platform/qt/SearchPopupMenuQt.cpp:
        * platform/qt/TextBreakIteratorQt.cpp:
        * platform/qt/WheelEventQt.cpp:
        * platform/win/FontPlatformData.h:
        * platform/win/FontPlatformDataWin.cpp:
        * platform/win/PopupMenuWin.cpp:
        * platform/win/SearchPopupMenuWin.cpp:
        * platform/win/TextBreakIteratorInternalICUWin.cpp:
        * rendering/AutoTableLayout.cpp:
        * rendering/AutoTableLayout.h:
        * rendering/CounterNode.cpp:
        * rendering/CounterNode.h:
        * rendering/DataRef.h:
        * rendering/EllipsisBox.cpp:
        * rendering/EllipsisBox.h:
        * rendering/FixedTableLayout.cpp:
        * rendering/FixedTableLayout.h:
        * rendering/GapRects.h:
        * rendering/HitTestRequest.h:
        * rendering/HitTestResult.cpp:
        * rendering/HitTestResult.h:
        * rendering/InlineBox.cpp:
        * rendering/InlineBox.h:
        * rendering/InlineFlowBox.cpp:
        * rendering/InlineFlowBox.h:
        * rendering/InlineRunBox.h:
        * rendering/InlineTextBox.cpp:
        * rendering/InlineTextBox.h:
        * rendering/Length.h:
        * rendering/ListMarkerBox.cpp:
        * rendering/ListMarkerBox.h:
        * rendering/RenderApplet.cpp:
        * rendering/RenderApplet.h:
        * rendering/RenderArena.cpp:
        * rendering/RenderArena.h:
        * rendering/RenderBR.cpp:
        * rendering/RenderBR.h:
        * rendering/RenderBlock.cpp:
        * rendering/RenderBlock.h:
        * rendering/RenderBox.cpp:
        * rendering/RenderBox.h:
        * rendering/RenderButton.cpp:
        * rendering/RenderButton.h:
        * rendering/RenderContainer.cpp:
        * rendering/RenderContainer.h:
        * rendering/RenderCounter.cpp:
        * rendering/RenderCounter.h:
        * rendering/RenderFieldset.cpp:
        * rendering/RenderFieldset.h:
        * rendering/RenderFileUploadControl.cpp:
        * rendering/RenderFileUploadControl.h:
        * rendering/RenderFlexibleBox.cpp:
        * rendering/RenderFlexibleBox.h:
        * rendering/RenderFlow.cpp:
        * rendering/RenderFlow.h:
        * rendering/RenderForeignObject.cpp:
        * rendering/RenderForeignObject.h:
        * rendering/RenderFrame.cpp:
        * rendering/RenderFrame.h:
        * rendering/RenderFrameSet.cpp:
        * rendering/RenderFrameSet.h:
        * rendering/RenderImage.cpp:
        * rendering/RenderImage.h:
        * rendering/RenderInline.cpp:
        * rendering/RenderInline.h:
        * rendering/RenderLayer.cpp:
        * rendering/RenderLayer.h:
        * rendering/RenderLegend.cpp:
        * rendering/RenderLegend.h:
        * rendering/RenderListItem.cpp:
        * rendering/RenderListItem.h:
        * rendering/RenderListMarker.cpp:
        * rendering/RenderListMarker.h:
        * rendering/RenderMenuList.cpp:
        * rendering/RenderMenuList.h:
        * rendering/RenderObject.cpp:
        * rendering/RenderObject.h:
        * rendering/RenderPart.cpp:
        * rendering/RenderPart.h:
        * rendering/RenderPartObject.cpp:
        * rendering/RenderPartObject.h:
        * rendering/RenderPath.cpp:
        * rendering/RenderPath.h:
        * rendering/RenderReplaced.cpp:
        * rendering/RenderReplaced.h:
        * rendering/RenderSVGBlock.cpp:
        * rendering/RenderSVGBlock.h:
        * rendering/RenderSVGContainer.cpp:
        * rendering/RenderSVGContainer.h:
        * rendering/RenderSVGGradientStop.cpp:
        * rendering/RenderSVGGradientStop.h:
        * rendering/RenderSVGHiddenContainer.cpp:
        * rendering/RenderSVGHiddenContainer.h:
        * rendering/RenderSVGImage.cpp:
        * rendering/RenderSVGImage.h:
        * rendering/RenderSVGInline.cpp:
        * rendering/RenderSVGInline.h:
        * rendering/RenderSVGInlineText.cpp:
        * rendering/RenderSVGInlineText.h:
        * rendering/RenderSVGTSpan.cpp:
        * rendering/RenderSVGTSpan.h:
        * rendering/RenderSVGText.cpp:
        * rendering/RenderSVGText.h:
        * rendering/RenderSlider.cpp:
        * rendering/RenderSlider.h:
        * rendering/RenderStyle.cpp:
        * rendering/RenderStyle.h:
        * rendering/RenderTable.cpp:
        * rendering/RenderTable.h:
        * rendering/RenderTableCell.cpp:
        * rendering/RenderTableCell.h:
        * rendering/RenderTableCol.cpp:
        * rendering/RenderTableCol.h:
        * rendering/RenderTableRow.cpp:
        * rendering/RenderTableRow.h:
        * rendering/RenderTableSection.cpp:
        * rendering/RenderTableSection.h:
        * rendering/RenderText.cpp:
        * rendering/RenderText.h:
        * rendering/RenderTextControl.cpp:
        * rendering/RenderTextControl.h:
        * rendering/RenderTextFragment.cpp:
        * rendering/RenderTextFragment.h:
        * rendering/RenderTheme.cpp:
        * rendering/RenderTheme.h:
        * rendering/RenderThemeMac.h:
        * rendering/RenderThemeMac.mm:
        * rendering/RenderThemeSafari.cpp:
        * rendering/RenderThemeSafari.h:
        * rendering/RenderThemeWin.cpp:
        * rendering/RenderThemeWin.h:
        * rendering/RenderView.cpp:
        * rendering/RenderView.h:
        * rendering/RenderWidget.cpp:
        * rendering/RenderWidget.h:
        * rendering/RootInlineBox.cpp:
        * rendering/RootInlineBox.h:
        * rendering/SVGInlineFlowBox.cpp:
        * rendering/SVGInlineFlowBox.h:
        * rendering/SVGInlineTextBox.cpp:
        * rendering/SVGInlineTextBox.h:
        * rendering/SVGRootInlineBox.cpp:
        * rendering/SVGRootInlineBox.h:
        * rendering/TableLayout.h:
        * rendering/bidi.cpp:
        * rendering/bidi.h:
        * rendering/break_lines.cpp:
        * rendering/break_lines.h:
        * xml/DOMParser.cpp:
        * xml/DOMParser.h:
        * xml/DOMParser.idl:
        * xml/XMLHttpRequest.cpp:
        * xml/XMLHttpRequest.h:
        * xml/XMLSerializer.cpp:
        * xml/XMLSerializer.h:
        * xml/XMLSerializer.idl:
        * xml/XPathEvaluator.idl:
        * xml/XPathExpression.idl:
        * xml/XPathNSResolver.idl:
        * xml/XPathResult.idl:
        * xml/XSLImportRule.cpp:
        * xml/XSLImportRule.h:
        * xml/XSLStyleSheet.cpp:
        * xml/XSLStyleSheet.h:
        * xml/XSLTProcessor.cpp:
        * xml/XSLTProcessor.h:

2007-09-25  Darin Adler  <darin@apple.com>

        Reviewed by Harrison.

        - fix <rdar://problem/5503225> CrashTracer: [USER] 2 crashes in Dashcode
          at com.apple.WebCore: WebCore::Frame::document const + 0

        * page/FrameView.cpp: (WebCore::FrameView::updateControlTints):
        Added null check.

2007-09-25  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin.

        Fixes http://bugs.webkit.org/show_bug.cgi?id=15282 r25726 caused 
        plugins/mouse-events.html to fail

        * page/FrameView.cpp:
        (WebCore::FrameView::layout): We need to call 
        updateWidgetPosition() after updating each widget.

2007-09-25  Anders Carlsson  <andersca@apple.com>

        Build fix.
        
        * page/Chrome.cpp:
        (WebCore::PageGroupLoadDeferrer::PageGroupLoadDeferrer):

2007-09-25  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoff.

        <rdar://problem/5283916>
        JavaScript timers may be firing while JavaScript alerts are displayed.
        
        Pause JavaScript timeouts while calling UI delegate methods that might show dialogs.
        
        * page/Chrome.cpp:
        (WebCore::PageGroupLoadDeferrer::PageGroupLoadDeferrer):
        (WebCore::PageGroupLoadDeferrer::~PageGroupLoadDeferrer):

2007-09-26  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Anders.

        Implement PopupMenu using GtkMenu.

        * platform/PopupMenu.h:
        * platform/gtk/PopupMenuGtk.cpp:
        (WebCore::PopupMenu::PopupMenu):
        (WebCore::PopupMenu::~PopupMenu):
        (WebCore::PopupMenu::show):
        (WebCore::PopupMenu::hide):
        (WebCore::PopupMenu::updateFromElement):
        (WebCore::PopupMenu::itemWritingDirectionIsNatural):
        (WebCore::PopupMenu::menuItemActivated):
        (WebCore::PopupMenu::menuUnmapped):
        (WebCore::PopupMenu::menuPositionFunction):
        (WebCore::PopupMenu::menuRemoveItem):

2007-09-23  Holger Hans Peter Freyther  <zecke@selfish.org>

        Rubber stamped by Mark.

        Obey the Coding-Style and move the asterisk to the
        left to be part of the type.

        * platform/gtk/RenderThemeGtk.h:

2007-09-25  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin.

        Fix for <rdar://problem/5466459> CrashTracer: [USER] 1 crash in 
        NetNewsWire at com.apple.WebCore: WebCore::bidiNext + 485 (15241)

        Mitz discovered that this crash appeared because r25128 made it 
        possible for RenderPartObject::updateWidget() to be called during 
        layout. updateWidget() can, through a series of calls, cause an 
        attach/detach to happen, which is very bad in the middle of a 
        layout and is what led to this crash. This patch fixes that by 
        having the FrameView keep track of a queue of RenderPartObjects 
        that need to call updateWidget(), and it goes through the queue 
        calling updateWidget() as soon as layout is done.

        * page/FrameView.cpp: We only want to call updateWidget() if we are 
        not in a nested layout. Unfortunately, the existing variables on 
        FrameViewPrivate do not have exactly the information that we need, 
        so I added nestedLayoutCount.
        (WebCore::FrameViewPrivate::reset): Reset nestedLayoutCount.
        (WebCore::FrameView::layout): Increment nestedLayoutCount once we 
        have gotten through all of the early returns. Call updateWidget() 
        after layout is nestedLayoutCount is 1 and there are widgets to 
        update. Decrement nestedLayoutCount at the end.
        (WebCore::FrameView::addWidgetToUpdate):
        (WebCore::FrameView::removeWidgetToUpdate):
        * page/FrameView.h:
        * rendering/RenderPartObject.cpp:
        (WebCore::RenderPartObject::~RenderPartObject): Remove this from 
        the FrameView's update set.
        (WebCore::RenderPartObject::layout): Instead of calling 
        updateWidget() immediately, add this to the update widget set on 
        FrameView.
        * rendering/RenderPartObject.h:

2007-09-25  David Kilzer  <ddkilzer@webkit.org>

        Reviewed by Mark Rowe.

        - fix http://bugs.webkit.org/show_bug.cgi?id=15275
          SVG dependency on WebCore/dom/XMLTokenizer.cpp

        * dom/XMLTokenizer.cpp: Moved #include "SVGStyleElement.h" into #if ENABLE(SVG).

2007-09-25  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Darin.

        <rdar://problem/5483567> 
        REGRESSION (Tiger only, workaround in AppKit on Leopard): Pasting words copied from TextEdit in Mail adds extra newline
        
        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::removeUnrenderedNodes): Added.
        (WebCore::ReplaceSelectionCommand::doApply): Call removeUnrenderedNodes
        to prevent unrendered spaces from interfering with paragraph merging.
        * editing/ReplaceSelectionCommand.h:

2007-09-24  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Darin.

        - fix <rdar://problem/5502513>

        * platform/win/FontCacheWin.cpp:
        (WebCore::FontCache::getFontLinkInterface):
        Roll back this file; the old code leaked a global COM object, but that's
        no big deal and the new code caused a crash on quit.

2007-09-24  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam.

        <rdar://problem/5494608>
        Seed: Safari will follow links in Flash movies without clicking.

        Make sure to handle mouseover and mouseout so the plug-in can track when the mouse is over it.
                
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginViewWin::handleMouseEvent):

2007-09-24  Mike Fenton  <mike@staikos.net>

        Reviewed by George Staikos.

        Switch to using a QImage instead of a QPixmap to make transparency work.

        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::drawImage):
        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::paint):
        (WebCore::HTMLCanvasElement::createDrawingContext):
        (WebCore::HTMLCanvasElement::createPlatformImage):
        * html/HTMLCanvasElement.h:

2007-09-21  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Sam.

        - Updated project files to not use Edit and Continue for Debug Information since it doesn't work and breaks some functionality.

        * WebCore.vcproj/WebCore.vcproj:

2007-09-24  Brady Eidson  <beidson@apple.com>

        Reviewed by John Sullivan

        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::iconForPageURL): Assert the page url is non-null

2007-09-20  Holger Hans Peter Freyther  <zecke@selfish.org>

        Rubber stamped by Adam.

        Renamed files from *Gdk to *Gtk (see #14732) using the
        work of Juan A. Suarez Romero as a base.

        GDK -> GTK

        * Projects/gdk/webcore-gdk.bkl:
        * WebCore.pro:
        * WebCoreSources.bkl:
        * loader/gdk: Removed.
        * loader/gdk/DocumentLoaderGdk.cpp: Removed.
        * loader/gtk: Added.
        * loader/gtk/DocumentLoaderGdk.cpp: Removed.
        * loader/gtk/DocumentLoaderGtk.cpp: Added.
        * page/FrameView.cpp:
        * page/FrameView.h:
        * page/gdk: Removed.
        * page/gdk/DragControllerGdk.cpp: Removed.
        * page/gdk/EventHandlerGdk.cpp: Removed.
        * page/gdk/FrameGdk.cpp: Removed.
        * page/gtk: Added.
        * page/gtk/DragControllerGdk.cpp: Removed.
        * page/gtk/DragControllerGtk.cpp: Added.
        * page/gtk/EventHandlerGdk.cpp: Removed.
        * page/gtk/EventHandlerGtk.cpp: Added.
        (WebCore::EventHandler::createDraggingClipboard):
        * page/gtk/FrameGdk.cpp: Removed.
        * page/gtk/FrameGtk.cpp: Added.
        * platform/ContextMenuItem.h:
        * platform/Cursor.h:
        * platform/DragData.h:
        * platform/DragImage.h:
        * platform/FontData.h:
        * platform/NotImplemented.h:
        * platform/PlatformKeyboardEvent.h:
        * platform/PlatformMenuDescription.h:
        * platform/PlatformMouseEvent.h:
        * platform/PlatformWheelEvent.h:
        * platform/ScrollView.h:
        * platform/Widget.h:
        * platform/gdk: Removed.
        * platform/gdk/ClipboardGdk.cpp: Removed.
        * platform/gdk/ClipboardGdk.h: Removed.
        * platform/gdk/ContextMenuGdk.cpp: Removed.
        * platform/gdk/ContextMenuItemGdk.cpp: Removed.
        * platform/gdk/CookieJarGdk.cpp: Removed.
        * platform/gdk/CursorGdk.cpp: Removed.
        * platform/gdk/DragDataGdk.cpp: Removed.
        * platform/gdk/DragImageGdk.cpp: Removed.
        * platform/gdk/FileChooserGdk.cpp: Removed.
        * platform/gdk/FileSystemGdk.cpp: Removed.
        * platform/gdk/FontCacheGdk.cpp: Removed.
        * platform/gdk/FontDataGdk.cpp: Removed.
        * platform/gdk/FontGdk.cpp: Removed.
        * platform/gdk/FontPlatformData.h: Removed.
        * platform/gdk/FontPlatformDataGdk.cpp: Removed.
        * platform/gdk/GlyphPageTreeNodeGdk.cpp: Removed.
        * platform/gdk/KeyEventGdk.cpp: Removed.
        * platform/gdk/KeyboardCodes.h: Removed.
        * platform/gdk/LocalizedStringsGdk.cpp: Removed.
        * platform/gdk/LoggingGdk.cpp: Removed.
        * platform/gdk/MIMETypeRegistryGdk.cpp: Removed.
        * platform/gdk/MouseEventGdk.cpp: Removed.
        * platform/gdk/PasteboardGdk.cpp: Removed.
        * platform/gdk/PlatformScreenGdk.cpp: Removed.
        * platform/gdk/PlatformScrollBar.h: Removed.
        * platform/gdk/PlatformScrollBarGdk.cpp: Removed.
        * platform/gdk/PopupMenuGdk.cpp: Removed.
        * platform/gdk/RenderThemeGdk.cpp: Removed.
        * platform/gdk/RenderThemeGdk.h: Removed.
        * platform/gdk/ScrollViewGdk.cpp: Removed.
        * platform/gdk/SearchPopupMenuGdk.cpp: Removed.
        * platform/gdk/SharedTimerLinux.cpp: Removed.
        * platform/gdk/SoundGdk.cpp: Removed.
        * platform/gdk/SystemTimeLinux.cpp: Removed.
        * platform/gdk/TemporaryLinkStubs.cpp: Removed.
        * platform/gdk/WheelEventGdk.cpp: Removed.
        * platform/gdk/WidgetGdk.cpp: Removed.
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/cairo/GraphicsContextCairo.cpp:
        (WebCore::GraphicsContextPlatformPrivate::GraphicsContextPlatformPrivate):
        (WebCore::GraphicsContext::setPlatformFont):
        * platform/graphics/gdk: Removed.
        * platform/graphics/gdk/IconGdk.cpp: Removed.
        * platform/graphics/gdk/ImageGdk.cpp: Removed.
        * platform/graphics/gtk: Added.
        * platform/graphics/gtk/IconGdk.cpp: Removed.
        * platform/graphics/gtk/IconGtk.cpp: Added.
        * platform/graphics/gtk/ImageGdk.cpp: Removed.
        * platform/graphics/gtk/ImageGtk.cpp: Added.
        * platform/gtk: Added.
        * platform/gtk/ClipboardGdk.cpp: Removed.
        * platform/gtk/ClipboardGdk.h: Removed.
        * platform/gtk/ClipboardGtk.cpp: Added.
        (WebCore::ClipboardGtk::ClipboardGtk):
        (WebCore::ClipboardGtk::~ClipboardGtk):
        (WebCore::ClipboardGtk::clearData):
        (WebCore::ClipboardGtk::clearAllData):
        (WebCore::ClipboardGtk::getData):
        (WebCore::ClipboardGtk::setData):
        (WebCore::ClipboardGtk::types):
        (WebCore::ClipboardGtk::dragLocation):
        (WebCore::ClipboardGtk::dragImage):
        (WebCore::ClipboardGtk::setDragImage):
        (WebCore::ClipboardGtk::dragImageElement):
        (WebCore::ClipboardGtk::setDragImageElement):
        (WebCore::ClipboardGtk::createDragImage):
        (WebCore::ClipboardGtk::declareAndWriteDragImage):
        (WebCore::ClipboardGtk::writeURL):
        (WebCore::ClipboardGtk::writeRange):
        (WebCore::ClipboardGtk::hasData):
        * platform/gtk/ClipboardGtk.h: Added.
        * platform/gtk/ContextMenuGdk.cpp: Removed.
        * platform/gtk/ContextMenuGtk.cpp: Added.
        * platform/gtk/ContextMenuItemGdk.cpp: Removed.
        * platform/gtk/ContextMenuItemGtk.cpp: Added.
        * platform/gtk/CookieJarGdk.cpp: Removed.
        * platform/gtk/CookieJarGtk.cpp: Added.
        * platform/gtk/CursorGdk.cpp: Removed.
        * platform/gtk/CursorGtk.cpp: Added.
        * platform/gtk/DragDataGdk.cpp: Removed.
        * platform/gtk/DragDataGtk.cpp: Added.
        * platform/gtk/DragImageGdk.cpp: Removed.
        * platform/gtk/DragImageGtk.cpp: Added.
        * platform/gtk/FileChooserGdk.cpp: Removed.
        * platform/gtk/FileChooserGtk.cpp: Added.
        * platform/gtk/FileSystemGdk.cpp: Removed.
        * platform/gtk/FileSystemGtk.cpp: Added.
        * platform/gtk/FontCacheGdk.cpp: Removed.
        * platform/gtk/FontCacheGtk.cpp: Added.
        * platform/gtk/FontDataGdk.cpp: Removed.
        * platform/gtk/FontDataGtk.cpp: Added.
        * platform/gtk/FontGdk.cpp: Removed.
        * platform/gtk/FontGtk.cpp: Added.
        * platform/gtk/FontPlatformDataGdk.cpp: Removed.
        * platform/gtk/FontPlatformDataGtk.cpp: Added.
        * platform/gtk/GlyphPageTreeNodeGdk.cpp: Removed.
        * platform/gtk/GlyphPageTreeNodeGtk.cpp: Added.
        * platform/gtk/KeyEventGdk.cpp: Removed.
        * platform/gtk/KeyEventGtk.cpp: Added.
        * platform/gtk/LocalizedStringsGdk.cpp: Removed.
        * platform/gtk/LocalizedStringsGtk.cpp: Added.
        * platform/gtk/LoggingGdk.cpp: Removed.
        * platform/gtk/LoggingGtk.cpp: Added.
        * platform/gtk/MIMETypeRegistryGdk.cpp: Removed.
        * platform/gtk/MIMETypeRegistryGtk.cpp: Added.
        * platform/gtk/MouseEventGdk.cpp: Removed.
        * platform/gtk/MouseEventGtk.cpp: Added.
        * platform/gtk/PasteboardGdk.cpp: Removed.
        * platform/gtk/PasteboardGtk.cpp: Added.
        * platform/gtk/PlatformScreenGdk.cpp: Removed.
        * platform/gtk/PlatformScreenGtk.cpp: Added.
        * platform/gtk/PlatformScrollBarGdk.cpp: Removed.
        * platform/gtk/PlatformScrollBarGtk.cpp: Added.
        * platform/gtk/PopupMenuGdk.cpp: Removed.
        * platform/gtk/PopupMenuGtk.cpp: Added.
        * platform/gtk/RenderThemeGdk.cpp: Removed.
        * platform/gtk/RenderThemeGdk.h: Removed.
        * platform/gtk/RenderThemeGtk.cpp: Added.
        (WebCore::theme):
        (WebCore::RenderThemeGtk::RenderThemeGtk):
        (WebCore::RenderThemeGtk::close):
        (WebCore::RenderThemeGtk::addIntrinsicMargins):
        (WebCore::RenderThemeGtk::supportsFocus):
        (WebCore::RenderThemeGtk::determineState):
        (WebCore::RenderThemeGtk::determineShadow):
        (WebCore::RenderThemeGtk::getThemeData):
        (WebCore::RenderThemeGtk::setCheckboxSize):
        (WebCore::RenderThemeGtk::paintCheckbox):
        (WebCore::RenderThemeGtk::setRadioSize):
        (WebCore::RenderThemeGtk::paintRadio):
        (WebCore::RenderThemeGtk::paintButton):
        (WebCore::RenderThemeGtk::adjustTextFieldStyle):
        (WebCore::RenderThemeGtk::paintTextField):
        (WebCore::RenderThemeGtk::paintTextArea):
        (WebCore::RenderThemeGtk::adjustButtonStyle):
        (WebCore::RenderThemeGtk::systemFont):
        (WebCore::RenderThemeGtk::gtkButton):
        (WebCore::RenderThemeGtk::gtkCheckbox):
        (WebCore::RenderThemeGtk::gtkRadioButton):
        (WebCore::RenderThemeGtk::gtkWindowContainer):
        * platform/gtk/RenderThemeGtk.h: Added.
        * platform/gtk/ScrollViewGdk.cpp: Removed.
        * platform/gtk/ScrollViewGtk.cpp: Added.
        * platform/gtk/SearchPopupMenuGdk.cpp: Removed.
        * platform/gtk/SearchPopupMenuGtk.cpp: Added.
        * platform/gtk/SoundGdk.cpp: Removed.
        * platform/gtk/SoundGtk.cpp: Added.
        * platform/gtk/WheelEventGdk.cpp: Removed.
        * platform/gtk/WheelEventGtk.cpp: Added.
        * platform/gtk/WidgetGdk.cpp: Removed.
        * platform/gtk/WidgetGtk.cpp: Added.
        * platform/network/ResourceHandle.h:

2007-09-23  Rob Buis  <buis@kde.org>

        Reviewed by Hyatt.

        http://bugs.webkit.org/show_bug.cgi?id=15025
        Background repeat css property is not inherited from parent if unspecified

        Don't let invalid url specification in background shorthand make
        the entire shorthand invalid.

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseBackgroundImage):
        (WebCore::CSSParser::parseBackgroundProperty):
        * css/CSSParser.h:

2007-09-22  Adam Roben  <aroben@apple.com>

        Fix Bug 15251: REGRESSION: <input type=range> doesn't respond to form.reset() or setting input.value

        http://bugs.webkit.org/show_bug.cgi?id=15251
        <rdar://5498169>

        Reviewed by Maciej.

        Test: fast/forms/range-reset.html

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::storesValueSeparateFromAttribute): <input
        type=range> should be storing its value separately from the value
        attribute, as do all of our variable-input input types.

2007-09-21  Mark Rowe  <mrowe@apple.com>

        Build fix for non-Mac platforms after r25697.
        
        Rename Frame::cleanupPlatformScriptObjects to Frame::clearPlatformScriptObjects.

        * bridge/win/FrameWin.cpp:
        * page/gdk/FrameGdk.cpp:
        * page/qt/FrameQt.cpp:
        * platform/wx/TemporaryLinkStubs.cpp:

2007-09-21  Adele Peterson  <adele@apple.com>

        Reviewed by Sam.

        Fix for <rdar://problem/5497357> REGRESSION: Safari doesn't show the month days on AirFrance reservation page

        Test: fast/dom/HTMLSelectElement/options-collection-set-string-length.html

        * bindings/js/JSHTMLOptionsCollectionCustom.cpp: (WebCore::JSHTMLOptionsCollection::setLength):
          Convert the value to a number.  We already have code here to check if the value is not a number.
          This matches other browsers, which allow a string value to be used to set the length.

2007-09-21  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5491013> REGRESSION: -[WebView windowScriptObject] returns a dummy object or nil if a page hasn't loaded

        Calling -[WebView windowScriptObject] before the page loads would give you nil. This behavior didn't match Tiger.
        The API behavior in Tiger let you get the window script object once and keep ahold of it as long as you needed it.
        The window object would remain valid even after page loads. This change restores the Tiger behavior.

        <rdar://problem/5495790> NULL dereference crash beneath Bindings::RootObject::interpreter when saving Dashcode document

        The changes to WebScriptObject's _isSafeScript call also fixed the crash in Dashcode.

        * bindings/objc/WebScriptObject.mm:
        (-[WebScriptObject _setOriginRootObject:andRootObject:]): New method used to update the the root objects,
        so the WebScriptObject can still be used after a page load.
        (-[WebScriptObject _isSafeScript]): Call [self _rootObject] instead of accessing the data member directly.
        DOMNode has an override for the _rootObject method, and it can return 0 when _private->_rootObject
        is non-zero. We would return YES here when it wasn't safe and later crash with my modified layout tests.
        Checking _rootObject first prevents other calls sites from needing to check for a valid root object,
        this fixed the Dashcode crash.
        (-[WebScriptObject _imp]): Ditto.

        * bindings/objc/WebScriptObjectPrivate.h: Add _setOriginRootObject:andRootObject:.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::clear): Call the renamed clearScriptObjects function.
        (WebCore::FrameLoader::dispatchWindowObjectAvailable): Some gratuitous code cleanup.

        * page/Frame.cpp:
        (WebCore::Frame::clearScriptObjects): Renamed cleanupScriptObject to clearScriptObjects.
        Call clearPlatformScriptObjects last so m_bindingRootObject is already NULL.
        (WebCore::Frame::windowScriptNPObject): Hold a JSLock before accessing the window. This
        change is unrelated to the bug, but should be fixed.

        * page/mac/FrameMac.mm:
        (WebCore::Frame::windowScriptObject): Return a script object even if the interpreter is NULL.
        This resotres the Tiger behavior of always being able to access the window object.
        (WebCore::Frame::clearPlatformScriptObjects): Keep the window script object around, and update
        the root objects for the window script object.

        * page/Frame.h: Rename cleanupScriptObject to clearScriptObjects.
        * page/FramePrivate.h: Use a RetainPtr for m_windowScriptObject.

2007-09-21  Mike Fenton  <mike@staikos.net>

        Reviewed by George Staikos.

        Fix styled pen support by not clobbering QPen properties.

        * html/CanvasStyle.cpp:
        (WebCore::CanvasStyle::applyStrokeColor):
        (WebCore::CanvasStyle::applyFillColor):

2007-09-21  Oliver Hunt  <oliver@apple.com>

        Reviewed by Tristan and Darin

        http://bugs.webkit.org/show_bug.cgi?id=15239
        <rdar://problem/5491955> REGRESSION (r25547): With Hanin IME, one cannot input characters into forms (15239)
        
        This problem was caused by the setComposition method failing to clear
        the composition markers in the presence of an empty string.  This would 
        result in the caret being locked within the 0 length bounds of the "composition"
        and so preventing basic keyboard interaction.

        * editing/Editor.cpp:
        (WebCore::Editor::setComposition):

2007-09-21  Adele Peterson  <adele@apple.com>

        Reviewed by Tristan.

        Fix for <rdar://problem/5497346> "Check spelling when I click Send" crashes on stationery messages every time

        No test. I wasn't able to find a way to get this to occur with Safari or DumpRenderTree.

        * editing/Editor.cpp: (WebCore::Editor::advanceToNextMisspelling): Updated comment.
        * editing/htmlediting.cpp:
        (WebCore::firstEditablePositionAfterPositionInRoot): Only return the root position if its editable.
        (WebCore::maxDeepOffset): Added nil check & assert.

2007-09-21  Anders Carlsson  <andersca@apple.com>

        Reviewed by Steve.

        <rdar://problem/5404339>
        Site redirects continuosly, starving UI thread, causing app to hang.
        
        Use GetQueueStatus to see if there are input messages in the queue that aren't being processed.
        If so, use a low-priority timer instead of PostMessage.
        
        * platform/win/SharedTimerWin.cpp:
        (WebCore::setSharedTimerFireTime):

2007-09-22  Darin Adler  <darin@apple.com>

        Reviewed by Anders.

        - add QueryInterface capabilities to COMPtr

        * platform/win/COMPtr.h:
        (COMPtr::COMPtr): Added constructor that takes a Query tag and
        does an appropriate QueryInterface.
        (COMPtr::query): Added function to do a queryInterface.
        (COMPtr::copyQueryInterfaceRef): Added private helper used by
        both of the above. Note that when the query fails you get a 0,
        which is the same thing you get if a 0 pointer is passed in.

        * platform/win/FontCacheWin.cpp:
        (WebCore::FontCache::getFontLinkInterface): Convert to using
        the new query as a test case. Also eliminate the unnecessary
        second global variable and use COMPtr objects rather than just
        leaking references.

        * platform/win/WCDataObject.h: Removed unneeded include and
        using statements.

2007-09-21  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam.

        <rdar://problem/5494790>
        clicking any link in the Flash regions at bananarepublic.com results in bad page

        Don't replace the frame contents, the Mac version doesn't do this.
        
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginViewWin::performRequest):

2007-09-21  Anders Carlsson  <andersca@apple.com>

        Reviewed by Darin.

        <rdar://problem/5496700>
        Repro crash loading http://www.tivo.com/whatistivo/tivohd/index.html

        Don't continue if the plug-in cancelled the stream.
                
        * loader/win/NetscapePlugInStreamLoaderWin.cpp:
        (WebCore::NetscapePlugInStreamLoader::didReceiveResponse):

2007-09-21  Kevin Decker  <kdecker@apple.com>

        * platform/mac/SoftLinking.h: Build fix; added necessary #imports. 

2007-09-21  Kevin Decker  <kdecker@apple.com>

        Reviewed by Darin Adler.

        * WebCore.xcodeproj/project.pbxproj: Added SoftLinking.h to the project.
        * platform/mac/SoftLinking.h: Contains a new macro; useful in helping to lazily load frameworks.

2007-09-20  Ada Chan  <adachan@apple.com>

        <rdar://problem/5477240> Regression: Footer is too high in print preview
        Make computePageRectsForFrame() return the height of the page adjusted for margins.

        Reviewed by Steve.

        * bridge/win/FrameWin.cpp:
        (WebCore::computePageRectsForFrame):
        * bridge/win/FrameWin.h:

2007-09-19  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Hyatt.

        - <rdar://problem/5101991> Avril Lavigne music player comes up in a window with scrollbars
        - Implementing missing scrollbar functionality to allow turning off scrollbars correctly.

        * platform/ScrollView.h:
        * platform/win/ScrollViewWin.cpp:
        (WebCore::ScrollView::ScrollViewPrivate::setAllowsScrolling):
        (WebCore::ScrollView::ScrollViewPrivate::allowsScrolling):
        (WebCore::ScrollView::updateScrollbars):
        (WebCore::ScrollView::setAllowsScrolling):
        (WebCore::ScrollView::allowsScrolling):

2007-09-20  Brady Eidson  <beidson@apple.com>

        Reviewed by Dave Hyatt

        <rdar://problem/5245981> - No favicon shows up for cnet.com
        
        CNet's favicon has two images in it - a 32x32 white square, and a 16x16 image that is their actual icon
        Till now on Windows we've always gone straight for the first image in an icon for the favicon, now we
        actually do proper size matching

        * platform/graphics/BitmapImage.h:

        * platform/graphics/Image.h:
        (WebCore::Image::getHBITMAPOfSize): 
        (WebCore::Image::drawFrameMatchingSourceSize): Search through the frames of the image for the correct size

        * platform/graphics/win/ImageWin.cpp:
        (WebCore::BitmapImage::getHBITMAP):
        (WebCore::BitmapImage::getHBITMAPOfSize):
        (WebCore::BitmapImage::drawFrameMatchingSourceSize):

2007-09-20  Steve Falkenburg  <sfalken@apple.com>

        Reviewed by Brady.

        Call ascii() instead of utf8() from debug logging code to avoid threading
        issues associated w/ converting to UTF8.

        * loader/icon/IconDatabase.cpp:
        (WebCore::makeAllDirectories):
        (WebCore::IconDatabase::retainIconForPageURL):
        (WebCore::IconDatabase::releaseIconForPageURL):
        (WebCore::IconDatabase::setIconDataForIconURL):
        (WebCore::IconDatabase::setIconURLForPageURL):
        (WebCore::IconDatabase::loadDecisionForIconURL):
        (WebCore::IconDatabase::getOrCreatePageURLRecord):
        (WebCore::IconDatabase::iconDatabaseSyncThread):
        (WebCore::IconDatabase::performOpenInitialization):
        (WebCore::IconDatabase::checkIntegrity):
        (WebCore::IconDatabase::performURLImport):
        (WebCore::IconDatabase::readFromDatabase):
        (WebCore::IconDatabase::writeToDatabase):
        (WebCore::readySQLStatement):
        (WebCore::IconDatabase::setIconURLForPageURLInSQLDatabase):
        (WebCore::IconDatabase::setIconIDForPageURLInSQLDatabase):
        (WebCore::IconDatabase::removePageURLFromSQLDatabase):
        (WebCore::IconDatabase::getIconIDForIconURLFromSQLDatabase):
        (WebCore::IconDatabase::addIconURLToSQLDatabase):
        (WebCore::IconDatabase::getImageDataForIconURLFromSQLDatabase):
        (WebCore::IconDatabase::removeIconFromSQLDatabase):
        (WebCore::IconDatabase::writeIconSnapshotToSQLDatabase):

2007-09-20  Mike Fenton  <mike@staikos.net>

        Reviewed by George Staikos.

        Implement gradients and more of canvas for Qt.  Style changes and some
        of the stroking fixes by George.

        * html/CanvasGradient.cpp:
        (WebCore::CanvasGradient::CanvasGradient):
        (WebCore::CanvasGradient::~CanvasGradient):
        (WebCore::CanvasGradient::addColorStop):
        (WebCore::CanvasGradient::platformShading):
        * html/CanvasGradient.h:
        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::fill):
        (WebCore::CanvasRenderingContext2D::stroke):
        (WebCore::CanvasRenderingContext2D::fillRect):
        (WebCore::CanvasRenderingContext2D::applyFillPattern):

2007-09-20  Rob Buis  <buis@kde.org>

        Reviewed by Mitz.

        http://bugs.webkit.org/show_bug.cgi?id=15235
        Options can not be removed from a Select element with OptGroup's using JavaScript
        <rdar://problem/5494123>

        Remove HTMLOptionElement children against the proper parent node.

        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::remove):

2007-09-19  John Sullivan  <sullivan@apple.com>

        Reviewed by Darin Adler.
        
        - WebCore part of speculative fix for <rdar://problem/5490627>, about crashes constructing a
          String using the values filled in by checkSpellingOfString()

        * editing/Editor.cpp:
        (WebCore::findFirstMisspellingInRange):
        initialize out parameters the way we do elsewhere; add many assertions for improper results
        from checkSpellingOfString(); don't create a String at all until we've checked all the ways
        that checkSpellingOfString() results could indicate invalid string, even the unexpected ones;
        as an optimization, don't construct a String at all when looping through to mark all instances.

2007-09-18  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Adam.

        There is no need to have FTPDirectoryDocument stubs. We can
        compile FTPDirectoryDocument.cpp and FTPDirectoryTokenizer.cpp
        instead.

        * WebCore.pro:
        * platform/gdk/TemporaryLinkStubs.cpp:
        * platform/qt/TemporaryLinkStubs.cpp:

2007-09-18  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Adam.

        Remove includes that are not needed.

        * platform/gdk/TemporaryLinkStubs.cpp:

2007-09-18  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Adam.

        Move the Pasteboard stubs to PasteboardGdk.cpp.

        * WebCore.pro:
        * platform/gdk/PasteboardGdk.cpp: Added.
        (WebCore::Pasteboard::generalPasteboard):
        (WebCore::Pasteboard::writeSelection):
        (WebCore::Pasteboard::writeURL):
        (WebCore::Pasteboard::writeImage):
        (WebCore::Pasteboard::clear):
        (WebCore::Pasteboard::canSmartReplace):
        (WebCore::Pasteboard::documentFragment):
        (WebCore::Pasteboard::plainText):
        (WebCore::Pasteboard::Pasteboard):
        * platform/gdk/TemporaryLinkStubs.cpp:

2007-09-18  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Adam.

        Move the Icon stubs to IconGdk.cpp

        * WebCore.pro:
        * platform/gdk/TemporaryLinkStubs.cpp:
        * platform/graphics/gdk/IconGdk.cpp: Added.
        (WebCore::Icon::Icon):
        (WebCore::Icon::~Icon):
        (WebCore::Icon::newIconForFile):

2007-09-18  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Adam.

        Move the Font stubs to FontGdk.cpp

        * platform/gdk/FontGdk.cpp:
        (WebCore::Font::drawComplexText):
        (WebCore::Font::floatWidthForComplexText):
        (WebCore::Font::offsetForPositionForComplexText):
        (WebCore::Font::selectionRectForComplexText):
        * platform/gdk/TemporaryLinkStubs.cpp:

2007-09-18  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Adam.

        Move the SearchPopupMenu stubs to SearchPopupMenuGdk.cpp

        * WebCore.pro:
        * platform/gdk/SearchPopupMenuGdk.cpp: Added.
        (WebCore::SearchPopupMenu::SearchPopupMenu):
        (WebCore::SearchPopupMenu::saveRecentSearches):
        (WebCore::SearchPopupMenu::loadRecentSearches):
        (WebCore::SearchPopupMenu::enabled):
        * platform/gdk/TemporaryLinkStubs.cpp:

2007-09-18  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Adam.

        Move the ContextMenu and ContextMenuItem stubs to
        ContextMenuGdk.cpp and ContextMenuItemGdk.cpp.

        * WebCore.pro:
        * platform/gdk/ContextMenuGdk.cpp: Added.
        (WebCore::ContextMenu::ContextMenu):
        (WebCore::ContextMenu::~ContextMenu):
        (WebCore::ContextMenu::appendItem):
        (WebCore::ContextMenu::setPlatformDescription):
        (WebCore::ContextMenu::platformDescription):
        (WebCore::ContextMenu::releasePlatformDescription):
        * platform/gdk/ContextMenuItemGdk.cpp: Added.
        (WebCore::ContextMenuItem::ContextMenuItem):
        (WebCore::ContextMenuItem::~ContextMenuItem):
        (WebCore::ContextMenuItem::releasePlatformDescription):
        (WebCore::ContextMenuItem::type):
        (WebCore::ContextMenuItem::setType):
        (WebCore::ContextMenuItem::action):
        (WebCore::ContextMenuItem::setAction):
        (WebCore::ContextMenuItem::title):
        (WebCore::ContextMenuItem::setTitle):
        (WebCore::ContextMenuItem::platformSubMenu):
        (WebCore::ContextMenuItem::setSubMenu):
        (WebCore::ContextMenuItem::setChecked):
        * platform/gdk/TemporaryLinkStubs.cpp:

2007-09-18  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Adam.

        Implement the WebCore::fileSize function using g_stat.

        * platform/gdk/FileSystemGdk.cpp:
        (WebCore::fileSize):
        * platform/gdk/TemporaryLinkStubs.cpp:

2007-09-18  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Adam.

        Move the ResourceHandle stubs from TemporaryLinkStubs
        to the ResourceHandleCurl.cpp file. This affects the
        Gtk+ and wx port as they share the curl implementation.


        * platform/gdk/TemporaryLinkStubs.cpp:
        * platform/network/curl/ResourceHandleCurl.cpp:
        (WebCore::ResourceHandle::willLoadFromCache):
        (WebCore::ResourceHandle::loadsBlocked):
        * platform/wx/TemporaryLinkStubs.cpp:

2007-09-17  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Mark.

        Take http://bugs.webkit.org/show_bug.cgi?id=15221 into account
        and change the variable names from nameSystem to systemName and
        change the name of the function to stringByAdoptingFileSystemRepresentation.

        * platform/gdk/FileChooserGdk.cpp:
        (WebCore::stringByAdoptingFileSystemRepresentation):
        (WebCore::FileChooser::basenameForWidth):

2007-09-19  Sam Weinig  <sam@webkit.org>

        Reviewed by Geoff Garen.

        Fix <rdar://problem/5492141> Assertion in isdigit() on windows Safari

        Test: fast/css/hexColor-isDigit-assert.html

        * platform/DeprecatedString.cpp:
        (WebCore::isCharacterAllowedInBase): Check that the character is ascii 
        to avoid an assertions on Windows.

2007-09-19  Anders Carlsson  <andersca@apple.com>

        Reviewed by Geoff.

        <rdar://problem/5489879>
        Combination of real player with high connection quality in selecting player makes Safari quit.
        
        Prevent the Real Player plug-in from calling the window proc recursively.
        
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginViewWin::wndProc):
        (WebCore::PluginViewWin::setNPWindowRect):
        (WebCore::PluginViewWin::determineQuirks):
        (WebCore::PluginViewWin::PluginViewWin):
        * plugins/win/PluginViewWin.h:
        (WebCore::):

2007-09-18  Adele Peterson  <adele@apple.com>

        Reviewed by Maciej.

        Fix for <rdar://problem/5472062> -webkit-user-select: none makes selection difficult
        and for <rdar://problem/5472056> REGRESSION: Cannot type into edit fields on a form (sccsheriff.org)

        Tests:

        This fix has a few steps:
        1) Removes the ignore value for the -webkit-user-select property.  We now decide when to prevent selection from starting by calling canStartSelection on the node.
        2) Implements canStartSelection which returns false for all elements that used to have -webkit-user-select:ignore set, true for content editable nodes, 
           and walks up the tree to ask the parent before allowing selection to be started on any other nodes.
        3) We used to disallow selection from starting within -webkit-user-select:none blocks, but now we only use canStartSelection for that.  This will allow easy selections
           in cases like iChat where there's a mix of selectable and non-selectable content.
        4) Makes -webkit-user-select inherited.  After removing the "ignore" value, -webkit-user-select would behave like it was inherited anyways since we already allowed the text value to override the none value.


        * css/html4.css: Removed all usage of -webkit-user-select: ignore.  This is now handled internally with canStartSelection().
          Now -webkit-user-select won't be unintentionally overridden by nodes that don't want to allow selection to be started, but do want to honor the -webkit-user-select to
          determine whether or not selection is allowed at all.

        * editing/SelectionController.cpp: (WebCore::SelectionController::selectAll):
          Don't try to determine whether selection is allowed inside the root node here.  VisiblePosition and Selection creation will keep Selection endpoints out of -webkit-user-select:none regions.
        
        * dom/Node.h:
        * dom/Node.cpp: (WebCore::Node::canStartSelection): Added. Always allows selection to be started in a content editable node.  If there's a parent, ask the parent if starting a selection is allowed.
          If there's no parent, default to allowing selection.
        * html/HTMLAnchorElement.h:
        * html/HTMLAnchorElement.cpp: (WebCore::HTMLAnchorElement::canStartSelection): Added. If its not a link, then calls the base class. Disallows selection for non-editable links.
          Allows selection for editable links.
          This logic used to be done in CSSStyleSelector by changing the user-select property.
        * html/HTMLButtonElement.h: (WebCore::HTMLButtonElement::canStartSelection): Added. Disallows selection from starting in buttons.
        * html/HTMLImageElement.h: (WebCore::HTMLImageElement::canStartSelection): Added. Disallows selection from starting in images.
        * html/HTMLInputElement.h:
        * html/HTMLInputElement.cpp: (WebCore::HTMLInputElement::canStartSelection): Added. Disallows selection from anything that's not a text field.  Text fields call up to the base class.
          When they're editable, text controls will always be selectable because of the case for content editable content. Otherwise, they'll respect their parent element's decision about starting a selection. 
        * html/HTMLSelectElement.h: (WebCore::HTMLSelectElement::canStartSelection): Added. Disallows selection from starting in popup buttons.

        * page/EventHandler.cpp:
        (WebCore::EventHandler::selectClosestWordFromMouseEvent): Use canMouseDownStartSelect instead of the ambiguously named shouldSelect().
        (WebCore::EventHandler::handleMousePressEventTripleClick): ditto.
        (WebCore::EventHandler::handleMousePressEventSingleClick): ditto.
        (WebCore::EventHandler::updateSelectionForMouseDrag): Use canMouseDragExtendSelect.
        (WebCore::EventHandler::selectCursor): Paint an ibeam in any region that allows you to click to create a selection.
        (WebCore::EventHandler::canMouseDownStartSelect): Now fires the selectStart event, and calls canStartSelection instead of checking the user-select property.
        (WebCore::EventHandler::canMouseDragExtendSelect): This is identical to canMouseDownStartSelect because of 12823, even though it seems strange that we would fire the selectStart event here.
        * page/EventHandler.h:
        * page/FocusController.cpp: (WebCore::clearSelectionIfNeeded): Calls canStartSelection instead of checking the user-select property to decide when to prevent selection creation. 
        * rendering/RenderObject.cpp: (WebCore::RenderObject::draggableNode): ditto.
        * rendering/RenderObject.h: Removed helper methods that are no longer needed.

        * rendering/RenderStyle.h: Made userSelect inherited.  After removing the "ignore" value, -webkit-user-select would behave like it was inherited 
          anyways since we already allowed the text value to override the none value.
          Removed the SELECT_AUTO and SELECT_IGNORE values since they're no longer used.
        (WebCore::):
        (WebCore::RenderStyle::userSelect):
        (WebCore::RenderStyle::setUserSelect):
        (WebCore::RenderStyle::initialUserSelect):
        * rendering/RenderStyle.cpp:
        (WebCore::StyleRareNonInheritedData::StyleRareNonInheritedData):
        (WebCore::StyleRareNonInheritedData::operator==):
        (WebCore::StyleRareInheritedData::StyleRareInheritedData):
        (WebCore::StyleRareInheritedData::operator==):
        (WebCore::RenderStyle::diff):

        * css/CSSComputedStyleDeclaration.cpp: (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue): Remove case for SELECT_AUTO and SELECT_IGNORE
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::adjustRenderStyle):  Remove adjustment for links.  This is now handled in HTMLAnchorElement::canStartSelection.
        (WebCore::CSSStyleSelector::applyProperty): Map CSS_VAL_AUTO to SELECT_TEXT.  Remove CSS_VAL_IGNORE.

2007-09-18  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Darin.

        <rdar://problem/5478250> REGRESSION: After pasting text copied from Mail subject and typing return, the cursor disappears because of negative left margin

        When pasting text from the Mail subject line, the RTF pasteboard contains text that has a first line negative indent along with a
        paragraph indent that has a counteracting positive indent. This results in the first line being flush left justified, and the remaining
        wrapped lines being indented. When this is converted to a DOM fragment, AppKit makes a block element with a margin-left and a negative
        text-indent that matches the RTF. So far this is all correct behavior.

        When this content is pasted on the line of an existing paragraph that has content, ReplaceSelectionCommand will decided to merge the paragraphs.
        This will convert the block element to a style span that has all inherited style properties. These inherited properties will still contain block
        properties that have no affect on inline elements. These block properties will hang around on the style span and will get cloned to new block
        elements if the user hit return on that line. The new block elements would then have the text-indent but not the margin-left, so the text would be
        hidden off the left edge of the page.

        In the end, we should never hang on to block-only properties in our style spans. This cuts out meaningless properties and prevents properties
        from magically affecting blocks later if the style is cloned for a new block element during a future editing operation.

        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::removeRedundantStyles): Remove any inherited block properties that are now in the span's style.
        * editing/markup.cpp:
        (WebCore::createMarkup): Ditto.

2007-09-18  Dave Hyatt  <hyatt@apple.com>

        Land a UnicodeRange helper class (ported from Mozilla) that we are going to use to prepare for making
        language-sensitive fallback choices for fonts.

        Reviewed by olliej

        * WebCore.vcproj/WebCore.vcproj:
        * platform/UnicodeRange.cpp: Added.
        (WebCore::):
        (WebCore::findCharUnicodeRange):
        (WebCore::langGroupFromUnicodeRange):
        * platform/UnicodeRange.h: Added.

2007-09-18  Dave Hyatt  <hyatt@apple.com>

        Fix a bug in my previous patch.  Make sure to select the old font back into the HDC and to also release the HDC.
       
        Reviewed by aroben

        * platform/win/FontCacheWin.cpp:
        (WebCore::FontCache::getFontDataForCharacters):

2007-09-18  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin.

        Patch for <rdar://problem/5488478> Safari crashes when passing null to Range.insertNode()

        Test: fast/dom/Range-insertNode-crash.html

        * dom/Range.cpp:
        (WebCore::Range::insertNode): Null check the passed in node to insert.

2007-09-18  Mike Fenton  <mike@staikos.net>

        Reviewed by George Staikos.

        Retain the pen properties when changing one aspect of the pen.

        * html/CanvasStyle.cpp:
        (WebCore::CanvasStyle::applyStrokeColor):

2007-09-18  Mike Fenton  <mike@staikos.net>

        Reviewed by George Staikos.

        Make <canvas> work in more cases by restarting the painter after we
        finish painting, and restoring the pen and opacity.

        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::paint):

2007-09-18  Mitz Pettel  <mitz@webkit.org>

        Reviewed by Darin.

        - fix http://bugs.webkit.org/show_bug.cgi?id=15169
          Freeze on Google maps using the "Dig a hole" tool
          <rdar://problem/5477414>

        Test: fast/dom/CSSStyleDeclaration-empty-string-property.html

        * bindings/js/JSCSSStyleDeclarationCustom.cpp:
        (WebCore::cssPropertyName): Added an early return if the property name
        is the empty string, thus avoiding a loop that is not prepared for that
        case.

2007-09-19  Darin Adler <darin@apple.com>

        Reviewed by Adam.

        - fix <rdar://problem/5415734> <select> draws incorrectly if size of menu options
          is changed after it pops up once

        * platform/win/PopupMenuWin.cpp:
        (WebCore::PopupMenu::PopupMenu): Removed unnecessary initialization of IntRect.
        (WebCore::PopupMenu::show): Check that the clientRect is empty instead of checking
        the entire windowRect -- this fixes a bug where we pop up a tiny 2-pixel high black
        box when you click on an empty menu.
        (WebCore::PopupMenu::visibleItems): Base the number of items on the client rect
        instead of the window rect. Rounding down means this would have worked anyway, but
        it's more correct to do it this way.
        (WebCore::PopupMenu::paint): Deallocate the bitmap so it gets reallocated if it
        has the wrong width or height (or if GetObject returns false, which should not
        happen in practice).

2007-09-18  David Harrison  <harrison@apple.com>

        Reviewed by Darin.

        <rdar://problem/5486974> REGRESSION(r25373): 1/4 second to doubleclick word in GMail when using Kotoeri IM, also slow in other IMs (15163)

        Updated tests:
        * fast/dom/Window/window-xy-properties-expected.txt:
        * fast/dom/plugin-attributes-enumeration-expected.txt:
        * fast/events/onerror-bubbling-expected.txt:
        * fast/events/related-target-expected.txt:
        * fast/forms/select-namedItem-expected.txt:
        * fast/table/incomplete-table-in-fragment-2-expected.txt:
        * fast/table/incomplete-table-in-fragment-hang-expected.txt:
        * fast/table/large-rowspan-crash-expected.txt:
        * plugins/embed-attributes-setting-expected.txt:

        * editing/TextIterator.cpp:
        (WebCore::TextIterator::shouldRepresentNodeOffsetZero):
        Avoid VisiblePosition check if the current node is a descendant
        of the start container and the start offset was 0. In that case
        we already had enough context to correctly decide whether to emit
        a newline after a preceding block. We chose not to emit
        (m_haveEmitted is false), so don't second guess that.
            
        (WebCore::TextIterator::exitNode):
        Changed some comments.

2007-09-17  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Darin Adler.

        Speculative fix for <rdar://problem/5479443> REGRESSION: Hang due to 
        infinite JS recursion on close @ engadget.com (onunload-based ad)
        
        If page is NULL, shouldInterruptScript now returns true, so you can't 
        get stuck in a state in which a script executes forever without putting 
        up a UI to ask if it should stop.

        * bindings/js/kjs_binding.cpp:
        (KJS::ScriptInterpreter::shouldInterruptScript):

2007-09-17  Dave Hyatt  <hyatt@apple.com>

        Fix for bug 14743, missing glyphs on many international sites because of MLang's tiny cache.
        
        Bypass Mlang's cache entirely.  Get the mapped font from MLang, obtain the font name, and then feed
        the name back into our own system so that it gets created and cached again without MLang being involved.
        Then free up the font obtained from MLang immediately so that its cache just remains empty.
           
        Reviewed by aroben

        * platform/FontData.h:
        (WebCore::FontData::isSystemFont):
        * platform/win/FontCacheWin.cpp:
        (WebCore::FontCache::getFontDataForCharacters):
        * platform/win/FontDataWin.cpp:
        (WebCore::FontData::platformInit):
        (WebCore::FontData::platformDestroy):
        * platform/win/UniscribeController.cpp:
        (WebCore::UniscribeController::shapeAndPlaceItem):
        
2007-09-17  Adam Roben  <aroben@apple.com>

        Fix <rdar://5423441> Should get focus ring color from SafariTheme

        Reviewed by Hyatt.

        No regression test possible.

        * WebCore.vcproj/WebCore.vcproj: Added ColorSafari.cpp.
        * platform/graphics/win/ColorSafari.cpp: Added.
        (WebCore::makeRGBAFromCGColor): Added.
        (WebCore::focusRingColor): Added. Gets the focus ring color from
        SafariTheme if SafariTheme has support for it.
        (WebCore::setFocusRingColorChangeFunction): Added.
        * platform/win/TemporaryLinkStubs.cpp: Removed focus ring color
        functions.

2007-09-17  Anders Carlsson  <andersca@apple.com>

        Fix Windows build.

        * WebCore.vcproj/WebCore.vcproj:
        * loader/NetscapePlugInStreamLoader.h:

2007-09-17  Anders Carlsson  <andersca@apple.com>

        Fix Mac build.
        
        * loader/NetscapePlugInStreamLoader.cpp:
        * loader/NetscapePlugInStreamLoader.h:
        * loader/win/NetscapePlugInStreamLoaderWin.cpp: Copied from loader/NetscapePlugInStreamLoader.cpp.

2007-09-17  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam.

        <rdar://problem/5483346>
        crash at vw.com WebCore::PluginViewWin::disconnectStream.
        
        The following events would lead to this crash:
        
        1. a plug-in stream finishes loading and calls NPP_DestroyStream.
        2. the DestroyStream handler calls NPN_Evaluate, submitting a form through JavaScript.
        3. A new page is going to be loaded and DocumentLoader::stopLoading is called.
        4. DocumentLoader::stopLoading will stop all loader, including the one that is done loading!
        
        The fix is to port NetscapePluginStreamLoader over from the Mac code and use it instead. This fixes the crash
        because it disassociates the stream loader with the document loader _before_ calling NPP_DestroyStream, whereas
        SubresourceLoader does this _after_ calling NPP_DestroyStream. 
        
        * loader/NetscapePlugInStreamLoader.cpp:
        (WebCore::NetscapePlugInStreamLoader::NetscapePlugInStreamLoader):
        (WebCore::NetscapePlugInStreamLoader::~NetscapePlugInStreamLoader):
        (WebCore::NetscapePlugInStreamLoader::create):
        (WebCore::NetscapePlugInStreamLoader::isDone):
        (WebCore::NetscapePlugInStreamLoader::releaseResources):
        (WebCore::NetscapePlugInStreamLoader::didReceiveResponse):
        (WebCore::NetscapePlugInStreamLoader::didReceiveData):
        (WebCore::NetscapePlugInStreamLoader::didFinishLoading):
        (WebCore::NetscapePlugInStreamLoader::didFail):
        (WebCore::NetscapePlugInStreamLoader::didCancel):
        * loader/NetscapePlugInStreamLoader.h:
        (WebCore::NetscapePlugInStreamLoaderClient::didFinishLoading):
        * plugins/win/PluginStreamWin.cpp:
        (WebCore::PluginStreamWin::start):
        (WebCore::PluginStreamWin::didReceiveResponse):
        (WebCore::PluginStreamWin::didReceiveData):
        (WebCore::PluginStreamWin::didFail):
        (WebCore::PluginStreamWin::didFinishLoading):
        * plugins/win/PluginStreamWin.h:
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginViewWin::load):

2007-09-17  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam.

        <rdar://problem/5483839>
        Crash loading http://www.microsoft.com if Silverlight 1.0 is installed.
        
        Work around a problem in our NPRuntime implementation by never unloading the silverlight plug-in dll.
        
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginViewWin::~PluginViewWin):
        (WebCore::PluginViewWin::determineQuirks):
        * plugins/win/PluginViewWin.h:
        (WebCore::):

2007-09-17  Brady Eidson  <beidson@apple.com>

        Reviewed by John Sullivan

        Fix for http://bugs.webkit.org/show_bug.cgi?id=15178
        and
        <rdar://problem/5474001>

        The stress test proves that this was an overzealous ASSERT.  It is very possible to mark an icon
        for addition to the on-disk database and then mark it for removal before it is ever written out.  
        This is not an error and was already handled gracefully

        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::removeIconFromSQLDatabase): Don't ASSERT of log if the icon wasn't on disk

2007-09-17  Brady Eidson  <beidson@apple.com>

        Reviewed by Oliver

        <rdar://problem/5487048> - ASSERT in stress test in IconDatabase

        If a PageURLRecord went away, it never clears its URL from the IconRecord it retained.

        * loader/icon/PageURLRecord.cpp:
        (WebCore::PageURLRecord::~PageURLRecord): Set the icon record to 0, clearing the page url
        * loader/icon/PageURLRecord.h: Add the destructor

2007-09-17  Antti Koivisto  <antti@apple.com>

        Reviewed by Darin.
        
        Fix <rdar://problem/5480050>
        Leopard9A551 with Dashcode 112: Dashcode crash when dragging image into canvas.
        
        If @import stylesheet was modified through CSS DOM style selector would not get updated. This
        could lead to crashes.

        Test: fast/css/import-style-update.html

        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::styleSheetChanged):

2007-09-17  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam.

        <rdar://problem/5421997>
        http://bugs.webkit.org/show_bug.cgi?id=14247
        Display problem with Flash - image does not stop changing
        
        Port the manual load code over from the Mac version.

        * plugins/win/PluginDatabaseWin.cpp:
        (WebCore::PluginDatabaseWin::createPluginView):
        * plugins/win/PluginDatabaseWin.h:
        Add load manually parameter.
        
        * plugins/win/PluginStreamWin.cpp:
        (WebCore::PluginStreamWin::stop):
        If we're loading manually, cancel the main resource load.
         
        (WebCore::PluginStreamWin::destroyStream):
        Don't disconnect the stream if we're loading manually.
        
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginViewWin::setFrameGeometry):
        Always call updateWindow()
        
        (WebCore::PluginViewWin::PluginViewWin):
        Initialize loadManually.
        
        (WebCore::PluginViewWin::init):
        Don't set the width and height of the window here since it will make the plug-in HWND show briefly
        before it's been positioned.
        
        (WebCore::PluginViewWin::didReceiveResponse):
        Create the manual stream.
        
        (WebCore::PluginViewWin::didReceiveData):
        (WebCore::PluginViewWin::didFinishLoading):
        (WebCore::PluginViewWin::didFail):
        Call through to the manual stream.
        
        * plugins/win/PluginViewWin.h:

2007-09-16  Sam Weinig  <sam@webkit.org>

        Reviewed by Maciej.

        Fix for http://bugs.webkit.org/show_bug.cgi?id=14693
        document.width/height doesn't force layout

        Test: fast/dom/document-width-height-force-layout.html

        * html/HTMLDocument.cpp:
        (WebCore::HTMLDocument::width): Force layout.
        (WebCore::HTMLDocument::height): ditto.
        * html/HTMLDocument.h:

2007-09-15  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Mark.

        Convert the filenames from WebCore::String to the filesystem encoding
        and vice versa using g_filename_{from,to}_utf8 functions. Also add the needed NULL
        checks for the return values where glib and gtk+ can return NULL.

        * platform/gdk/FileChooserGdk.cpp:
        (WebCore::convertToStringByAdoptingTheFilesystemRepresentation):
        (WebCore::FileChooser::openFileChooser):
        (WebCore::FileChooser::basenameForWidth):

2007-09-15  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Mark.

        Use the new WebCore::String::fromUTF8 function to create
        the labels.

        * platform/gdk/LocalizedStringsGdk.cpp:
        (WebCore::submitButtonDefaultLabel):
        (WebCore::inputElementAltText):
        (WebCore::resetButtonDefaultLabel):
        (WebCore::searchableIndexIntroduction):
        (WebCore::fileButtonChooseFileLabel):
        (WebCore::fileButtonNoFileSelectedLabel):
        (WebCore::contextMenuItemTagOpenLinkInNewWindow):
        (WebCore::contextMenuItemTagDownloadLinkToDisk):
        (WebCore::contextMenuItemTagCopyLinkToClipboard):
        (WebCore::contextMenuItemTagOpenImageInNewWindow):
        (WebCore::contextMenuItemTagDownloadImageToDisk):
        (WebCore::contextMenuItemTagCopyImageToClipboard):
        (WebCore::contextMenuItemTagOpenFrameInNewWindow):
        (WebCore::contextMenuItemTagCopy):
        (WebCore::contextMenuItemTagGoBack):
        (WebCore::contextMenuItemTagGoForward):
        (WebCore::contextMenuItemTagStop):
        (WebCore::contextMenuItemTagReload):
        (WebCore::contextMenuItemTagCut):
        (WebCore::contextMenuItemTagPaste):
        (WebCore::contextMenuItemTagNoGuessesFound):
        (WebCore::contextMenuItemTagIgnoreSpelling):
        (WebCore::contextMenuItemTagLearnSpelling):
        (WebCore::contextMenuItemTagSearchWeb):
        (WebCore::contextMenuItemTagLookUpInDictionary):
        (WebCore::contextMenuItemTagOpenLink):
        (WebCore::contextMenuItemTagIgnoreGrammar):
        (WebCore::contextMenuItemTagSpellingMenu):
        (WebCore::contextMenuItemTagShowSpellingPanel):
        (WebCore::contextMenuItemTagCheckSpelling):
        (WebCore::contextMenuItemTagCheckSpellingWhileTyping):
        (WebCore::contextMenuItemTagCheckGrammarWithSpelling):
        (WebCore::contextMenuItemTagFontMenu):
        (WebCore::contextMenuItemTagBold):
        (WebCore::contextMenuItemTagItalic):
        (WebCore::contextMenuItemTagUnderline):
        (WebCore::contextMenuItemTagOutline):
        (WebCore::contextMenuItemTagWritingDirectionMenu):
        (WebCore::contextMenuItemTagDefaultDirection):
        (WebCore::contextMenuItemTagLeftToRight):
        (WebCore::contextMenuItemTagRightToLeft):
        (WebCore::contextMenuItemTagInspectElement):
        (WebCore::searchMenuNoRecentSearchesText):
        (WebCore::searchMenuRecentSearchesText):
        (WebCore::searchMenuClearRecentSearchesText):

2007-09-15  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Mark.

        Add WebCore::String::fromUTF8 to convert from UTF-8
        to a WebCore::String. This is meant to be used by
        the Gtk+ port and the signature and implementation
        is similiar to the one of DeprecatedString.

        * platform/PlatformString.h:
        * platform/String.cpp:
        (WebCore::String::fromUTF8):

2007-09-13  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Anders.

        Implement the fileExists and deleteFile functions
        using glib.

        * WebCore.pro:
        * platform/gdk/FileSystemGdk.cpp: Added.
        (WebCore::fileExists):
        * platform/gdk/TemporaryLinkStubs.cpp:

2007-09-16  David Harrison  <harrison@apple.com>

        Reviewed by Darin.

        <rdar://problem/5472125> REGRESSION (9A535-9A548): No VO cursor shown when navigating in a mail message body

        The problem was that the visible units code was mishandling non-editable content, generating null
        VisiblePositions instead of the actual boundary VisiblePositions.
        
        Updated tests:
        * fast/dom/Window/window-xy-properties-expected.txt:
        * fast/dom/plugin-attributes-enumeration-expected.txt:
        * fast/events/onerror-bubbling-expected.txt:
        * fast/events/related-target-expected.txt:
        * fast/forms/select-namedItem-expected.txt:
        * fast/table/incomplete-table-in-fragment-2-expected.txt:
        * fast/table/incomplete-table-in-fragment-hang-expected.txt:
        * fast/table/large-rowspan-crash-expected.txt:
        * plugins/embed-attributes-setting-expected.txt:
       
        Source Changes:
        * editing/VisiblePosition.cpp:
        (WebCore::VisiblePosition::next):
        (WebCore::VisiblePosition::previous):
        (WebCore::VisiblePosition::honorEditableBoundaryAtOrBefore):
        (WebCore::VisiblePosition::honorEditableBoundaryAtOrAfter):
        Rename firstEditablePositionAtOrAfter to honorEditableBoundaryAtOrAfter.
        Rename firstEditablePositionAtOrBefore to honorEditableBoundaryAtOrBefore.
        Changed these two functions to handle non-editable positions.
        
        * editing/VisiblePosition.h:
        * editing/visible_units.cpp:
        (WebCore::previousWordPosition):
        (WebCore::nextWordPosition):
        (WebCore::positionAvoidingFirstPositionInTable):
        (WebCore::startPositionForLine):
        (WebCore::startOfLine):
        (WebCore::endOfLine):
        (WebCore::previousSentencePosition):
        (WebCore::nextSentencePosition):
        Rename firstEditablePositionAtOrAfter to honorEditableBoundaryAtOrAfter.
        Rename firstEditablePositionAtOrBefore to honorEditableBoundaryAtOrBefore.
        Also, startOfLine() now calls positionAvoidingFirstPositionInTable() in the empty block early return case.
        positionAvoidingFirstPositionInTable() was the logic startOfLine() used in the normal case. Now in a reusable function.

2007-09-14  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam.

        Mac doesn't have any kind of not implemented macro, so we'll actually implement
        fileSize.

        * platform/mac/FileSystemMac.mm:
        (WebCore::fileSize):

2007-09-14  Timothy Hatcher  <timothy@apple.com>

        Initialize m_dialogArguments to 0. Fixes the newly crashing layout tests.

        * bindings/js/kjs_window.cpp:
        (KJS::WindowPrivate::WindowPrivate):

2007-09-14  Oliver Hunt  <oliver@apple.com>

        Reviewed by Brady, John H.

        <rdar://problem/5483632> File system operation wrappers are unimplemented on windows
        
        Implement Windows versions of fileExists and deleteFile. 
        Also corrects fileSize to use a 64-bit version of stat.

        * platform/win/FileSystemWin.cpp:
        (WebCore::fileSize):  
          Renamed argument to be more consistent with others.
          And converted to _stat32i64 to allow 64-bit filesizes
        (WebCore::fileExists):
        (WebCore::deleteFile):
        * platform/win/TemporaryLinkStubs.cpp:

2007-09-14  Oliver Hunt  <oliver@apple.com>

        Reviewed by Sam and Geoff.

        <rdar://problem/5333272> Cannot upload files when path contains 
        non-ascii/multibyte characters

        We can't use _stat to determine file size on Windows as it may not 
        correctly handle multibyte characters, so we have to use _wstat.
        
        In deference to the fact that we may one day use the FormDataStreamCFNet.cpp
        on Mac i've wrapped the call to _wstat with a generic fileSize
        method in FileSystem.h

        * WebCore.vcproj/WebCore.vcproj:
        * platform/FileSystem.h:
        * platform/network/cf/FormDataStreamCFNet.cpp:
        * platform/win/FileSystemWin.cpp: Added.
        (WebCore::setHTTPBody):
        * platform/gdk/TemporaryLinkStubs.cpp:
        * platform/mac/FileSystemMac.mm:
        (WebCore::fileSize):
        * platform/qt/TemporaryLinkStubs.cpp:

2007-09-14  Timothy Hatcher  <timothy@apple.com>

        Reviewed by Sam.

        <rdar://problem/5472970> REGRESSION (r24276): TinyMCE popups show an empty window with no content

        Accessing the document of a window before the load finished would cause the window
        object to hold onto the initial empty document, and never switch over to the real document
        once the load finished. This regression was caused by r24276 which added a check to prevent
        clearing the window object when the load finished. The absence of this clear allowed the
        dialogArguments set with showModalDialog to persist on the window after the load. However,
        not clearing the window would keep other properties (and the empty document object) around.

        So the fix is to store away the dialog arguments that were passed to showModalDialog and
        put them back on the window object in the dialogArguments property each time
        the window is cleared.

        * bindings/js/kjs_window.cpp:
        (KJS::createWindow): No longer put dialogArguments on the window here.
        (KJS::showModalDialog): Put dialogArguments on the window and call
        setDialogArgumentsAndReturnValueSlot to remember the arguments.
        (KJS::Window::clear): Put m_dialogArguments back on the window as dialogArguments.
        (KJS::WindowFunc::callAsFunction): Call the new setDialogArgumentsAndReturnValue.
        (KJS::Window::setDialogArgumentsAndReturnValue): Store the arguments in m_dialogArguments.
        * bindings/js/kjs_window.h: Rename setReturnValueSlot to setDialogArgumentsAndReturnValueSlot.
        * manual-tests/modal-dialog-arguments.html: Confirmed that this test still passes.

        Reverted r24276 which was all the changes in FrameLoader.cpp and FrameLoader.h.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::FrameLoader): Remove m_shouldClearWindowProperties.
        (WebCore::FrameLoader::createWindow): Remove the call to setShouldClearWindowProperties.
        (WebCore::FrameLoader::clear): No longer check m_shouldClearWindowProperties, clear the
        window whenever clearWindowProperties is set.
        (WebCore::FrameLoader::begin): Remove m_shouldClearWindowProperties.
        (WebCore::FrameLoader::open): Ditto.
        * loader/FrameLoader.h: Remove m_shouldClearWindowProperties.

2007-09-14  Brady Eidson  <beidson@apple.com>

        How about a build fix that works on *all* platforms?

        * platform/Threading.h:
        (WebCore::initializeThreading):

2007-09-14  Brady Eidson  <beidson@apple.com>

        Roll out my previous build fix and just make the stupid thing inline
        (I knew there was something easier but oh boy, no coffee yet... weinig?)

2007-09-14  Brady Eidson  <beidson@apple.com>

        Rubberstamped by Mark Rowe

        Add the logging channel I just created to the initialize list on Mac

        * platform/mac/LoggingMac.mm:
        (WebCore::InitializeLoggingChannelsIfNecessary):

2007-09-14  Brady Eidson  <beidson@apple.com>

        Build fix

        That method can't go in the header, apparently

        * platform/Threading.h:
        * platform/gdk/TemporaryLinkStubs.cpp:
        (WebCore::initializeThreading):
        * platform/mac/Threading.mm:
        (WebCore::initializeThreading):
        * platform/qt/TemporaryLinkStubs.cpp:
        (WebCore::initializeThreading):

2007-09-14  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin

        -Add callOnMainThread() implementation to Windows

        * WebCore.vcproj/WebCore.vcproj:
        
        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::open): Call initializeThreading() from the main thread before kicking off the secondary thread
        
        * platform/Logging.cpp: Added Threading logging channel
        (WebCore::):
        * platform/Logging.h: Ditto
        
        * platform/Threading.h:
        (WebCore::initializeThreading): Added - only needs Windows impl for now
        * platform/win/ThreadingWin.cpp: Added.
        (WebCore::callFunctionsOnMainThread): Calls each function currently in the main-thread queue
        (WebCore::ThreadingWindowWndProc):
        (WebCore::initializeThreading): Creates a message-only window to use for callOnMainThread()
        (WebCore::callOnMainThread): Queues the function to be called and posts a message to the threading
          window such that the function-call-queue can be addressed
        
        * platform/win/TemporaryLinkStubs.cpp:
        (WebCore::signedPublicKeyAndChallengeString):
        
2007-09-14  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam.

        <rdar://problem/5316743>
        Safari does not handle filename parameter of content-disposition
        
        Use CFURLResponseCopySuggestedFilename instead of our own hand-rolled implementation. 
        
        While we do return the correct filename in all cases I've tried, using CFNetwork is better because
        it might handle corner cases that we don't.
        
        * platform/network/cf/ResourceResponseCFNet.cpp:
        (WebCore::ResourceResponse::doUpdateResourceResponse):
        
2007-09-14  Geoffrey Garen  <ggaren@apple.com>

        Reviewed by Adam Roben.

        Fixed http://bugs.webkit.org/show_bug.cgi?id=15209
        Sometimes removing an iframe from the DOM does not remove its frame 
        from the page

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::requestFrame): Use the contentFrame pointer
        directly instead of searching for a frame by the frame element's name, 
        because the frame element's name may have changed. (Another reason to do
        this is that it's just plain more straight-forward and efficient.)

2007-09-14  Darin Adler  <darin@apple.com>

        Reviewed by Mitz and Kevin Decker.

        - fix http://bugs.webkit.org/show_bug.cgi?id=15197
          <rdar://problem/5478271> REGRESSION: Some Yahoo text entry fields
          render as lines rather than text entry boxes

        Test: fast/forms/textarea-rows-cols.html

        * html/HTMLTextAreaElement.cpp:
        (WebCore::HTMLTextAreaElement::HTMLTextAreaElement): Use constants for the default number
        of rows and columns.
        (WebCore::HTMLTextAreaElement::parseMappedAttribute): If rows/cols attribute has a value
        that's missing, non-numeric, or zero, then use the default value. Also check for the
        case where the effective value of the attribute isn't changing.

2007-09-14  Sven Herzberg  <sven@imendio.com>

        Reviewed by George.

        Don't maintain obsolete code, fixes:
        http://bugs.webkit.org/show_bug.cgi?id=15215

        * platform/gdk/FontPlatformData.cpp: remove static
        FontPlatformData::list() (isn't used at any place)

2007-09-14  Sven Herzberg  <sven@imendio.com>

        Reviewed by Adam Roben.

        Don't use fontconfig types if necessary, fixes:
        http://bugs.webkit.org/show_bug.cgi?id=15203

        * platform/gdk/FontPlatformData.cpp: don't use an FcBool to store the
        initialized state, use a plain c++ bool instead

2007-09-13  Brady Eidson  <beidson@apple.com>

        Reviewed by Maciej

        <rdar://problem/5480437> - No site icon at launch and related error messages

        The error message was actually indicative of a larger bug that might've resulted in icons getting
        improperly pruned because they were never added to the set of retained page URLs.

        To solve the no-icon-at-launch problem, we send the "didReceiveIcon:" delegate call for every page 
        load that has an icon, whether the icon comes in from network, from disk, or was already in ram

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::startIconLoader): Always send the didReceiveIcon delegate call when an icon's 
          image data is known

        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::retainIconForPageURL): Much more accurately track the set of retained pages by
          adding them when their retain count moves from 0 to 1

        * loader/icon/PageURLRecord.h:
        (WebCore::PageURLRecord::retain): Correctly distinguish the "retain count just went from 0 to 1" case
          in the return value

2007-09-13  Brady Eidson  <beidson@apple.com>

        Rubberstamped by Geoff and Maciej

        Fix MSVC build warning due to out of range data in a char array

        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::defaultIcon): The buffer is now unsigned data

        * platform/SharedBuffer.cpp:
        (WebCore::SharedBuffer::SharedBuffer): Add the "unsigned char*" c'tor
        * platform/SharedBuffer.h:

2007-09-13  Darin Adler  <darin@apple.com>

        Reviewed by Oliver.

        - fix <rdar://problem/5470457> REGRESSION: Input method inline hole is mishandled in text
          <input> elements with maxlength limit

        * editing/Editor.h: Moved MarkedTextUnderline here and renamed it CompositionUnderline.
        Moved the rest of the marked text API here and used the term that will be more familiar
        to those on platforms other than Macintosh, "composition". This helps prevent confusion
        with the other kinds of mark -- the emacs "mark" and spelling/grammar marks. Also
        cleaned up the conditionals a bit for the Macintosh-specific parts of this header.

        * editing/Editor.cpp:
        (WebCore::Editor::Editor): Updated for name change.
        (WebCore::Editor::clear): Added. To be called by FrameLoader::clear().
        (WebCore::Editor::insertTextWithoutSendingTextEvent): Removed code to make inserted
        text replace the marked text range -- we now deal with this explicitly by not
        calling this function to replace marked text. Also removed unneeded code that was
        specific to the use of this to replace the marked text.
        (WebCore::Editor::selectComposition): Renamed from selectMarkedText. Updated since
        the composition range is not stored as a Range.
        (WebCore::Editor::confirmComposition): Added. To be called when changing a composition
        into actual text. Unlike the old code path, deletes the composition first, then inserts
        the text, triggering the normal insertion code path and events. This is helpful because
        it means the inserted text will be truncated by the <input> element, for example.
        (WebCore::Editor::confirmCompositionWithoutDisturbingSelection): Added.
        (WebCore::Editor::setComposition): Added. To be called when changing the composition.
        Takes parameters for the underlines and selection. Unlike the old code path, this passes
        a flag down that indicates the inserted text is part of a composition. This is helpful
        because we don't send the event that will cause the <input> element to do truncation.
        It's also a better API for future improvements to our input method handling.
        (WebCore::Editor::revealSelectionAfterEditingOperation): Updated for name change.
        (WebCore::Editor::setIgnoreCompositionSelectionChange): Ditto.
        (WebCore::Editor::compositionRange): Added. Needed now that the composition is not
        stored as a Range.
        (WebCore::Editor::getCompositionSelection): Added.

        * editing/TypingCommand.h:
        * editing/TypingCommand.cpp: (WebCore::TypingCommand::insertText):
        Added an insertedTextIsComposition parameter, and don't send the BeforeTextInsertedEvent
        if it's true.

        * loader/FrameLoader.cpp: (WebCore::FrameLoader::clear): Replaced the Macintosh-specific
        call to setMarkedTextRange with a call to the new Editor::clear().

        * page/Frame.h:
        * page/Frame.cpp:
        * page/FramePrivate.h:
        * page/mac/FrameMac.mm:
        Removed the marked text code. It was streamlined and moved to Editor, except for the
        Mac-specific code, which was moved into WebKit.

        * page/mac/WebCoreFrameBridge.h:
        * page/mac/WebCoreFrameBridge.mm: Removed some now-unneeded marked text code.
        (-[WebCoreFrameBridge markedTextNSRange]): Updated for name/API change.

        * rendering/InlineTextBox.h:
        * rendering/InlineTextBox.cpp:
        (WebCore::InlineTextBox::paint): Updated marked text code for name changes, and also
        streamlined the code a bit for the case where there is no composition.
        (WebCore::InlineTextBox::paintCompositionBackground): Name change.
        (WebCore::InlineTextBox::paintCompositionUnderline): Ditto.

        * rendering/RenderTextControl.h:
        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::finishText): Added. Helper function shared by the
        (WebCore::RenderTextControl::text):
        (WebCore::getNextSoftBreak):
        (WebCore::RenderTextControl::textWithHardLineBreaks):

        * platform/CharacterNames.h: Added newlineCharacter.

        * dom/Range.h: Remove the now-unneeded version of toString that converts <br>
        elements into newlines.
        * dom/Range.cpp:
        (WebCore::Range::toString): Changed this to use a Vector<UChar> instead of
        a String so it will not have pathological reallocation performance, and removed
        the <br> feature.
        (WebCore::Range::pastEndNode): Made this return 0 when there is no start node.
        This bit of extra robustness guarantees you can't do a null dereference if the
        start node is 0 and the end node is not. Not sure this case really exists.

        * page/ContextMenuController.cpp: (ContextMenuController::contextMenuItemSelected):
        Removed a semi-bogus use of Range::toString(true). The right function to use here
        is plainText().

        * bridge/EditorClient.h: Removed obsolete markedTextAbandoned function.

        * WebCore.exp: Updated for above changes. 

2007-09-13  Anders Carlsson  <andersca@apple.com>

        Reviewed by Adam and Geoff.

        <rdar://problem/5304000>
        Windows Safari doesn't always call NPP_SetWindow() for NPAPI plugins.
        
        This does two things:
        
        1. Makes sure that the plug-in get the correct initial size.
        
        2. Always updates the size of the HWND, even if the widget size didn't change. This is because
        the widget size can be different before the HWND has been created.
        
        * plugins/win/PluginDatabaseWin.cpp:
        (WebCore::PluginDatabaseWin::createPluginView):
        * plugins/win/PluginDatabaseWin.h:
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginViewWin::setFrameGeometry):
        (WebCore::PluginViewWin::PluginViewWin):
        * plugins/win/PluginViewWin.h:

2007-09-13  Kevin McCullough  <kmccullough@apple.com>

        Reviewed by Geof, Sam, Adam, Hyatt, Darin.

        - <rdar://problem/5480234> JS setTimeout function requires a second argument
        - Removed check for number of arguments in setTimeout to behave like other browsers.
        - Added layoutTest setTimeout-no-arguments.html

        * bindings/js/kjs_window.cpp:
        (KJS::WindowFunc::callAsFunction):

2007-09-13   Dave Hyatt  <hyatt@apple.com>

        Some minor Windows font improvements before I make the larger changes.
        
        Reviewed by aroben, weinig

        * platform/win/FontCacheWin.cpp:
        (WebCore::FontCache::getFontDataForCharacters):
        Don't use the currently selected font in the HDC when passing priority code pages to MLANG.  Make
        sure to use ACP code pages instead so that there won't be any confusion regarding traditional vs.
        simplified chinese, etc.

        * platform/win/FontDataWin.cpp:
        (WebCore::FontData::containsCharacters):
        Rewrite containsCharacters so that it isn't glyph-dependent (since CG doesn't shape, this call is
        rejecting fonts that it shouldn't).  Re-implement this method in terms of MLang and use code page
        testing.
        
        * platform/win/UniscribeController.cpp:
        (WebCore::UniscribeController::itemizeShapeAndPlace):
        Add some comments to explain the additional item in the items array.
       
        (WebCore::UniscribeController::shape):
        Fix up the missing glyph check when doing uniscribe shaping.  Only wgDefault matters as far as doing
        font fallback.
        
2007-09-13  kuchhal  <kuchhal@yahoo.com>

        Reviewed, tweaked and landed by Anders.

        <rdar://problem/5461153> 
        http://bugs.webkit.org/show_bug.cgi?id=15143
        Crash seen on Windows
        
        Null check frame before calling Frame::settings.
        
        * loader/PluginDocument.cpp:
        (WebCore::PluginTokenizer::writeRawData):

2007-09-12  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Mark.

        Implement the FileChooser for the WebKit/Gtk+ port by using
        the GtkFileChooserDialog and g_path_get_basename to get the
        basename for the current filename.


        * WebCore.pro:
        * platform/gdk/FileChooserGdk.cpp: Added.
        (WebCore::FileChooser::FileChooser):
        (WebCore::FileChooser::~FileChooser):
        (WebCore::FileChooser::openFileChooser):
        (WebCore::FileChooser::basenameForWidth):
        * platform/gdk/TemporaryLinkStubs.cpp:

2007-09-12  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Mark.

        Move the "string" functions from the TemporaryLinkStubs.cpp
        to LocalizedStringsGdk.cpp and implement them using the text
        from the win port and glib-i18n (gettext).

        * platform/gdk/LocalizedStringsGdk.cpp: Added.
        (WebCore::submitButtonDefaultLabel):
        (WebCore::inputElementAltText):
        (WebCore::resetButtonDefaultLabel):
        (WebCore::searchableIndexIntroduction):
        (WebCore::fileButtonChooseFileLabel):
        (WebCore::fileButtonNoFileSelectedLabel):
        (WebCore::contextMenuItemTagOpenLinkInNewWindow):
        (WebCore::contextMenuItemTagDownloadLinkToDisk):
        (WebCore::contextMenuItemTagCopyLinkToClipboard):
        (WebCore::contextMenuItemTagOpenImageInNewWindow):
        (WebCore::contextMenuItemTagDownloadImageToDisk):
        (WebCore::contextMenuItemTagCopyImageToClipboard):
        (WebCore::contextMenuItemTagOpenFrameInNewWindow):
        (WebCore::contextMenuItemTagCopy):
        (WebCore::contextMenuItemTagGoBack):
        (WebCore::contextMenuItemTagGoForward):
        (WebCore::contextMenuItemTagStop):
        (WebCore::contextMenuItemTagReload):
        (WebCore::contextMenuItemTagCut):
        (WebCore::contextMenuItemTagPaste):
        (WebCore::contextMenuItemTagNoGuessesFound):
        (WebCore::contextMenuItemTagIgnoreSpelling):
        (WebCore::contextMenuItemTagLearnSpelling):
        (WebCore::contextMenuItemTagSearchWeb):
        (WebCore::contextMenuItemTagLookUpInDictionary):
        (WebCore::contextMenuItemTagOpenLink):
        (WebCore::contextMenuItemTagIgnoreGrammar):
        (WebCore::contextMenuItemTagSpellingMenu):
        (WebCore::contextMenuItemTagShowSpellingPanel):
        (WebCore::contextMenuItemTagCheckSpelling):
        (WebCore::contextMenuItemTagCheckSpellingWhileTyping):
        (WebCore::contextMenuItemTagCheckGrammarWithSpelling):
        (WebCore::contextMenuItemTagFontMenu):
        (WebCore::contextMenuItemTagBold):
        (WebCore::contextMenuItemTagItalic):
        (WebCore::contextMenuItemTagUnderline):
        (WebCore::contextMenuItemTagOutline):
        (WebCore::contextMenuItemTagWritingDirectionMenu):
        (WebCore::contextMenuItemTagDefaultDirection):
        (WebCore::contextMenuItemTagLeftToRight):
        (WebCore::contextMenuItemTagRightToLeft):
        (WebCore::contextMenuItemTagInspectElement):
        (WebCore::searchMenuNoRecentSearchesText):
        (WebCore::searchMenuRecentSearchesText):
        (WebCore::searchMenuClearRecentSearchesText):
        (WebCore::unknownFileSizeText):
        * platform/gdk/TemporaryLinkStubs.cpp:

2007-09-10  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Mark.

        EventHandlerGdk::createDraggingClipboard must succeed otherwise an
        ASSERT is hit. Add Clipboard stubs for the Gdk/Gtk+ port and
        instantiate ClipboardGdk from the EventHandlerGdk to make the ASSERT
        go away. In contrast to the Windows and Mac port this clipboard is not
        inheriting CachedResourceClient. This was proposed by Oliver.

        * WebCore.pro:
        * page/gdk/EventHandlerGdk.cpp:
        * platform/gdk/ClipboardGdk.cpp: Added.
        (WebCore::ClipboardGdk::ClipboardGdk):
        (WebCore::ClipboardGdk::~ClipboardGdk):
        (WebCore::ClipboardGdk::clearData):
        (WebCore::ClipboardGdk::clearAllData):
        (WebCore::ClipboardGdk::getData):
        (WebCore::ClipboardGdk::setData):
        (WebCore::ClipboardGdk::types):
        (WebCore::ClipboardGdk::dragLocation):
        (WebCore::ClipboardGdk::dragImage):
        (WebCore::ClipboardGdk::setDragImage):
        (WebCore::ClipboardGdk::dragImageElement):
        (WebCore::ClipboardGdk::setDragImageElement):
        (WebCore::ClipboardGdk::createDragImage):
        (WebCore::ClipboardGdk::declareAndWriteDragImage):
        (WebCore::ClipboardGdk::writeURL):
        (WebCore::ClipboardGdk::writeRange):
        (WebCore::ClipboardGdk::hasData):
        * platform/gdk/ClipboardGdk.h: Added.

2007-09-12  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam.

        Corrections missed in previous revision

        * platform/Cursor.h:
        * platform/win/CursorWin.cpp:
        (WebCore::loadCursorByName):

2007-09-12  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adam.

        Fixing 
            <rdar://problem/5018591> Windows doesn't have a standard vertical text cursor
            <rdar://problem/5224996> Add zoom in and zoom out cursors

        Added SharedCursor for CursorWin so we can correctly track lifetime of custom/image
        based cursors, such as the vertical text and zooming cursors.

        * platform/Cursor.h:
        (WebCore::SharedCursor::SharedCursor):
        (WebCore::SharedCursor::~SharedCursor):
        (WebCore::SharedCursor::nativeCursor):
        * platform/win/CursorWin.cpp:
        (WebCore::Cursor::Cursor):
        (WebCore::loadCursorByName):
        (WebCore::loadSharedCursor):
        (WebCore::pointerCursor):
        (WebCore::crossCursor):
        (WebCore::handCursor):
        (WebCore::iBeamCursor):
        (WebCore::waitCursor):
        (WebCore::helpCursor):
        (WebCore::eastResizeCursor):
        (WebCore::northResizeCursor):
        (WebCore::northEastResizeCursor):
        (WebCore::northWestResizeCursor):
        (WebCore::southResizeCursor):
        (WebCore::southEastResizeCursor):
        (WebCore::southWestResizeCursor):
        (WebCore::westResizeCursor):
        (WebCore::northSouthResizeCursor):
        (WebCore::eastWestResizeCursor):
        (WebCore::northEastSouthWestResizeCursor):
        (WebCore::northWestSouthEastResizeCursor):
        (WebCore::columnResizeCursor):
        (WebCore::rowResizeCursor):
        (WebCore::moveCursor):
        (WebCore::verticalTextCursor):
        (WebCore::progressCursor):
        (WebCore::notAllowedCursor):
        (WebCore::zoomInCursor):
        (WebCore::zoomOutCursor):
        * platform/win/WidgetWin.cpp:
        (WebCore::Widget::setCursor):

2007-09-12  Brady Eidson  <beidson@apple.com>

        Reviewed by Geoff Garen

        <rdar://problem/5478577> - Further improve cold launch time with Icon Database changes

        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::open): Store the directory and full path for later usage and access in the API, respectively
          Move the makeAllDirectories() call to the background thread.
        (WebCore::IconDatabase::IconDatabase): Don't set up the timer here...
        (WebCore::IconDatabase::scheduleOrDeferSyncTimer): Create the timer on demand
        (WebCore::IconDatabase::iconDatabaseSyncThread): makeAllDirectories() here where it's not as expensive
        (WebCore::IconDatabase::cleanupSyncThread): Cleanup the directory as well as full path

        * loader/icon/IconDatabase.h: m_syncTimer becomes an OwnPtr, and we add the database directory
          as a member to set it on the main thread and act with it on the background thread

2007-09-12  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Tristan.

        <rdar://problem/5469868> 
        GoogleDocs: A hang occurs when applying list styling to a selection in a <table>
        
        When list insertion moves selected paragraphs into list items, it relies on 
        the selection preservation code inside moveParagraphs to iterate over the 
        selected paragraphs.  If a selection is ever restored incorrectly (before
        the original, or inside the original) list insertion will go into an infinite loop.
        
        In this hang, a table was selected and the selection preservation code incorrectly
        restored a selection, placing it inside the table.
        
        The bug was that a TextIterator, when being used for selection preservation, must
        emit a character between every VisiblePosition in the Range used to create the
        iterator.
        
        * editing/TextIterator.cpp:
        (WebCore::TextIterator::TextIterator): Renamed the boolean that we use for 
        selection preservation.  It used to be m_emitForReplacedElements because
        we believed that replaced elements were the only case where TextIterators
        should have emitted differently when used for selection preservation.
        (WebCore::TextIterator::handleReplacedElement): Ditto.
        (WebCore::TextIterator::shouldRepresentNodeOffsetZero): Represent the 
        position before block tables, but only if we are emitting for selection 
        preservation.
        (WebCore::TextIterator::shouldEmitSpaceBeforeAndAfterNode): We should emit 
        a space before and after block tables if we are emitting for selection 
        preservation (because we have VisiblePositions before and after them).
        (WebCore::TextIterator::handleNonTextNode): Use a renamed variable.
        * editing/TextIterator.h: Made shouldEmitSpaceBeforeAndAfterNode a member
